//=============================//
//         Template.I          //
//  subprocedure include file  //
//=============================//

//======================================================//
// InitApplication is called - at initialization time  //
// - if and only if no other instances of this applic- //
// ation are currently running.                         //
//                                                      //
// In this example, the window class is initialized by  //
// assigning values to the WNDCLASS structure before    //
// calling RegisterClass(). Because all instances of    //
// this application use the same window class, this     //
// task is executed only when the first application     //
// instance is initialized.                             //
//======================================================//

BOOL InitApplication( HANDLE hInstance )
{
   WNDCLASS  wc;

   wc.style = NULL;
   wc.lpfnWndProc = (WNDPROC) WndProc;
   wc.cbClsExtra    = 0;
   wc.cbWndExtra    = 0;
   wc.hInstance     = hInstance;
   wc.hIcon         = LoadIcon( NULL, APP_ICON );
   wc.hCursor       = LoadCursor( NULL, IDC_ARROW );
   wc.hbrBackground = GetStockObject( WHITE_BRUSH );
   wc.lpszMenuName  = APP_MENU;
   wc.lpszClassName = szAppName;
   return( RegisterClass( &wc ) );
}

//======================================================//
// InitInstance is called - at initialization time -  //
// for every instance of the application executed and   //
// performs tasks which cannot be shared across         //
// multiple instances.                                  //
//                                                      //
// In this example, InitInstance saves the instance     //
// handle (using a static variable) before creating and //
// displaying the program's main window.                //
//======================================================//

BOOL InitInstance( HANDLE hInstance, int nCmdShow )
{
   HWND  hWnd;

   hInst = hInstance;
   hWnd = CreateWindow( szAppName, szAppTitle,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, CW_USEDEFAULT,
                        CW_USEDEFAULT, CW_USEDEFAULT,
                        NULL, NULL, hInstance, NULL   );
   if( ! hWnd ) return( FALSE );
   ShowWindow( hWnd, nCmdShow );
   UpdateWindow( hWnd );
   return( TRUE );
}

