//===================================//
//           WinHello.C             //
//  HELLO WORLD, Windows 98 Version  //
//===================================//

#include <windows.h>

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
   HDC         hdc;
   PAINTSTRUCT ps;
   RECT        rect;

   switch( msg )
   {
      case WM_PAINT:
         hdc = BeginPaint( hwnd, &ps );
         GetClientRect( hwnd, &rect );
         DrawText( hdc, "Hello, World!", -1, &rect,
                   DT_SINGLELINE | DT_CENTER | DT_VCENTER );
         EndPaint( hwnd, &ps );
         return( 0 );

      case WM_DESTROY:			// message: window being destroyed 
         PostQuitMessage(0);
         break;

      default:					// if msg unproccessed, return to Windows 
         return( DefWindowProc( hwnd, msg, wParam, lParam ) );
   }
   return TRUE;
}

int APIENTRY WinMain( HANDLE hInstance,    HANDLE hPrevInstance,
                      LPSTR  lpszCmdParam, int    nCmdShow )
{
   static char szAppName[] = "WinHello";
   HWND        hwnd;
   MSG         msg;
   WNDCLASS    wc;

   if( ! hPrevInstance )
   {
      wc.style         = CS_HREDRAW | CS_VREDRAW;
      wc.lpfnWndProc   = WndProc;
      wc.cbClsExtra    = 0;
      wc.cbWndExtra    = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon( NULL, IDI_APPLICATION );
      wc.hCursor       = LoadCursor( NULL, IDC_ARROW );
      wc.hbrBackground = GetStockObject( WHITE_BRUSH );
      wc.lpszMenuName  = NULL;
      wc.lpszClassName = szAppName;
      RegisterClass( &wc );
   }
   hwnd = CreateWindow(
      szAppName,					// window class name       
      "Hello, World - Win98 Style",	// window caption          
      WS_OVERLAPPEDWINDOW,			// window style            
      100,							// initial X position      
      100,							// initial Y position      
      300,							// initial X size          
      200,							// initial Y size          
      NULL,							// parent window handle    
      NULL,							// window menu handle      
      hInstance,					// program instance handle 
      NULL  );						// creation parameters     
   ShowWindow( hwnd, nCmdShow );
   UpdateWindow( hwnd );
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }
   return msg.wParam;
}
