// KeycodesView.cpp : implementation of the CKeycodesView class
//

#include "stdafx.h"
#include "Keycodes.h"

#include "KeycodesDoc.h"
#include "KeycodesView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView

IMPLEMENT_DYNCREATE(CKeycodesView, CView)

BEGIN_MESSAGE_MAP(CKeycodesView, CView)
	//{{AFX_MSG_MAP(CKeycodesView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView construction/destruction

CKeycodesView::CKeycodesView()
{
	// TODO: add construction code here
}

CKeycodesView::~CKeycodesView()
{
}

BOOL CKeycodesView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView drawing

void CKeycodesView::OnDraw(CDC* pDC)
{
	CKeycodesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
   CString csCapt = "Message        "
      "Code  Key  Char  Cnt  Scan  Ext ALT Prv Trs";
   CString csUnLn = "_____________  "
      "____  ___  ____  ___  ____  ___ ___ ___ ___";

   pDC->SelectObject( GetStockObject( SYSTEM_FIXED_FONT ) );
	pDC->SetBkMode( TRANSPARENT );
   pDC->TextOut( m_cxChr, 1, csCapt );
   pDC->TextOut( m_cxChr, 5, csUnLn );
   pDC->SetBkMode( OPAQUE );   // restore default
}

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView printing

BOOL CKeycodesView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CKeycodesView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CKeycodesView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView diagnostics

#ifdef _DEBUG
void CKeycodesView::AssertValid() const
{
	CView::AssertValid();
}

void CKeycodesView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CKeycodesDoc* CKeycodesView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKeycodesDoc)));
	return (CKeycodesDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKeycodesView message handlers

int CKeycodesView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
   TEXTMETRIC	tm;
	CDC*			pDC;

   pDC = GetDC();
   pDC->SelectObject( GetStockObject( SYSTEM_FIXED_FONT ) );
   pDC->GetTextMetrics( &tm );
   m_cxChr = tm.tmAveCharWidth;
   m_cyChr = tm.tmHeight + tm.tmExternalLeading;
   ReleaseDC( pDC );
   m_cRect.top = 2 * m_cyChr;
	return 0;
}

void CKeycodesView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
   m_cRect.right  = cx;
   m_cRect.bottom = cy;
	m_cyWin			= cy;
	UpdateWindow();
}

BOOL CKeycodesView::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
   switch( pMsg->message )
   {
      case WM_KEYDOWN:     ShowKey( 0, 0, "WM_KEYDOWN",
												pMsg->wParam, pMsg->lParam );	break;
      case WM_KEYUP:       ShowKey( 0, 1, "WM_KEYUP",
												pMsg->wParam, pMsg->lParam );	break;
      case WM_CHAR:        ShowKey( 1, 0, "WM_CHAR",
												pMsg->wParam, pMsg->lParam );	break;
      case WM_DEADCHAR:    ShowKey( 1, 0, "WM_DEADCHAR",
												pMsg->wParam, pMsg->lParam );	break;
      case WM_SYSKEYDOWN:  ShowKey( 0, 0, "WM_SYSKEYDOWN",  
												pMsg->wParam, pMsg->lParam );	break;
      case WM_SYSKEYUP:    ShowKey( 0, 1, "WM_SYSKEYUP",
												pMsg->wParam, pMsg->lParam );	break;
      case WM_SYSCHAR:     ShowKey( 1, 0, "WM_SYSCHAR",	   
												pMsg->wParam, pMsg->lParam );	break;
      case WM_SYSDEADCHAR: ShowKey( 1, 0, "WM_SYSDEADCHAR", 
												pMsg->wParam, pMsg->lParam );	break;
	}
	return CView::PreTranslateMessage(pMsg);
}

void CKeycodesView::ShowKey( int  iType,  BOOL EndRpt,	CString csMsg, 
										UINT wParam, LONG lParam )
{
	CString	csFormat[2] =
   {  "%-15s.%02Xh.............%3d...%02Xh"
      "...%c...%c...%c...%c",
      "%-15s......%02Xh...[%c]..%3d...%02Xh"   };

   PAINTSTRUCT	ps;
	CString		csBuff;
   CDC*			pDC;
   short			step;
   WORD			ChCnt, ChScan, ChFlags;

   if( EndRpt ) step = m_cyChr * 3 / 2;
	else			 step = m_cyChr;
   ChCnt   = LOWORD( lParam );
   ChScan  = HIWORD( lParam ) & 0x00FF;
   ChFlags = HIWORD( lParam ) & 0xFF00;
   ScrollWindow( 0, -step, &m_cRect, &m_cRect );
   pDC = BeginPaint( &ps );
   pDC->SelectObject( GetStockObject( SYSTEM_FIXED_FONT ) );
   if( ! iType )
		csBuff.Format( csFormat[iType],
							csMsg,			// message constant
							wParam,			// key code value
							ChCnt,			// repeat char count
							ChScan,			// keyboard scan code
				 (BYTE)( ChFlags & 0x0100 ? '*' : '.' ),     //Ext
				 (BYTE)( ChFlags & 0x2000 ? '*' : '.' ),     //ALT
				 (BYTE)( ChFlags & 0x4000 ? '*' : '.' ),     //Prv
				 (BYTE)( ChFlags & 0x8000 ? '*' : '.' ) );	//Trs
	else
		csBuff.Format( csFormat[iType],
							csMsg,			// message constant
							wParam,			// key code value
							wParam,			// character or space
							ChCnt,			// repeat char count
							ChScan );		// keyboard scan code
	pDC->TextOut( m_cxChr, m_cyWin - step, csBuff );
   EndPaint( &ps );
   ValidateRect( NULL );
}
