/*--------------------------------------------------------------------
        GLOBAL.H  [named pipe version]

        Header file definitions common to both halves of the
        PROCESS demo program.
  --------------------------------------------------------------------*/

// The parent process uses the following numbers as menu command ids.
// It also records some of them in a FIGURE structure which get passed
// through the pipe to the child.  The child reads these values to
// find out what it should draw.

#define IDM_TERMINATE       200     // connected children exit when
                                    // they receive this command

#define IDM_ELLIPSE         300     // other shapes to draw
#define IDM_RECTANGLE       400
#define IDM_TRIANGLE        500

#define IDM_SMALL           600     // size of shape
#define IDM_LARGE           700

#define IDM_RED             800     // color for shape
#define IDM_GREEN           900
#define IDM_BLUE            1000

// The parent and child share strings in their string table.
// The shared string names the pipe object.  This number
// identifies the shared string.

#define IDS_PIPE            10000

/* the structure used to pass information about a figure to the child */
typedef struct Figure
{
    int iShape;
    int iSize;
    int iColor;
} FIGURE, *PFIGURE;
