/*--------------------------------------------------------------------
        PARENT.H  [named pipe version]

        Header file for the parent process half of the PROCESS
        demo program.
  --------------------------------------------------------------------*/

/*--------------------------------------------------------------------
        CONSTANTS
  --------------------------------------------------------------------*/

#define MAX_BUFFER          64          // maximum string size
#define NUM_PIPE_INSTANCES  2           // number of pipe instances
                                        // to create

/*--------------------------------------------------------------------
        RESOURCE ID'S
  --------------------------------------------------------------------*/

#define DLG_ABOUT           100         // about box template
#define MENU_MAIN           200         // menu template
#define ICON_APP            100         // application icon

// A few menu command IDs are in this file.  The others are in
// the global.h header, read by both child.c and parent.c

#define IDM_START           100         // menu command IDs
#define IDM_ABOUT           1100
#define IDM_EXIT            1200

#define IDS_APPNAME         100         // string IDs
#define IDS_TITLE           200
#define IDS_PROCESS         300

/*--------------------------------------------------------------------
        FUNCTION PROTOTYPES
  --------------------------------------------------------------------*/

BOOL Init( void );
LRESULT WINAPI Parent_WndProc( HWND hWnd , UINT uMessage, WPARAM wParam,
    LPARAM lParam );
BOOL Parent_OnCreate( HWND hWnd, LPCREATESTRUCT lpcs );
void Parent_OnInitMenu( HWND hWnd, HMENU hMenu );
void Parent_OnCommand( HWND hWnd, int iCmd, HWND hWndCtl, UINT uCode );
void Parent_OnDestroy( HWND hWnd );
BOOL CreateMainWindow( void );
void ChangeShape( int iCmd );
void ChangeSize( int iCmd );
void ChangeColor( int iCmd );
void StartProcess( void );
BOOL MakePipeInstance( void );
LONG PipeInstanceThread( HANDLE hPipe );
BOOL SendCommand( HANDLE hPipe );
BOOL WINAPI About_DlgProc( HWND hDlg, UINT uMessage, WPARAM wParam,
    LPARAM lParam );
void ShowErrorMsg( void );
