// LevelCtrl.h : Declaration of the CLevelCtrl

#ifndef __LEVELCTRL_H_
#define __LEVELCTRL_H_

#include <math.h>
#include "resource.h"       // main symbols
#include "CPKnobCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CLevelCtrl
class ATL_NO_VTABLE CLevelCtrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLevelCtrl, &CLSID_LevelCtrl>,
	public CComControl<CLevelCtrl>,
	public CStockPropImpl<CLevelCtrl, ILevelCtrl, &IID_ILevelCtrl, &LIBID_KNOBCTRLLib>,
//	public IProvideClassInfo2Impl<&CLSID_LevelCtrl, NULL, &LIBID_KNOBCTRLLib>,
	public IProvideClassInfo2Impl<&CLSID_LevelCtrl, &DIID__LevelEvents, &LIBID_KNOBCTRLLib>,
	public IPersistStreamInitImpl<CLevelCtrl>,
	public IPersistStorageImpl<CLevelCtrl>,
	public IQuickActivateImpl<CLevelCtrl>,
	public IOleControlImpl<CLevelCtrl>,
	public IOleObjectImpl<CLevelCtrl>,
	public IOleInPlaceActiveObjectImpl<CLevelCtrl>,
	public IViewObjectExImpl<CLevelCtrl>,
	public IOleInPlaceObjectWindowlessImpl<CLevelCtrl>,
	public IDataObjectImpl<CLevelCtrl>,
	public ISupportErrorInfo,
	public ISpecifyPropertyPagesImpl<CLevelCtrl>,
//=== add ===
	public CProxy_LevelEvents<CLevelCtrl>,
	public IConnectionPointContainerImpl<CLevelCtrl>,
	public IObjectSafetyImpl<CLevelCtrl>
{
public:
	CLevelCtrl()
	{
		m_nLevel = 0;	// initial setting for level
		m_clrFillColor = RGB( 0, 0xFF, 0 );
	}

DECLARE_REGISTRY_RESOURCEID(IDR_LEVELCTRL)

BEGIN_COM_MAP(CLevelCtrl)
	COM_INTERFACE_ENTRY(ILevelCtrl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IObjectSafety)
END_COM_MAP()

//=== next three lines added ===
BEGIN_CONNECTION_POINT_MAP(CLevelCtrl)
	CONNECTION_POINT_ENTRY(DIID__LevelEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROPERTY_MAP(CLevelCtrl)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_ENTRY( "Level", 1, CLSID_LevelProp )
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()

BEGIN_MSG_MAP(CLevelCtrl)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
//=== add map entries ===
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonDown)
END_MSG_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

// ILevelCtrl
public:
	STDMETHOD(get_m_nLevel)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_m_nLevel)(/*[in]*/ short newVal);
	HRESULT OnDraw( ATL_DRAWINFO& di );
	LRESULT	OnLButtonDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled );
	LRESULT	OnRButtonDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled );
	void	ChangeLevel( short newLevel );

	OLE_COLOR	m_clrFillColor;
	short		m_nLevel;
	POINT		m_arrPoint[5];
	RECT		m_rectLeft, m_rectRight;
};

#endif //__LEVELCTRL_H_
