// LevelProp.h : Declaration of the CLevelProp

#ifndef __LEVELPROP_H_
#define __LEVELPROP_H_

#include "resource.h"       // main symbols
#include "KnobCtrl.h"		// definition of ILevelCtrl

EXTERN_C const CLSID CLSID_LevelProp;

/////////////////////////////////////////////////////////////////////////////
// CLevelProp
class ATL_NO_VTABLE CLevelProp :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLevelProp, &CLSID_LevelProp>,
	public IPropertyPageImpl<CLevelProp>,
	public CDialogImpl<CLevelProp>
{
public:
	CLevelProp() 
	{
		m_dwTitleID = IDS_TITLELevelProp;
		m_dwHelpFileID = IDS_HELPFILELevelProp;
		m_dwDocStringID = IDS_DOCSTRINGLevelProp;
	}

	enum {IDD = IDD_LEVELPROP};

DECLARE_REGISTRY_RESOURCEID(IDR_LEVELPROP)

BEGIN_COM_MAP(CLevelProp) 
	COM_INTERFACE_ENTRY_IMPL(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CLevelProp)
	COMMAND_HANDLER( IDC_LEVEL, EN_CHANGE, OnLevelChange )
	CHAIN_MSG_MAP(IPropertyPageImpl<CLevelProp>)
END_MSG_MAP()

	STDMETHOD(Apply)(void)
	{
		USES_CONVERSION;
		ATLTRACE(_T("CLevelProp::Apply\n"));
		for( UINT i = 0; i < m_nObjects; i++ )
		{
			// Do something interesting here
			// ICircCtl* pCirc;
			// m_ppUnk[i]->QueryInterface(IID_ICircCtl, (void**)&pCirc);
			// pCirc->put_Caption(CComBSTR("something special"));
			// pCirc->Release();
			CComQIPtr<ILevelCtrl, &IID_ILevelCtrl> pLevel(m_ppUnk[i]);
			short nLevel = (short)GetDlgItemInt(IDC_LEVEL);
			if FAILED( pLevel->put_m_nLevel( nLevel ) )
			{
				CComPtr<IErrorInfo> pError;
				CComBSTR			strError;
				GetErrorInfo( 0, &pError );
				pError->GetDescription(&strError);
				MessageBox( OLE2T(strError), _T("Error"), MB_ICONEXCLAMATION );
				return E_FAIL;
			}
		}
		m_bDirty = FALSE;
		return S_OK;
	}

	LRESULT OnLevelChange( WORD wNotify, WORD wID, HWND hWnd, BOOL &bHandled )
	{
		SetDirty(TRUE);
		return FALSE;
	}
};

#endif //__LEVELPROP_H_
