//====================================================================
//   Errors.H
//   Symbol defintions for the Errors program message table

//   first message   
//
//   Values are 32-bit values laid out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |            Code               |
//
//   where
//
//      Sev -- is the severity code
//
//           00 -- Success
//           01 -- Informational
//           10 -- Warning
//           11 -- Error
//
//      C -- is the customer code flag
//
//      R -- is a reserved bit
//
//      Facility -- is the facility code
//
//      Code -- is the facility's status code
//
//  Define the facility codes
#define  FACILITY_APP_ERRORS       0x0FFF0000
//
//  Define the severity codes
//
//  MessageId: ERRORS_ERROR_NO_NAME
//
//  MessageText:
//
//   Rats: Another crook stays nameless.
//   file: %1
//   line: %2|1d|%0
//
#define ERRORS_ERROR_NO_NAME        0xCFFF0001L

// second message
//
//  MessageId: ERRORS_SUCCESS_MASTERMIND
//
//  MessageText:
//
//   Eureka! We've found the mastermind
//   file: %1
//   line: %2|1d|%0
#define ERRORS_SUCCESS_MASTERMIND   0x0FFF0002L

