// ExceptionsView.cpp : implementation of the CExceptionsView class
//

#include "stdafx.h"
#include "Exceptions.h"

#include "ExceptionsDoc.h"
#include "ExceptionsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView

IMPLEMENT_DYNCREATE(CExceptionsView, CView)

BEGIN_MESSAGE_MAP(CExceptionsView, CView)
	//{{AFX_MSG_MAP(CExceptionsView)
	ON_COMMAND(ID_EXCEPTIONS_NESTEDHANDLERS, OnExceptionsNestedhandlers)
	ON_COMMAND(ID_EXCEPTIONS_SIMPLEHANDLER, OnExceptionsSimplehandler)
	ON_COMMAND(ID_EXCEPTIONS_FAILEDCATCH, OnExceptionsFailedcatch)
	ON_COMMAND(ID_EXCEPTIONS_RESOURCEEXCEPTION, OnExceptionsResourceexception)
	ON_COMMAND(ID_EXCEPTIONS_USEREXCEPTION, OnExceptionsUserexception)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView construction/destruction

CExceptionsView::CExceptionsView()
{
	// TODO: add construction code here
}

CExceptionsView::~CExceptionsView()
{
}

BOOL CExceptionsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView drawing

void CExceptionsView::OnDraw(CDC* pDC)
{
	CExceptionsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView printing

BOOL CExceptionsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CExceptionsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CExceptionsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView diagnostics

#ifdef _DEBUG
void CExceptionsView::AssertValid() const
{
	CView::AssertValid();
}

void CExceptionsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CExceptionsDoc* CExceptionsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CExceptionsDoc)));
	return (CExceptionsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CExceptionsView message handlers

void CExceptionsView::ForceException()
{
	int	*p = 0x00000000;	// void pointer

	*p = 999;				// invalid memory access
}

void CExceptionsView::OnExceptionsSimplehandler() 
{
	CDC		*pDC = GetDC();
	CSize	cSize = pDC->GetTextExtent( "A", 1 );	// get vertical size for text
	int		vSize = cSize.cy, 
			iLine = 0;
	CString	csText;

	Invalidate();	OnPaint();					// erase anything previous
	csText = "Starting process";
	pDC->TextOut( 10, vSize*iLine++, csText );
	try
	{
		csText = "In try block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		csText = "About to cause exception";
		pDC->TextOut( 50, vSize*iLine++, csText );

		ForceException();

        csText = "This line will not display because execution "
				 "has passed to the catch block";
        pDC->TextOut( 50, vSize*iLine++, csText );
	}
	catch(...)		// catch everything!!!
	{
		csText = "In catch all block";
		pDC->TextOut( 50, vSize*iLine++, csText );
	}
	csText = "End of process";
	pDC->TextOut( 10, vSize*iLine++, csText );
}

void CExceptionsView::OnExceptionsNestedhandlers() 
{
	CDC		*pDC = GetDC();
	CSize	cSize = pDC->GetTextExtent( "A", 1 );
	int		vSize = cSize.cy, iLine = 0, *p = 0x00000000;
	CString	csText;

	Invalidate();	OnPaint();					// erase anything previous
	csText = "Starting process";
	pDC->TextOut( 10, vSize*iLine++, csText );
	try
	{
		csText = "In outer try block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		try
		{
			csText = "In inner try block";
			pDC->TextOut( 90, vSize*iLine++, csText );
			csText = "About to cause exception ...";
			pDC->TextOut( 90, vSize*iLine++, csText );

			ForceException();

			csText = "This line will not display because execution "
					 "has passed to the catch block";
		    pDC->TextOut( 50, vSize*iLine++, csText );
		}
		catch( CMemoryException *e )		// out of memory
		{
			TCHAR    szCause[255];        

			csText = "CMemoryException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( CFileException *e )			// file exception
		{
			TCHAR    szCause[255];        

			csText = "CFileException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
 		catch( CArchiveException *e )		// Archive/Serialization exception
		{
			TCHAR    szCause[255];        

			csText = "CArchiveException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
 		catch( CNotSupportedException *e )	// response to request for
		{									// unsupported service
			TCHAR    szCause[255];        

			csText = "CNotSupportedException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
 		catch( CResourceException *e )		// resource allocation exception
		{
			TCHAR    szCause[255];        

			csText = "CResourceException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
/*					// no data base support ergo CDaoException and
					// CDBException are not recognized in this example
		catch( CDaoException *e )			// database exceptions (DAO classes)
		{
			TCHAR    szCause[255];        

			csText = "CDaoException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( CDBException *e )			// database exceptions (ODBC classes)
		{
			TCHAR    szCause[255];        

			csText = "CDBException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
*/
		catch( COleException *e )			// OLE exceptions
		{
			TCHAR    szCause[255];        

			csText = "COleException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( COleDispatchException *e )	// dispatch (automation) exceptions
		{
			TCHAR    szCause[255];        

			csText = "COleDispatchException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( CUserException *e )		// exception alerts the user with message
		{								// box, then throws a generic CException
			TCHAR    szCause[255];        

			csText = "CUserException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( CException *e )			// must follow all derived classes or
		{								// compiler will flag error
			TCHAR    szCause[255];        

			csText = "CException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch(...)						// catch everything!!!
		{
			csText = "In inner catch all block: ";
			pDC->TextOut( 90, vSize*iLine++, csText );
			csText = "Throwing exception to outer catch block: ";
			pDC->TextOut( 90, vSize*iLine++, csText );
			throw;		// will throw exception to outer catch block below
		}

        csText = "This line will not display because execution has been "
				 "thrown to the outer catch block";
        pDC->TextOut( 50, vSize*iLine++, csText );
	}
//	catch( CException *e )				// same as CExeption catch before
	catch(...)							// catch everything!!!
	{
		csText = "In outer catch all block, catching thrown exception";
		pDC->TextOut( 50, vSize*iLine++, csText );
	}
	csText = "End of process";
	pDC->TextOut( 10, vSize*iLine++, csText );
}

void CExceptionsView::OnExceptionsFailedcatch() 
{
	CDC		*pDC = GetDC();
	CSize	cSize = pDC->GetTextExtent( "A", 1 );
	int		vSize = cSize.cy, iLine = 0, *p = 0x00000000;
	CString	csText;

	Invalidate();	OnPaint();					// erase anything previous
	csText = "Starting process";
	pDC->TextOut( 10, vSize*iLine++, csText );
	try
	{
		csText = "In try block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		csText = "About to cause exception ...";
		pDC->TextOut( 90, vSize*iLine++, csText );
		MessageBox( "WARNING!\r\nThis exception may require a reboot\r\n"
					"for full recovery!" );
		*p = 999;
	}
	catch( CException *e )					// CException will not catch the
	{										// memory access error ...
		TCHAR    szCause[255];        

		csText = "In catch block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		csText = _T("CException cause: ");
	    e->GetErrorMessage( szCause, 255 );
		csText += szCause;        

	}
/*			// enabling the catch(...) block will
			// prevent the system from trapping the error
	catch(...)								// catch everything ... including
	{										// the memory access error!
		csText = "In catch all block";
		pDC->TextOut( 50, vSize*iLine++, csText );
	}
*/
	csText = "End of process";
	pDC->TextOut( 10, vSize*iLine++, csText );
}

void CExceptionsView::OnExceptionsResourceexception() 
{
	CDC		*pDC = GetDC();
	CSize	cSize = pDC->GetTextExtent( "A", 1 );
	int		vSize = cSize.cy, iLine = 0;
	CString	csText, csMsg;

	Invalidate();	OnPaint();					// erase anything previous
	csText = "Starting process";
	pDC->TextOut( 10, vSize*iLine++, csText );
	try
	{
		csText = "In outer try block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		try
		{
			csText = "In inner try block";
			pDC->TextOut( 90, vSize*iLine++, csText );
			csText = "About to cause exception ...";
			pDC->TextOut( 90, vSize*iLine++, csText );
			if( ! csText.LoadString( IDS_NON_STRING ) )
				AfxThrowResourceException();
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
 		catch( CResourceException *e )		// resource allocation exception
		{
			TCHAR    szCause[255];        

			csText = "CResourceException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch( CException *e )			// must follow all derived classes or
		{								// compiler will flag error
			TCHAR    szCause[255];        

			csText = "CException cause: ";
	        e->GetErrorMessage( szCause, 255 );
			csText += szCause;        
			pDC->TextOut( 90, vSize*iLine++, csText );
		}
		catch(...)						// catch everything!!!
		{
			csText = "In inner catch all block: ";
			pDC->TextOut( 90, vSize*iLine++, csText );
			csText = "Throwing exception to outer catch block: ";
			pDC->TextOut( 90, vSize*iLine++, csText );
			throw;		// will throw exception to outer catch block below
		}
        csText = "Still in the outer try block. This line displays because";
        pDC->TextOut( 50, vSize*iLine++, csText );
		csText = "execution was not thrown to the outer catch block";
        pDC->TextOut( 50, vSize*iLine++, csText );
	}
	catch(...)							// catch everything!!!
	{
		csText = "In outer catch all block, catching thrown exception";
		pDC->TextOut( 50, vSize*iLine++, csText );
	}
	csText = "End of process";
	pDC->TextOut( 10, vSize*iLine++, csText );
}

BOOL CExceptionsView::UserException()
{		// assume something has gone wrong
	AfxMessageBox( "Drat! The XDR Veng operation failed!" );
	AfxThrowUserException();
	return TRUE;
}

void CExceptionsView::OnExceptionsUserexception() 
{
	CDC		*pDC = GetDC();
	CSize	cSize = pDC->GetTextExtent( "A", 1 );
	int		vSize = cSize.cy, iLine = 0, *p = 0x00000000;
	CString	csText, csMsg;

	Invalidate();	OnPaint();					// erase anything previous
	csText = "Starting process";
	pDC->TextOut( 10, vSize*iLine++, csText );
    try
    {
		csText = "In try block, about to call UserException()";
		pDC->TextOut( 50, vSize*iLine++, csText );
        if( UserException() )
		{
			csText = "In try block, the XDR Veng operation succeeded (impossible)";
			pDC->TextOut( 50, vSize*iLine++, csText );
		}
		csText = "Continuing try block";
		pDC->TextOut( 50, vSize*iLine++, csText );
    }
    catch( CUserException *e )
    {
		TCHAR    szCause[255];        

		csText = "In CUserException catch block";
		pDC->TextOut( 50, vSize*iLine++, csText );
		csText = "CUserException cause: ";
        e->GetErrorMessage( szCause, 255 );
		csText += szCause;        
		pDC->TextOut( 90, vSize*iLine++, csText );
    }
    catch( CException *e )
    {
		TCHAR    szCause[255];        

		csText = "In CException catch block (unexpected)";
		pDC->TextOut( 50, vSize*iLine++, csText );
		csText = "CException cause: ";
        e->GetErrorMessage( szCause, 255 );
		csText += szCause;        
		pDC->TextOut( 90, vSize*iLine++, csText );
    }
	csText = "End of process";
	pDC->TextOut( 10, vSize*iLine++, csText );
    return;   // No exception thrown
}
