// BrowserDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Browser.h"
#include "BrowserDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define NUM_SECTIONS	6		// dialog supports 6 section buttons
#define SECTION_SIZE	1024	// each section shows 1K of buffer
#define NAME_BUFFER		80		// size of mapping object name string

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowserDlg dialog

CBrowserDlg::CBrowserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowserDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowserDlg)
	m_csEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBrowserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowserDlg)
	DDX_Text(pDX, IDD_EDIT, m_csEdit);
	DDV_MaxChars(pDX, m_csEdit, SECTION_SIZE);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrowserDlg, CDialog)
	//{{AFX_MSG_MAP(CBrowserDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDD_CLEAR, OnClear)
	ON_BN_CLICKED(IDD_READ, OnRead)
	ON_BN_CLICKED(IDD_WRITE, OnWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowserDlg message handlers

BOOL CBrowserDlg::OnInitDialog()
{
    CString csMapFile;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

		// load the string to name the file-mapping object
	if( ! csMapFile.LoadString( IDS_MAPFILE ) )	return( FALSE );

		// Create the file-mapping object.  Secondary instances
		// will receive a handle to the object the first instance
		// has already created.
    m_hMapFile = 
		CreateFileMapping( (HANDLE) 0xFFFFFFFF,			// use system swap file
					(LPSECURITY_ATTRIBUTES) NULL,		// default attributes
						   PAGE_READWRITE,				// read and write to buffer
						   0,							// high half of size
						   NUM_SECTIONS*SECTION_SIZE,	// low half of size
						   csMapFile );					// name of new object
    if( m_hMapFile == NULL )						// any error?
    {
        ShowErrorMsg( __LINE__ );
        return( FALSE );							// yes; give up
    }
		// map a view of the file
    m_pView = (char*)MapViewOfFile( m_hMapFile,	// handle to file-mapping object
						FILE_MAP_ALL_ACCESS,	// access privileges
						0, 0,					// start at beginning of file
						0 );					// size of view area (all of file)
    if( ! m_pView )								// any error?
    {
        CloseHandle( m_hMapFile );				// yes; free handle
        ShowErrorMsg( __LINE__ );
        return( FALSE );
    }
    CheckRadioButton( IDD_SECTION1, IDD_SECTION6, IDD_SECTION1 );
    CheckRadioButton( IDD_READ_ACCESS, IDD_WRITECOPY_ACCESS, IDD_READWRITE_ACCESS );
	m_nSection = 0;	// start with first (0) section
    OnRead();		// initialize edit control with contents of starting section
	return TRUE;	// return TRUE  unless you set the focus to a control
}

void CBrowserDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if( ( nID & 0xFFF0 ) == IDM_ABOUTBOX )
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBrowserDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBrowserDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CBrowserDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch( wParam )
	{
        case IDD_SECTION1:		case IDD_SECTION2:
        case IDD_SECTION3:		case IDD_SECTION4:
        case IDD_SECTION5:		case IDD_SECTION6:	
			m_nSection = wParam - IDD_SECTION1;  // save current choice
			OnClear();	// clear edit box
			OnRead();	// show new file section
			break;

        case IDD_READ_ACCESS:
        case IDD_READWRITE_ACCESS:
        case IDD_WRITECOPY_ACCESS:
			OnChangeAccess( wParam );	
			break;

        case IDCANCEL:
        case IDD_QUIT:		
			EndDialog( TRUE );		
			break;
	}
	return CDialog::OnCommand( wParam, lParam );
}

void CBrowserDlg::OnClear() 
{
	m_csEdit.Empty();		// empty the edit buffer
	UpdateData( FALSE );	// refresh the edit box
}

void CBrowserDlg::OnRead() 
{
	char chBuff[SECTION_SIZE];

		// retrieve the text from memory and display it
	strncpy( chBuff, &m_pView[m_nSection*SECTION_SIZE], SECTION_SIZE );
	m_csEdit = chBuff;
	UpdateData( FALSE );
}

void CBrowserDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
    __try
    {		// copy the text from the edit buffer to the mapped file
		strcpy( &m_pView[m_nSection*SECTION_SIZE], (LPCTSTR)m_csEdit );
    }
    __except( ( GetExceptionCode() == EXCEPTION_ACCESS_VIOLATION )
		   ? EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH )
    {		// assume the exception was due to read only access
        MessageBox( "Memory is read only.\n\rNo data was written.",
					"Browser Message", MB_OK | MB_ICONEXCLAMATION );
    }                               
}

void CBrowserDlg::OnChangeAccess( int iNewAccess )
{
    DWORD fdwAccess;                        // new access flag

		// close the previous mapping
    UnmapViewOfFile( m_pView );
		// choose new access flag
    switch( iNewAccess )
    {
        case IDD_READWRITE_ACCESS:	fdwAccess = FILE_MAP_ALL_ACCESS;	break;
        case IDD_READ_ACCESS:		fdwAccess = FILE_MAP_READ;			break;
		case IDD_WRITECOPY_ACCESS:
        default:					fdwAccess = FILE_MAP_COPY;			break;
    }
		// re-map the view using the requested access and view number 
    m_pView = (char*)MapViewOfFile( m_hMapFile,		// handle to mapping object
									fdwAccess,		// access privileges
									0, 0,			// starting offset in file
									0 );			// size of view area (all of file)
    if( m_pView == NULL )					// error?
        ShowErrorMsg( __LINE__ );			// yes; tell user
    return;
}

void CBrowserDlg::ShowErrorMsg( int iLine )
{
    LPVOID	lpvMessage;                      // temporary message buffer
	CString csMsg;

		// retrieve a message from the system message table 
    FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				   NULL,                               // ignored
				   GetLastError(),                     // message id
				   MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),   // message language
				   (LPTSTR)&lpvMessage,                // address of buffer pointer
				   0,                                  // minimum buffer size
				   NULL );                             // no other arguments
		// add the line information
	csMsg.Format( "%s (line %u)", (LPSTR)lpvMessage, iLine );
		// display the message in a message box 
    MessageBox( csMsg, "List Message", MB_ICONEXCLAMATION | MB_OK );
		// release the buffers allocated by FormatMessage and by us
    LocalFree( lpvMessage );
    return;
}
