//=====================================================================
//	LIST.H
//		Header file for the virtual memory List program.

//=====================================================================
//	CONSTANTS

#define MAX_ITEMS       500         // max number of entries in the list
#define ITEM_SIZE       1024        // max chars for one node's text
#define MAX_BUFFER      64

//=====================================================================
//	RESOURCE IDs

#define MENU_MAIN           10      // menu template

#define DLG_ABOUT           10      // dialog templates
#define DLG_TEXTENTRY       20

#define IDD_EDIT            100     // edit control

#define IDM_ADD             100     // menu commands
#define IDM_DELETE          200
#define IDM_ABOUT           300
#define IDM_EXIT            400

#define IDS_APPNAME         100     // strings
#define IDS_TITLE           200

#define ICON_APP            10      // application icon

//=====================================================================
//	FUNCTION PROTOTYPES

LRESULT WINAPI List_WndProc( HWND hWnd , UINT uMessage, WPARAM wParam, LPARAM lParam );
BOOL Init( void );
BOOL CreateWindows( void );
void List_OnInitMenu( HWND hWnd, HMENU hMenu );
void List_OnSize( HWND hWnd, UINT uState, int cxClient, int cyClient );
void List_OnSetFocus( HWND hWnd, HWND hwndOldFocus );
void List_OnCommand( HWND hWnd, int iCmd, HWND hwndCtl, UINT uCode );
void List_OnDestroy( HWND hWnd );
BOOL CreateList( void );
void AddItem( void );
LONG CommitMemFilter( DWORD dwExceptCode, int iIndex );
void DeleteItem( void );
void DeleteList( void );
int GetItemText( char *pszText );
int GetPageBaseEntry( int iPlace );
void AdjustLookupTable( int iStart );
BOOL WINAPI Text_DlgProc( HWND hDlg, UINT uMessage, WPARAM wParam, LPARAM lParam );
void Text_DoCommand( HWND hDlg, int iCmd );
BOOL WINAPI About_DlgProc( HWND hDlg, UINT uMessage, WPARAM wParam, LPARAM lParam );
void ShowErrorMsg( int iLine );
