/*--------------------------------------------------------------------

	MATHLIB.CPP
   
	This file contains the simple functions which get called using the
   remote procedure calling (RPC) mechanism. The RPCSERV example RPC
   server calls these functions in response to corresponding RPC calls
   made via the RPCLIENT client application.
   
     FUNCTIONS USED:

   Add                  Simple addition function
   Subtract             Simple subtraction function.
   Multiply             Simple multiplication function.
   Divide               Simple division function.
   SendClientName       Demo's passing a string to the server app.
   GetMathServerName    Demo's retrieving a string from the server app.
   
   NOTES: 
   - These functions can be called in a "normal" (non-RPC) program by
     including a non-RPC header file. (Recommended for testing prior 
     to implementing with RPC.)
     
	written by Jim Blaney, 1996
	from Mastering Windows NT Programming

  -------------------------------------------------------------------*/
#include <iostream.h>
#include <rpc.h>
#include "mathlib.h" 


void SendClientName( char *pszClientName )
{
   cout << endl << "Client: " << pszClientName << endl;
   cout << flush;
}
  

char *GetMathServerName( void  )
{
   static char szServerName[64];

   strcpy( szServerName, "Name of Server" );

   return szServerName;
}

long Add(long lNum1, long lNum2)
{
   cout << "Call to Add(" << lNum1 << ", " << lNum2 << ")\n";
   cout << flush;

   return( lNum1 + lNum2 );
}

long Subtract(long lNum1, long lNum2)
{
   cout << "Call to Subtract(" << lNum1 << ", " << lNum2 << ")\n";
   cout << flush;
   
   return( lNum1 - lNum2 );
}
  
long Multiply(long lNum1, long lNum2)
{
   cout << "Call to Multiply(" << lNum1 << ", " << lNum2 << ")\n";
   cout << flush;
   
   return( lNum1 * lNum2 );
}

long Divide(long lNum1, long lNum2)
{
   cout << "Call to Divide(" << lNum1 << ", " << lNum2 << ")\n";
   cout << flush;
   
   return( lNum1 / lNum2 );
}






