/*--------------------------------------------------------------------

	RPCLIENT.CPP

	Demonstrates using RPC in a client application to make calls to 
   "mathlib" functions which execute on an attached server.
   
     FUNCTIONS USED:

   Add                  Simple math functions which get called via RPC.
   Subtract              "      "     "        "     "     "    "   "
   Multiply              "      "     "        "     "     "    "   "
   Divide                "      "     "        "     "     "    "   "
   SendClientName       Demo's passing a string to server app.
   GetMathServerName    Demo's retrieving a string from server app.
   
   RpcTryExcept         Does RPC version of "try" (exception handling).
   RpcExcept            Does RPC version of "except" (exception handling). 
   RpcEndExcept         Does RPC version of "finally" (exception handling).
   

   NOTES: 
   - This program works Windows NT only, not Windows 95.
   
		written/updated by Jim Blaney, 1998
		for Windows 98 Developers Handbook

  -------------------------------------------------------------------*/
#include <iostream.h>
#include <rpc.h>
#include "..\rpcmathlib\mathlib.h"


void __RPC_FAR *__RPC_API midl_user_allocate( size_t len )
{
   return( malloc(len) );
}

void __RPC_API midl_user_free( void __RPC_FAR *ptr )
{
   free( ptr );
}
 

void _CRTAPI1 main(void)
{
   int a = 100;
   int b =  25;

   RpcTryExcept

      SendClientName( "Client's name" );
      cout << "Connected to Math Server " << GetMathServerName() << ".\n";

      cout << a << " plus       " << b << " = " << Add        (a, b) << endl;
      cout << a << " minus      " << b << " = " << Subtract   (a, b) << "\n";
      cout << a << " times      " << b << " = " << Multiply   (a, b) << "\n";
      cout << a << " divided by " << b << " = " << Divide     (a, b) << "\n";

   RpcExcept(1)
      
      cout << "RPC Runtime error occurred.\n";

   RpcEndExcept
}

