//======================//
//       Color1.C       //
//  C++ Windows Colors  //
//======================//

#include <windows.h>
#include <stdlib.h>

#define APP_ICON  "Color1"
#define APP_MENU  "Color1"
// note: no cursor assignment
#define  XSTEPS    5
#define  YSTEPS    4

HANDLE hInst;
char   szAppTitle[] = "Standard Palette Colors";
char   szAppName[]  = "Color1";

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	HBRUSH       hBrush, hOldBrush;
	HPEN         hPen, hOldPen;
	HDC          hdc;
	char		 szColor[24];
	PAINTSTRUCT  ps;
	static int   i, j, xSize, ySize;
	COLORREF	 crColor, crRGB;

	switch( msg )
	{
		case WM_SIZE:
			xSize = ( LOWORD( lParam ) ) / XSTEPS;
			ySize = ( HIWORD( lParam ) ) / YSTEPS;
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			hdc = BeginPaint( hwnd, &ps );
			for( j=0; j<YSTEPS; j++ )
				for( i=0; i<XSTEPS; i++ )
				{
					crColor = PALETTEINDEX( i + ( j * XSTEPS ) );
					hPen = CreatePen( PS_SOLID, 1, crColor );
					hOldPen = SelectObject( hdc, hPen );
					hBrush = CreateSolidBrush( crColor );
					hOldBrush = SelectObject( hdc, hBrush );
					Rectangle( hdc, i * xSize + 2, j * ySize + 2,
							   ( i + 1 ) * xSize - 2,
							   ( j + 1 ) * ySize - 2 );
					SelectObject( hdc, hOldPen );	// restore original pen
					SelectObject( hdc, hOldBrush );	// and brush then delete
					DeleteObject( hPen );			// discards so we don't
					DeleteObject( hBrush );			// run out of handles
						// report palette entries as RGB values
					crRGB = GetNearestColor( hdc, crColor );
					wsprintf( szColor, " RGB: %02X %02X %02X ",  
							  GetRValue( crRGB ), GetGValue( crRGB ),
							  GetBValue( crRGB ) );
					TextOut( hdc, i * xSize + 20, j * ySize + 20, 
							 szColor, strlen(szColor) );
				}
			EndPaint( hwnd, &ps );
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

#ifdef __BORLANDC__
#pragma argsused
#endif

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG   msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
#ifndef __BORLANDC__
	UNREFERENCED_PARAMETER( lpCmdLine );
#endif
}
