//==================//
//     Color2.C     //
//  Windows Colors  //
//==================//

#include <windows.h>
#include <stdlib.h>

#define  CHILD_STYLE    WS_CHILD | WS_VISIBLE
#define  MIN( i )       min( 255, i + 1 )
#define  MAX( i )       max(   0, i - 1 )

HWND     hwndScrl[3], hwndTag[3], hwndVal[3], hwndRect;
int      nFocus, CVal[3] = { 100, 175, 250 };
char     szBuff[10];

long FAR PASCAL WndProc( HWND hwnd, UINT msg, UINT wParam, LONG lParam )
{
	HDC         hdc;
	int         i, cxWnd, cyWnd, cyChr, cxChr, OrgY;
	TEXTMETRIC  tm;

	switch( msg )
	{
		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			hdc = GetDC( hwnd );
			GetTextMetrics( hdc, &tm );
			cyChr = tm.tmHeight;
			cxChr = tm.tmAveCharWidth;
			ReleaseDC( hwnd, hdc );
			MoveWindow( hwndRect,        // window handle
						0,               // x origin
						cyWnd-5*cyChr,   // y origin
						cxWnd,           // x size
						cyWnd,           // y size
						TRUE );          // repaint flag
			for( i=0; i<=2; i++ )
			{
				OrgY = cyWnd - (INT)( (i+1) * 1.5 * cyChr );
				MoveWindow( hwndScrl[i], 7*cxChr, OrgY,
							cxWnd-(14*cxChr), cyChr, TRUE );
				MoveWindow( hwndTag[i], cxChr, OrgY,
							6*cxChr, cyChr, TRUE );
				MoveWindow( hwndVal[i], cxWnd-7*cxChr, OrgY,
							6*cxChr, cyChr, TRUE );
			}
			SetFocus( hwnd );
			break;

		case WM_HSCROLL:
			i = GetWindowLong( (HWND) lParam, GWL_ID );
			switch( LOWORD( wParam ) )
			{
				case SB_TOP:		CVal[i]  =   0;				break;
				case SB_PAGEDOWN:	CVal[i] +=  15;				// no break!
				case SB_LINEDOWN:	CVal[i]  = MIN( CVal[i] );	break;
				case SB_PAGEUP:		CVal[i] -=  15;				// no break!
				case SB_LINEUP:		CVal[i]  = MAX( CVal[i] );	break;
				case SB_BOTTOM:		CVal[i]  = 255;             break;
				case SB_THUMBPOSITION:
				case SB_THUMBTRACK:	CVal[i] = HIWORD( wParam );	break;
				default:										break;
			}
			SetScrollPos( hwndScrl[i], SB_CTL, CVal[i], TRUE );
			SetWindowText( hwndVal[i], itoa( CVal[i], szBuff, 10 ) );
			DeleteObject( (HGDIOBJ) GetClassLong( hwnd, GCL_HBRBACKGROUND ) );
			SetClassLong( hwnd, GCL_HBRBACKGROUND, (LONG)
						  CreateSolidBrush( RGB( CVal[0], CVal[1], CVal[2] ) ) );
			InvalidateRect( hwnd, 0L, TRUE );
			break;

		case WM_DESTROY:
			DeleteObject( (HGDIOBJ) GetClassLong( hwnd, GCL_HBRBACKGROUND ) );
			PostQuitMessage(0);
			break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

int PASCAL WinMain( HANDLE hInst, HANDLE hPrevInst,
                    LPSTR  lpCmd, int    nCmdShow )
{
	static char szAppName[] = "COLOR2";
	static char *szColorLabel[] = { "Red", "Green", "Blue" };
	HWND		hwnd;
	MSG			msg;
	int			i;
	WNDCLASS	wc;

	if( ! hPrevInst )
	{
		wc.hInstance     = hInst;
		wc.lpfnWndProc   = WndProc;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		wc.lpszClassName = szAppName;
		wc.hIcon         = LoadIcon( hInst, szAppName );
		wc.lpszMenuName  = (LPSTR) szAppName;
		wc.hCursor       = LoadCursor( 0L, IDC_ARROW );
		wc.hbrBackground =
			CreateSolidBrush( RGB( CVal[0], CVal[1], CVal[2] ) );
		wc.style         = CS_HREDRAW | CS_VREDRAW;
		RegisterClass( &wc );
	}
	hwnd = CreateWindow( szAppName, "Dithered Colors",
						 WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
						 CW_USEDEFAULT, CW_USEDEFAULT,
						 500, 200, 0L, 0L, hInst, 0L  );
	hwndRect = CreateWindow( "static", 0L, CHILD_STYLE | SS_WHITERECT,
							 0, 0, 0, 0, hwnd, (HMENU) 10, hInst, 0L );
	for( i=0; i<=2; i++ )
	{
		hwndScrl[i] = CreateWindow( "scrollbar", 0L,
									CHILD_STYLE | WS_TABSTOP | SBS_HORZ,
									0, 0, 0, 0, hwnd, (HMENU) i, hInst, 0L );
		hwndTag[i]  = CreateWindow( "static", szColorLabel[i], 
									CHILD_STYLE | SS_CENTER,
									0, 0, 0, 0, hwnd, (HMENU)(i+4), hInst, 0L );
		hwndVal[i]  = CreateWindow( "static", itoa( CVal[i], szBuff, 10 ),
									CHILD_STYLE | SS_CENTER,
									0, 0, 0, 0, hwnd, (HMENU)(i+7), hInst, 0L );
		SetScrollRange( hwndScrl[i], SB_CTL, 0, 255, 0 );
		SetScrollPos( hwndScrl[i], SB_CTL, CVal[i], 0 );
	}
	ShowWindow(   hwnd, nCmdShow );
	UpdateWindow( hwnd );
	while( GetMessage( &msg, 0L, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage(  &msg );
	}
	return( msg.wParam );
}