//=======================//
//       PenDraw3.C      //
//  C++ Windows Drawing  //
//=======================//

#include <windows.h>
#include <math.h>
#include "pendraw3.h"

#define PI2 ( 2.0 * 3.1415 )  // radians in 360 degrees //
#define APP_ICON  "PenDraw3"
#define APP_MENU  "PenDraw3"
// note: no cursor assignment

HANDLE hInst;
char   szAppTitle[] = "Pen Draw 3: Filled Polygons";
char   szAppName[]  = "PenDraw3";
static POINT pt[2][7];


long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	static  int  cxWnd, cyWnd, nFillMode = IDM_ALTERNATE;
	HDC          hdc;
	HPEN         hPen;
	HMENU        hMenu;
	PAINTSTRUCT  ps;
	int          i, j;

	switch( msg )
	{
		case WM_CREATE:
			for( i=j=0; i<5; i++, j=(j+2)%5 )  // 5 points //
			{
				pt[0][i].x = (int)( sin( j*PI2/5 ) * 100 ) - 110;
				pt[0][i].y = (int)( cos( j*PI2/5 ) * 100 );
			}
			for( i=j=0; i<7; i++, j=(j+3)%7 )  // 7 points //
			{
				pt[1][i].x = (int)( sin( j*PI2/7 ) * 100 ) + 110;
				pt[1][i].y = (int)( cos( j*PI2/7 ) * 100 );
			}
			break;

		case WM_COMMAND:
			hMenu = GetMenu( hwnd );
			switch( LOWORD(wParam) )
			{
				case IDM_ALTERNATE:
				case IDM_WINDING:
					CheckMenuItem( hMenu, nFillMode, MF_UNCHECKED );
					nFillMode = wParam;
					CheckMenuItem( hMenu, nFillMode, MF_CHECKED );
					break;

				default: return( DefWindowProc( hwnd, msg, wParam, lParam ) );
			}
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_SIZE:
			cxWnd = LOWORD( lParam );
			cyWnd = HIWORD( lParam );
			InvalidateRect( hwnd, NULL, TRUE );
			break;

		case WM_PAINT:
			hdc = BeginPaint( hwnd, &ps );
			hPen = CreatePen( PS_SOLID, 3, 0L );
			SelectObject( hdc, hPen );
			SelectObject( hdc, GetStockObject( LTGRAY_BRUSH ) );
			SetMapMode( hdc, MM_ISOTROPIC );
			SetWindowExtEx(   hdc,   440,  -220, NULL );
			SetViewportExtEx( hdc, cxWnd, cyWnd, NULL );
			SetWindowOrgEx(   hdc,  -220,   110, NULL );
			SetPolyFillMode( hdc, nFillMode );
			Polygon( hdc, pt[0], 5 );
			Polygon( hdc, pt[1], 7 );
			EndPaint( hwnd, &ps );
			break;

		case WM_DESTROY:   PostQuitMessage(0);   break;

		default:
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return 0;
}

#include "template.i"

int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                      LPSTR  lpCmdLine, int    nCmdShow    )
{
	MSG   msg;

	if( ! hPrevInstance )
		if( ! InitApplication( hInstance ) )
			return( FALSE );
	if( ! InitInstance( hInstance, nCmdShow ) )
		return (FALSE);
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return( msg.wParam );
	UNREFERENCED_PARAMETER( lpCmdLine );
}
