/*--------------------------------------------------------------------

        SHOWWAVE.H

        Declarations for the ShowWave sound program.

  --------------------------------------------------------------------*/

/*--------------------------------------------------------------------
        PROGRAM CONSTANTS
  --------------------------------------------------------------------*/

/* Values for PCM waveform data */
/* NOTE: dependent on the Bits Per Sample (in this demo: 8) */
#define MAXVALUE        255     // max value for one 8-bit sample 
#define MIDVALUE        128
#define MINVALUE        0       // min value for one 8-bit sample 

#define RGB_WHITE       RGB( 0xFF, 0xFF, 0xFF )
#define RGB_GREEN       RGB( 0x00, 0xFF, 0x00 )

/*--------------------------------------------------------------------
        GLOBAL VARIABLES
  --------------------------------------------------------------------*/

extern LPSTR lpWaveData;            // data from current .WAV file 
extern DWORD dwWaveDataSize;        // size of .WAV file data 
extern DWORD dwCurrentSample;       // position in current sound 
extern DWORD dwSamplesPerSec;       // sampling rate for current sound 

/*--------------------------------------------------------------------
        MACROS
  --------------------------------------------------------------------*/

/* message cracker for MCINOTIFY message */

/* void Cls_OnMCINotify(HWND hwnd, UINT uCode, UINT uDevID); */
#define HANDLE_MM_MCINOTIFY(hwnd, wParam, lParam, fn) \
        ((fn)((hwnd), (UINT)(wParam), LOWORD(lParam)), 0L)

/*--------------------------------------------------------------------
        FUNCTION PROTOTYPES
  --------------------------------------------------------------------*/

/* SHOWWAVE.C */
LRESULT WINAPI ShowWave_WndProc( HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam );
BOOL QuerySave( HWND hDlg );

/* GRAPHWIN.C */
BOOL RegisterGraphClass( HINSTANCE hInstance );

/* MMIO.C */
BOOL ReadWaveData( HWND hWnd, LPSTR lpszFileName, LPSTR *lplpWaveData,
    DWORD *lpdwWaveDataSize, DWORD *lpdwSamplesPerSec );
BOOL WriteWaveData( HWND hWnd, LPSTR lpszFileName, LPSTR lpWaveData,
    DWORD dwWaveDataSize, DWORD dwSamplesPerSec );

/* MCI.C */
BOOL OpenDevice( HWND hWnd, LPSTR lpszFileName, MCIDEVICEID *lpuDeviceID );
VOID CloseDevice( HWND hWnd, MCIDEVICEID mciDevice );
BOOL SetTimeFormat( HWND hWnd, MCIDEVICEID mciDevice );
BOOL BeginPlay( HWND hWnd, MCIDEVICEID mciDevice, DWORD dwFrom );
VOID StopPlay( HWND hWnd, MCIDEVICEID mciDevice );
BOOL BeginRecord( HWND hWnd, MCIDEVICEID mciDevice, DWORD dwTo );
BOOL SaveRecord( HWND hWnd, MCIDEVICEID mciDevice, LPSTR lpszFileName );

/* WINMAIN.C */
BOOL WINAPI About_DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam );
