; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   FTOI.ASM:  Convert Floating Point to Long Integer
        page    55,132

; Call with:    ftoi (float* a, int str_a, long* b, int str_b, int n)
;
; Returns:      b [i * str_b] = (long) a [i * str_a] for i = 0 to n-1
;
; Destroys:     nothing

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
B_STR     equ     bp+8
B_OFF     equ     bp+10
B_SEG     equ     bp+12
A_STR     equ     bp+14
A_OFF     equ     bp+16
A_SEG     equ     bp+18

          PUBLIC  _ftoi__FPfiPlii

_ftoi__FPfiPlii PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp,sp                   ; Set stack framepointer

          push    si                      ; Save registers
          push    di
          push    es
          push    ds

          push    dx
          push    cx
          push    bx
          push    ax

          mov     cx, [N_ELM]             ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     si, [A_OFF]             ; Get address of A array
          mov     ds, [A_SEG]

          mov     di, [B_OFF]             ; Get address of B array
          mov     es, [B_SEG]

          mov     ax, 4                   ; Compute stride of destination
          mul     word ptr [B_STR]
          mov     bx, ax

          mov     ax, 4                   ; Compute stride of source
          mul     word ptr [A_STR]             

loop1:    fld     dword ptr ds:[si]       ; Load operands
          fistp   dword ptr es:[di]       ; Save result

inca:     add     si, ax                  ; Increment pointers
          add     di, bx

          loop    loop1                   ; Repeat until cx is 0

          fwait                           ; Wait for processor to catch up

          xor     ax, ax                  ; Return code is 0

exit:     pop     ax                      ; Restore registers
          pop     bx
          pop     cx
          pop     dx

          pop     ds
          pop     es
          pop     di
          pop     si

          pop     bp

          RET     14                      ; Return

error:    mov     ax, 1                   ; Load error code
          jmp     exit

_ftoi__FPfiPlii ENDP
          END

