; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   VABS.ASM:  Take Absolute Value of Elements of Vector
        page    55,132

; Call with:    vabs (float* a, int str_a, float* b, int str_b, int n)
;
; Returns:      b [i * str_b] = abs (a [i * str_a]) for i = 0 to n-1
;
; Destroys:     nothing

.286
.287

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
B_STR     equ     bp+8
B_OFF     equ     bp+10
B_SEG     equ     bp+12
A_STR     equ     bp+14
A_OFF     equ     bp+16
A_SEG     equ     bp+18

          PUBLIC  _vabs__FPfiPfii

_vabs__FPfiPfii PROC
          push    bp                      ; Save old stack pointer
          mov     bp, sp

          push    si                      ; Save registers
          push    di
          push    es
          push    ds

          push    dx
          push    cx
          push    bx

          mov     cx, [N_ELM]             ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     si, [A_OFF]             ; Get address of A array
          mov     ds, [A_SEG]

          mov     di, [B_OFF]             ; Get address of B array
          mov     es, [B_SEG]

          mov     ax, word ptr [B_STR]    ; Compute stride of destination
          dec     ax
          shl     ax, 2
          mov     dx, ax

          mov     ax, word ptr [A_STR]    ; Compute stride of source
          dec     ax
          shl     ax, 2
          mov     bx, ax

          cld                             ; Initialize direction flag

loop1:    movsw                           ; Move first word

          lodsw                           ; Get second word
          and     ax, 7fffh               ; Mask off sign bit
          stosw                           ; Store second word

          add     si, bx                  ; Increment pointers
          add     di, dx

          loop    loop1                   ; Repeat until cx is 0

          xor     ax, ax                  ; Return code is 0

exit:     pop     bx                      ; Restore registers
          pop     cx
          pop     dx

          pop     ds
          pop     es
          pop     di
          pop     si

          mov     sp, bp                  ; Release memory for local variable
          pop     bp

          RET     14                      ; Return

error:    mov     ax, 1
          jmp     exit

_vabs__FPfiPfii ENDP
          END

