; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   VESUM.ASM:  Find Sum of Elements of Vector
        page    55,132

; Call with:    vesum (float* a, int str_a, float* b, int n)
;
; Returns:      b = Sum (a [i * str_a]) for i = 0 to n-1
;
; Destroys:     nothing

.286
.287

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
B_OFF     equ     bp+8
B_SEG     equ     bp+10
A_STR     equ     bp+12
A_OFF     equ     bp+14
A_SEG     equ     bp+16

          PUBLIC  _vesum__FPfiPfi

_vesum__FPfiPfi PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp,sp                   ; Set stack framepointer

          push    si                      ; Save registers
          push    ds

          push    dx
          push    cx
          push    bx

          mov     cx, [N_ELM]             ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     si, [A_OFF]         ; Get address of A array
          mov     ds, [A_SEG]

          mov     ax, 4                   ; Compute stride
          mul     word ptr [A_STR]

          fldz

loop1:    fadd    dword ptr ds:[si]       ; Add element

          add     si, ax                  ; Increment pointer

          loop    loop1                   ; Repeat until cx is 0

          fwait                           ; Wait for processor to catch up

          mov     si, [B_OFF]         ; Save Result
          mov     ds, [B_SEG]
          fstp    dword ptr ds:[si]

          xor     ax, ax                  ; Return code is 0

exit:     pop     bx                      ; Restore registers
          pop     cx
          pop     dx

          pop     ds
          pop     si

          pop     bp

          RET     12                      ; Return

error:    mov     ax, 1
          jmp     exit

_vesum__FPfiPfi ENDP
          END

