; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   VZERO.ASM:  Zero A Vector
        page    55,132

; Call with:    vzero (float* a, int str_a, int n)
;
; Returns:      a [i*str_a] = 0 for i = 0 to n-1
;
; Destroys:     nothing

.286
.287

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
A_STR     equ     bp+8
A_OFF     equ     bp+10
A_SEG     equ     bp+12

          PUBLIC  _vzero__FPfii

_vzero__FPfii PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp,sp                   ; Set stack framepointer

          push    di                      ; Save registers
          push    es

          push    cx
          push    bx

          mov     cx, [N_ELM];            ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     di, [A_OFF]             ; Get address of A array
          mov     es, [A_SEG]

          mov     ax, [A_STR]             ; Compute stride A array
          dec     ax
          shl     ax, 2
          mov     bx, ax

          xor     ax, ax                  ; Zero accumulator

loop1:    stosw                           ; Zero first pair of bytes
          stosw                           ; Zero second pair of bytes

          add     di, bx                  ; Increment pointers

          loop    loop1                   ; Repeat until cx is 0

exit:     pop     bx                      ; Restore registers
          pop     cx

          pop     es
          pop     di

          pop     bp

          RET     8                       ; Return

error:    mov     ax, 1
          jmp     exit

_vzero__FPfii ENDP
          END
