@CSOURCE8 = /* DDSHELL.c<R>
<R>
   Drop and Drag Shell for Windows applications that do not implement 
the<R>
   drop and drag paradigm.<R>
<R>
   History:<R>
   NSDavids 92-07-01<R>
      Code started<R>
<R>
*/<R>
<R>
#define STRICT        /* define STRICT to provide maximum type safety<R>
                         as defined by Microsoft */<R>
<R>
#include <<windows.h>><R>
#include <<string.h>><R>
#include <<dir.h>><R>
#include <<shellapi.h>><R>
<R>
#define WS_WINDOWSTYLE (WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | 
WS_THICKFRAME)<R>
#define IDM_ABOUT 1<R>
<R>
char        szAppName [] = "Drop_and_Drag";<R>
<R>
LPSTR       lpDDInstance;<R>
char        szCommand [MAXPATH + 2];<R>
char        szTitle [80];<R>
int         initialXPos;<R>
int         initialYPos;<R>
<R>
long CALLBACK _export WndProc(HWND, UINT, UINT, LONG);<R>
<R>
#pragma argsused<R>
/**************************************************************/<R>
int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,<R>
                    LPSTR lpCmdLine,     int nCmdShow)<R>
{<R>
MSG                msg;<R>
WNDCLASS           wc;<R>
HWND               hWnd;<R>
HMENU              hMenu;<R>
<R>
lpDDInstance = lpCmdLine;<R>
<R>
if (!hPrevInstance)<R>
   {<R>
   wc.style             = CS_HREDRAW | CS_VREDRAW ;<R>
   wc.lpfnWndProc       = WndProc;                                  <R>
   wc.cbClsExtra        = 0;<R>
   wc.cbWndExtra        = 0;  <R>
   wc.hInstance         = hInstance;<R>
   wc.hIcon             = LoadIcon (hInstance, szAppName);<R>
   wc.hCursor           = LoadCursor (NULL, IDC_ARROW);<R>
   wc.hbrBackground     = GetStockObject (WHITE_BRUSH);<R>
   wc.lpszMenuName      = NULL;<R>
   wc.lpszClassName     = szAppName;<R>
   <R>
   RegisterClass(&wc);

@CSOURCE8 =    }<R>
<R>
hWnd = CreateWindow(szAppName, NULL, WS_WINDOWSTYLE, CW_USEDEFAULT,<R>
                CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,<R>
                NULL, NULL, hInstance, NULL);<R>
<R>
if (!hWnd)<R>
   return (FALSE);<R>
<R>
hMenu = GetSystemMenu (hWnd, FALSE);<R>
AppendMenu (hMenu, MF_SEPARATOR, 0,         NULL);<R>
AppendMenu (hMenu, MF_STRING,    IDM_ABOUT, "About...");<R>
   <R>
ShowWindow(hWnd, SW_SHOWMINIMIZED);<R>
if ((initialXPos != 0) || (initialYPos != 0))<R>
                  MoveWindow (hWnd, initialXPos, initialYPos, 0, 0, 
TRUE);<R>
<R>
SetWindowText (hWnd, (LPSTR) szTitle);<R>
<R>
while (GetMessage(&msg, NULL, NULL, NULL))<R>
      {<R>
      TranslateMessage(&msg);<R>
      DispatchMessage(&msg);<R>
      }<R>
<R>
return (msg.wParam);<R>
} /* end of WinMain */<R>
<R>
<R>
long CALLBACK _export WndProc<R>
              (HWND hWnd, UINT message, UINT wParam, LONG lParam)<R>
{<R>
int        xPos;<R>
int        yPos;<R>
HDROP      hDrop;<R>
int        TotalNumberOfFiles;<R>
char       szFileName [MAXPATH + 1];<R>
char       szString [256];<R>
int        i;<R>
WORD       winExecErr;<R>
int        len;<R>
<R>
switch (message)<R>
       {<R>
       case WM_CREATE:<R>
            if (lstrlen (lpDDInstance) == 0)<R>
               {<R>
               wsprintf (szString, "%s %s",<R>
                   (LPSTR) "DDSHELL must be called with an",<R>
                   (LPSTR) "argument to identify its instance");<R>
               MessageBox (hWnd, szString, szAppName,<R>
                                              MB_ICONEXCLAMATION | 
MB_OK);<R>
               DestroyWindow (hWnd);<R>
               return 0;<R>
               }<R>
            len = GetPrivateProfileString (lpDDInstance, "command",<R>
                               "", szCommand, MAXPATH + 2, "ddshell.ini");<R>
            if (len == 0)<R>
               {<R>
               wsprintf (szString,

@CSOURCE8 =                       "No command line defined for %s 
in DDSHELL.INI%s%s",<R>
                      lpDDInstance, (LPSTR) "\n          or\n",<R>
                      (LPSTR) "DDSHELL.INI not found in your WINDOWS 
DIR");<R>
               MessageBox(hWnd,<R>
                          szString, szAppName, MB_ICONEXCLAMATION 
| MB_OK);<R>
               DestroyWindow (hWnd);<R>
               return 0;<R>
               }<R>
            if (len >> MAXPATH)<R>
               {<R>
               wsprintf (szString,<R>
                  "The command line for %s \n%s %i character limit",<R>
                  lpDDInstance, (LPSTR) "is longer than the",<R>
                  MAXPATH);<R>
               MessageBox(hWnd,<R>
                         szString, szAppName, MB_ICONEXCLAMATION | 
MB_OK);<R>
               DestroyWindow (hWnd);<R>
               return 0;<R>
               }<R>
            GetPrivateProfileString (lpDDInstance, "title",<R>
                                lpDDInstance, szTitle, 80, "ddshell.ini");<R>
            initialXPos = GetPrivateProfileInt<R>
                                  (lpDDInstance, "xPos", 0, "ddshell.ini");<R>
            initialYPos = GetPrivateProfileInt<R>
                                  (lpDDInstance, "yPos", 0, "ddshell.ini");<R>
            DragAcceptFiles (hWnd , TRUE );<R>
            return 0;<R>
<R>
       case WM_MOVE:<R>
            xPos = (int) LOWORD (lParam);<R>
            yPos = (int) HIWORD (lParam);<R>
            wsprintf (szString, "%i", xPos);<R>
            WritePrivateProfileString<R>
                        (lpDDInstance, "xPos", szString, "ddshell.ini");<R>
            wsprintf (szString, "%i", yPos);<R>
            WritePrivateProfileString<R>
                        (lpDDInstance, "yPos", szString, "ddshell.ini");<R>
            return 0;<R>
<R>
       case WM_DROPFILES:<R>
            hDrop = (HDROP) wParam;<R>
            TotalNumberOfFiles = DragQueryFile( hDrop , 0xFFFF, NULL, 
0 );<R>
            for ( i = 0; i << TotalNumberOfFiles ; i++ )<R>
                {<R>
                len = DragQueryFile( hDrop , i , NULL, 0 );<R>
                if (len >> MAXPATH)<R>
                   {<R>
                   wsprintf (szString,<R>
                      "The path for dropped file %i is to long", i);<R>
                   MessageBox(hWnd,<R>
                         szString, szAppName, MB_ICONEXCLAMATION | 
MB_OK);<R>
                   }<R>
                else<R>
                   {<R>
                   DragQueryFile( hDrop , i, szFileName, MAXPATH + 
1 );<R>
                   wsprintf (szString,<R>
                        "%s %s", (LPSTR) szCommand, (LPSTR) szFileName);<R>
                   winExecErr = WinExec (szString, SW_SHOW);<R>
                   if (winExecErr << 32)<R>
                      {

@CSOURCE8 =                       switch (winExecErr)<R>
                             {<R>
                             case 2:<R>
                                  wsprintf (szString,<R>
                                    "Invalid command path:\n%s",<R>
                                    (LPSTR) szCommand);<R>
                                  break;<R>
                             default:<R>
                                  wsprintf (szString, "%s %s %s\n%s 
%d",<R>
                                    (LPSTR) "Error launching command:",<R>
                                    (LPSTR) szCommand, (LPSTR) szFileName,<R>
                                    (LPSTR) "error code =",<R>
                                    winExecErr);<R>
                             }<R>
                      MessageBox (hWnd, szString, szAppName,<R>
                                       MB_ICONEXCLAMATION | MB_OK);<R>
                      } /* end if (winExecErr << 32) */<R>
                   } /* end if (len >> MAXPATH) */<R>
                } /* end for ( i = 0; i << TotalNumberOfFiles ; i++ 
) */<R>
<R>
            DragFinish( hDrop );<R>
            return 0;<R>
<R>
       case WM_SYSCOMMAND:<R>
            switch (wParam)<R>
                   {<R>
                   case IDM_ABOUT:<R>
                        wsprintf (szString, "%s%s%s",<R>
                           (LPSTR) "Drop and Drag Shell\n",<R>
                           (LPSTR) "        version 2.0\n",<R>
                           (LPSTR) "(c) Noah Davids 1992");<R>
                        MessageBox(hWnd, szString, szAppName,<R>
                                              MB_ICONEXCLAMATION | 
MB_OK);<R>
                        return 0;<R>
                   }<R>
            break;<R>
<R>
       case WM_CLOSE:<R>
            DragAcceptFiles( hWnd , FALSE );<R>
            break;<R>
<R>
       case WM_DESTROY:<R>
            PostQuitMessage(0);<R>
            return 0;<R>
       }<R>
return DefWindowProc(hWnd, message, wParam, lParam);<R>
<R>
} /* end of WndProc */<R>
 <R>
/* End of File */ 

