/*                    Listing 3
             Windows subclassing for C++
          by Norman L. Hills & Davin S. Hills
    Copyright (c) 1992 Hills Object Technology, Inc.
                 All Rights Reserved
*/
#include <dos.h>
LPSTR FWOFF;
LPSTR FWWSEG;

/* Save "this" for VButton object
   in button Window's Property List
*/
void SetCObjptr(HWND hwnd,CCVPTR ctlptr) {
#if defined(__SMALL__) || (__MEDIUM__)
    FWOFF = (LPSTR)MAKEINTATOM(AddAtom("winoff"));
    SetProp(hwnd,FWOFF,(HANDLE)ctlptr);
#else
    FWOFF = (LPSTR)MAKEINTATOM(AddAtom("winoff"));
    FWWSEG = (LPSTR)MAKEINTATOM(AddAtom("winseg"));
    SetProp(hwnd,FWWSEG,(HANDLE) FP_SEG (ctlptr));
    SetProp(hwnd,FWOFF,(HANDLE) FP_OFF (ctlptr));
#endif
}

/* Retrieve "this" for VButton object
   from button Window's Property List
*/
CCVPTR GetCObjptr(HWND hwnd) {
#if defined(__SMALL__) || (__MEDIUM__)
    return (CCVPTR) GetProp(hwnd,FWOFF);
#else
    return (CCVPTR) (((long)(int)GetProp(hwnd,FWWSEG)<<16) | 
                           (long)(int)GetProp(hwnd,FWOFF));
#endif
}

/* Clear "this" from Property List
*/
void RemoveCObjptr(HWND hwnd) {
#if defined(__SMALL__) || (__MEDIUM__)
    RemoveProp(hwnd,FWOFF);
#else
    RemoveProp(hwnd,FWWSEG);
    RemoveProp(hwnd,FWOFF);
#endif
}
