/*   Title:  DEMODIO.C                               *
 *  Author:  John Reynolds                           *
 * Purpose:  Test parallel port Digital I/O routines *
 * Copyright 1991 Magnetic Technologies Corporation  *
 *           Rochester, New York  14625              */

#include "printdio.h"
#include <conio.h>

void main()
{
  int i, LPTport;
  char choice = 'x';

  clrscr();
  puts("\nAvalable LPT ports:\n");
  for (i=0; i<3; i++)
   printf("LPT%d= %04x\n",i+1, peek(0x00,0x0408 +i*2));

  printf("\nUse which LPT port (1-3): ");
  scanf("%d",&LPTport);

  if (!use_port_LPT(LPTport))
  {
    printf("\nLPT%d port unavailable !!\n\n",
            LPTport);
    exit();
  } /* if bad port */

  while (toupper(choice) != 'Q')
  {
    clrscr();
    printf("Using LPT%d\n\n",LPTport);
    puts("INPUTS ARE UPDATED WITH EACH CHOICE");
    printf("\n Input byte = %02x\t\t\t"
           " Output byte = %02x\n"
           ,input_byte(), read_output_byte());
    printf(" Input bit: 7 6 5 4 3 2 1 0\t\t"
           " Output bit: 7 6 5 4 3 2 1 0\n"
           " Currently:");
    for (i=7; i>=0; i--)
      printf(" %d", input_bit(i));
    printf("\t\t  Currently:");
    for (i=7; i>=0; i--)
      printf(" %d", read_output_bit(i));

    puts("\n\n\nOUTPUT CHOICES");
    puts("\n 1\) Clear all bits");
    puts(" 2\) Clear single bit");
    puts(" 3\) Clear masked bits");
    puts("\n 4\) Set all bits");
    puts(" 5\) Set single bit");
    puts(" 6\) Set masked bits");
    puts("\n 7\) Set bit pattern");

    printf("\n Enter Choice number, or Q to quit: ");
    choice = toupper(getch());

    switch(choice)
    {
      case '1':
        clear_all_bits();
        break;
      case '2':
        printf("\nClear which bit (0-7)? ");
        scanf("%d",&i);
        clear_bit(i);
        break;
      case '3':
        printf("\nEnter mask byte (hex) to clear "
               "(1's cleared, 0's unchanged): ");
        scanf("%x",&i);
        clear_masked_bits(i);
        break;
      case '4':
        set_all_bits();
        break;
      case '5':
        printf("\nSet which bit (0-7)? ");
        scanf("%d",&i);
        set_bit(i);
        break;
      case '6':
        printf("\nEnter mask byte (hex) to set "
               "(1's set, 0's unchanged): ");
        scanf("%x",&i);
        set_masked_bits(i);
        break;
      case '7':
        printf("\nEnter pattern byte "
               "(hex) to output: ");
        scanf("%x",&i);
        set_bit_pattern(i);
        break;
    } /* switch i */
  } /* while(choice) */
} /* main() */
