/*   Title:  DEMORTC.C                               *
 *  Author:  John Reynolds                           *
 * Purpose:  Exercise the Real-time clock routines   *
 *           contained in rtclock.c.                 *
 * Copyright 1991 Magnetic Technologies Corporation  *
 *           Rochester, New York  14625              */

#include <conio.h>
#include <stdio.h>
#include "rtclock.h"

static int clk_hertz, RtcSeconds;
static void rtc_timer();

void main()
{
  long int endsec;
  char cmd = 'X';

  while(cmd != 'Q')
  {
    clrscr();
    printf("Run for how many seconds ? ");
    scanf("%ld",&endsec);
    printf("\nSelect clock speed: [1] 128 Hz, (2)"
           " 1024 Hz, (3) 4096 Hz >> ");
    scanf("%d",&clk_hertz);

    printf("\nHit any key to start timer. . .");
    getch();

    printf("\n\nStop at %d seconds\n",endsec);
    puts("Rtclock   RtcSeconds");

    /* designate interrupt handling routine */
     NewRtcVec = rtc_timer;
     RtcCounter = RtcSeconds = 0;

    /* turn on real-time clock interrupts */
     switch(clk_hertz)
     {
       case 2:   clk_hertz = 1024;
                 EnableRtcInts(Hz1024);
                 break;
       case 3:   clk_hertz = 4096;
                 EnableRtcInts(Hz4096);
                 break;
       default:  clk_hertz = 128;
                 EnableRtcInts(Hz128);
                 break;
     } /* switch */

    /* wait for time to expire */
     while (RtcSeconds < endsec)
     {
       printf("%5d     %5d\r",RtcCounter,RtcSeconds);
     } /* while */

    /* print ending time */
       printf("%5d     %5d\r",RtcCounter,RtcSeconds);

    /* turn off real-time clock interrupts */
     DisableRtcInts();

    /* beep end of test */
     sound(800);
     delay(10);
     nosound();

     fflush(stdin);
     printf("\n\nHit ant key to continue, or 'Q' to end. . .");
     cmd = toupper(getch());
  } /* while !'Q' */
} /* main() */

/*-------------------*/
static void rtc_timer()
{
  RtcCounter++;

  if (RtcCounter == clk_hertz)
  {
     RtcCounter = 0;
     RtcSeconds++;
  } /* if second passed */
} /* rtc_timer() */
