/*   Title:  IOUTILS.C                               *
 *  Author:  John Reynolds                           *
 * Purpose:  Interface to Analog/Digital I/O being   *
 *           used in this specific system.           *
 * Copyright 1991 Magnetic Technologies Corporation  *
 *           Rochester, New York  14625              */

#include "ioutils.h"
#include "stepisr.h"
#include "printdio.h"

unsigned char digital_reads[READS_PER_BLOCK];
unsigned int analog_reads[READS_PER_BLOCK];

/*-----------------------------*/
int init_io(unsigned char device)
{
  if (use_port_LPT(device)==0) return -1;
  clear_all_bits();
  return 0;
} /* init_io() */

/*-------------------------------*/
void turn_on_bit(unsigned char bit)
{
  set_bit(bit);
} /* turn_on_bit() */

/*--------------------------------*/
void turn_off_bit(unsigned char bit)
{
  clear_bit(bit);
} /* turn_off_bit() */

/*----------------------*/
static unsigned char dins;
static unsigned int ain;
/*-----------------------------*/
int read_io(unsigned int stepnum)
{
  if (stepnum > READS_PER_BLOCK) return -1;

  /* read digital inputs */
     dins = input_byte();
     digital_reads[stepnum] = dins;
     eot_cw_stop  = dins &  0x01 << CWLIMIT;
     eot_ccw_stop = dins &  0x01 << CCWLIMIT;
     mech_home = dins &  0x01 << MECHHOME;
  /* read analog inputs */
     delay(5); /* simulated read time */
     analog_reads[stepnum] = ain;
  return(0); /* all ok */
} /* read_io() */
