/*   Title:  RTCLOCK.H                              *
 *  Author:  John Reynolds                          *
 * Purpose:  Routines to tap the Real Time Clock    *
 *           periodic interrupt which can be set    *
 *           to run at 128, 1024, or 4096 Hertz     *
 * Copyright 1991 Magnetic Technologies Corporation *
 *           Rochester, New York  14625             */

#ifndef RTCLOCK_H
#define RTCLOCK_H

#define Hz128   2   /*  Allowable values for   */
#define Hz1024  6   /*  periodic interrupt     */
#define Hz4096  4   /*  ClockSpeed.            */

void EnableRtcInts(int ClockSpeed);
void DisableRtcInts(void);

extern int RtcCounter;
extern void (*NewRtcVec)(void);

#endif
