-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=Begin Listing 06-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
/*****************************************************/
/* ownrdraw.c                                        */
/* -- Demonstrate owner draw buttons.                */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>

WNDPROC lpfnSav;      /* Button's original wndproc. */
WNDPROC lpfnSubClass; /* Subclasser instance proc. */

#define cidPush  100  /* Push button control id. */

BOOL             IsButtonUp(WORD, WORD);
LRESULT CALLBACK LButtonSubClassProc(HWND, UINT,
                 WPARAM, LPARAM);
LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM,
                 LPARAM);

LRESULT CALLBACK
MainWndProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_CREATE: /* Create a button to test. */
        {
        HWND hwndPush;

        if (!(hwndPush = CreateWindow("button", NULL,
          WS_CHILD | WS_VISIBLE | BS_OWNERDRAW,
          0, 0, 0, 0, hwnd, (HMENU)cidPush,
          GetWindowInstance(hwnd), NULL)))
            return -1;  /* Destroy window. */

        /* Subclass it using a nifty macro from */
        /* windowsx.h. */
        lpfnSav = (WNDPROC)GetWindowLong(hwndPush,
          GWL_WNDPROC);
        SubclassWindow(hwndPush, lpfnSubClass);
        }
        break;

    case WM_SIZE:   /* Button fills client area. */
        SetWindowPos(GetDlgItem(hwnd, cidPush), NULL,
          0, 0, LOWORD(lParam), HIWORD(lParam),
          SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER);
        break;

    case WM_DESTROY:	/* Only for main window. */
        PostQuitMessage(0);
        break;

    case WM_DRAWITEM:
        {
        LPDRAWITEMSTRUCT    lpDIS;

        lpDIS = (LPDRAWITEMSTRUCT)lParam;
        if (!IsButtonUp(lpDIS->itemAction,
          lpDIS->itemState))
            FillRect(lpDIS->hDC,&lpDIS->rcItem,
              GetStockObject(BLACK_BRUSH));
        else
            FillRect(lpDIS->hDC,&lpDIS->rcItem,
              GetStockObject(LTGRAY_BRUSH));
        }
        return TRUE;	/* Apparently unheeded. */
        }

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }

LRESULT CALLBACK
LButtonSubClassProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Turn double clicks into single clicks.         */
/*****************************************************/
    {
    return CallWindowProc(lpfnSav, hwnd,
      wm == WM_LBUTTONDBLCLK ? WM_LBUTTONDOWN : wm,
      wParam, lParam);
    }

BOOL
IsButtonUp(WORD ItemAction, WORD ItemState)
/*****************************************************/
/* -- Return TRUE if button is in selected state.    */
/*****************************************************/
    {
    if ((ItemAction & ODA_SELECT) ||
      (ItemAction & ODA_DRAWENTIRE))
        {
        if (ItemState & ODS_SELECTED)
            return TRUE;
        else
            return FALSE;
        }

    return FALSE;	/* Return something known. */
    }


