        .model  medium
;***********************************************************************
;                              KBPEEK.ASM
;    KBPEEK [DECLARE FUNCTION KBPEEK% ()] is a function to be linked to
; compiled BASIC programs.  It looks at the next character in the
; type-ahead buffer and returns the following integer values: 
;                -1 if no character is pending
;               256 if an ASCII symbol is pending
;    Any other returned value is the extended code symbol, which is
; purged from the type-ahead buffer. 
;         Based on the subroutine of the same name in the book
;    "Advanced QuickBASIC 4.0," published by Bantam Books in 1988.
;             Copyright (C) 1988, 1991 by Murray L. Lesser
;***********************************************************************
.code
        public  kbpeek
kbpeek  proc
        push    bp                      ;Safety, no arguments passed
;Test keyboard type word (as found by POST)
        mov     ax,40h                  ;Set ES to ROM BIOS data area
        mov     es,ax
        xor     ch,ch                   ;83-key "read key" function
        test byte ptr es:[96h],10h      ;Keyboard data area 3
        jz      next                    ;Zero if 83-key keyboard
        mov     ch,10h                  ;101-key "read key" function
next:   mov     ah,ch                   ;Check buffer status
        inc     ah
        int     16h
        jz      no_chr                  ;Zero flag set if buffer empty
;Is pending character "Extended Code" symbol (AL = 0) for old keys?
        or      al,al
        jz      getit                   ;If so, remove from buffer
;If not, test for "new" "Extended Code" symbol (AL = 0E0H, AH <> 0):
        cmp     al,0e0h
        jnz     next_2
        or      ah,ah                   ;ASCII code 224 [0E0H] is ""
        jnz     getit
next_2: mov     ax,256                  ;Else return ASCII char signal
done:   pop     bp
        ret
;Remove pending "Extended Code" symbol from buffer:
getit:  mov     ah,ch                   ;Read keyboard buffer
        int     16h
        xchg    ah,al                   ;Integer value of extended code
        xor     ah,ah                   ;  now in AX
        jmp     done
;Signal no character pending:
no_chr: mov     ax,-1
        jmp     done
kbpeek  endp
        end
