   1: /*
   2:  *  REDIRECT.C
   3:  *
   4:  *  Written by Gordon W. Lawson
   5:  *  Test code modified by Leor Zolman
   6:  *
   7:  *  Redirects STDOUT to STDPRN or a file, and back again.
   8:  *
   9:  *  Tested under Borland C++ 3.1 by LZ
  10:  */
  11: 
  12: #include <stdio.h>
  13: #include <stdlib.h>
  14: #include <conio.h>
  15: 
  16: #define CONSOLE 0
  17: #define PRINTER 1
  18: #define FILE_IO 2
  19: 
  20: #define NO_REDIR 3
  21: #define QUIT    4
  22: 
  23: int redirect(int which);
  24: void print_this_junk(void);
  25: 
  26: char Filename[] = "TESTFILE.TXT";
  27: 
  28: void main(void)
  29: {
  30:     int answer;
  31: 
  32:     while(1)
  33:     {
  34:         fprintf(stderr, "\nWhere do you want the text to go?\n");
  35:         fprintf(stderr, "0  Console\n");
  36:         fprintf(stderr, "1  Printer\n");
  37:         fprintf(stderr, "2  File\n");
  38:         fprintf(stderr, "3  No redirection\n");
  39:         fprintf(stderr, "4  Quit\n");
  40:         answer = getch();
  41:         fprintf(stderr, "\n\n");
  42: 
  43:         answer -= '0';
  44: 
  45:         switch(answer)
  46:         {
  47:             case CONSOLE:
  48:                 if (redirect(CONSOLE))
  49:                     fprintf(stderr, "Error!\n");
  50:                 break;
  51:                 
  52:             case PRINTER:
  53:                 if (redirect(PRINTER))
  54:                     fprintf(stderr, "Error!\n");
  55:                 break;
  56:                 
  57:             case FILE_IO:
  58:                 if(redirect(FILE_IO))
  59:                     fprintf(stderr, "Error!\n");
  60:                 break;
  61: 
  62:             case QUIT:
  63:                 fcloseall();
  64:                 exit(0);
  65: 
  66:             case NO_REDIR:
  67:                 break;
  68: 
  69:             default:
  70:                 fprintf(stderr, "Please type the number "
  71:                                 "beside your choice...\n");
  72:                 continue;
  73:         }
  74:         print_this_junk();
  75:     }
  76: }
  77: 
  78: 
  79: int redirect(int which)
  80: {
  81:   FILE *in;
  82:   int return_value;
  83: 
  84:   switch(which) {
  85:     case  0:                /* Redirect output to the console */
  86:         if (freopen("CON", "wt", stdout)== NULL)
  87:             return_value = 1;
  88:         else
  89:             return_value = 0;
  90:         break;
  91: 
  92:     case  1:                /* Redirect output to the printer */
  93:         if (freopen("LPT1", "wt", stdout) == NULL)
  94:             return_value = 1;
  95:         else
  96:             return_value = 0;
  97:         break;
  98:               
  99:     case  2:                /* Redirect output to a file */
 100:         if (freopen(Filename, "wt", stdout) == NULL)
 101:             return_value = 1;
 102:         else
 103:             return_value = 0;
 104:         break;
 105:     }
 106:     return(return_value);
 107: }
 108: 
 109: void print_this_junk(void)
 110: {
 111:     printf("This is the junk or stuff that you can "
 112:         "print in a file, the console\n");
 113:     printf("or the printer.  Blah, blah, blah.  Et cetera, "
 114:         "other stuff and well,\n");
 115:     printf("you know, this stuff, too!\n");
 116: }
