;------------------------------------------------------
;   LISTING 4
;
;   Module:     initblk.asm
;   Summary:    Setup data structures for block device
;               Include file for sldd.asm module
;   Assembler:  TASM 2.0
;   Author:     T.W. Nelson
;   Version:    1.00
;   Date:       29-Jan-1992
;   Notes:
;
;   Source code Copyright (c) 1992 T.W. Nelson. May
;   be used only with appropriate acknowledgement of
;   copyright.
;------------------------------------------------------

    mov     ax,seg _TEXT
    mov     es,ax
    test    es:drv_attr,8000h   ;block device?
    jz      init0               ;yes, continue
    jmp     init_x              ;else bypass
init0:
    cmp     cmdPkt.rh_nunits,0  ;any units returned?
    jne     init1               ;yes, continue
    mov     bx,offset no_block  ;no, abort
    jmp     err_exit
init1:
    cmp     cmdPkt.rh_brkofs,0  ;paragraph aligned?
    je      init2               ;yes, bypass
    mov     bx,cmdPkt.rh_brkofs ;no, align on pgraph
    mov     cx,4
    shr     bx,cl
    inc     bx
    add     cmdPkt.rh_brkseg,bx
    mov     cmdPkt.rh_brkofs,0
init2:
    xor     cx,cx               ;starting unit#
    jmp     init10              ;test loop exit
init3:
    call    new_drive           ;get next CDS entry
    push    ax                  ;save result
    les     bx,pBlkDevCnt
    inc     bptr es:[bx]        ;1 more block device
    mov     ah,32h              ;DOS get DPB pointer
    mov     dl,al               ;drive# (A=1,B=2,etc.)
    int     21h                 ;return ds:bx -> DPB
    push    ds
    pop     es                  ;es:bx -> last DPB
    mov     ax,seg _INIT
    mov     ds,ax               ;fix ds
    add     bx,24               ;-> DPB link field
    cmp     dosMajor,3
    jle     init4
    inc     bx                  ;adjust for DOS 4+
init4:
    push    es
    push    bx                  ;save -> DPB link
    mov     es,cmdPkt.rh_bufseg
    mov     bx,cmdPkt.rh_bufofs ;es:bx -> BPB offset
    mov     si,es:[bx]          ;unpack -> BPB
    push    es
    mov     es,cmdPkt.rh_brkseg
    mov     bp,0                ;es:bp = new DPB addr
    pop     ds                  ;ds:si -> BPB
    mov     ah,53h              ;DOS xlat BPB -> DPB
    int     21h
    mov     ax,seg _INIT
    mov     ds,ax               ;fix ds
    pop     bx
    pop     es                  ;recover -> DPB link
    mov     ax,cmdPkt.rh_brkseg
    mov     wptr es:[bx+0],0    ;link offset
    mov     wptr es:[bx+2],ax   ;link segment
    pop     ax                  ;recover new drive#
    push    ax                  ;save again
    mov     bx,sizeofCDS
    mul     bl
    les     bx,pCDS
    add     bx,ax               ;-> new CDS entry
    mov     wptr es:[bx].flags,1 shl 14
    mov     ax,cmdPkt.rh_brkseg
    mov     wptr es:[bx].pDPB[0],0
    mov     wptr es:[bx].pDPB[2],ax
    mov     es:[bx].sclust,0ffffh
    mov     wptr es:[bx].ffff[0],0ffffh
    mov     wptr es:[bx].ffff[2],0ffffh   ;-1L
    mov     es:[bx].slash,2
    cmp     dosMajor,3
    jle     init5
    mov     es:[bx].qmark1,0    ;initialize
    mov     es:[bx].qmark2,0    ;DOS 4+ entries
    mov     wptr es:[bx].ifs[0],0
    mov     wptr es:[bx].ifs[2],0
init5:                          ;initialize new DPB
    mov     es,cmdPkt.rh_brkseg
    mov     bx,0                ;-> new DPB
    pop     ax                  ;recover new drive#
    mov     es:[bx],al
    pop     cx                  ;recover unit#
    mov     es:[bx+1],cl
    inc     cx                  ;next unit#
    cmp     dosMajor,3
    jle     init6
    inc     bx                  ;adjust for DOS 4+
init6:
    mov     wptr es:[bx+12h],offset _TEXT:drv_header
    mov     wptr es:[bx+14h],seg _TEXT
    mov     wptr es:[bx+18h],0ffffh ;set end of DPB
    mov     wptr es:[bx+1ah],0ffffh ;chain
    add     cmdPkt.rh_brkseg,2     ;2 pgraphs for DPB
    add     cmdPkt.rh_bufofs,2     ;-> next BPB
init10:
    cmp     cmdPkt.rh_nunits,0     ;more block units?
    je      init_x                 ;no, quit
    dec     cmdPkt.rh_nunits       ;yes, continue
    push    cx                     ;save unit#
    jmp     init3
init_x:

;----- End of file ------------------------------------
