/* BTN_FNCS.H: Declarations of Support Functions for 3-D Buttons
   Include after WINDOWS.H

   Copyright (c) 1992 Springtime Software
   All Rights Reserved

*/

/* Fatal error procedure type */
typedef void ERRPROC(LPSTR msg, long info);

/* Initialize 3-D button facility (call from start of application) */
void	init_3d(LPSTR app_name, HANDLE instance, ERRPROC fatal);

/* Terminate 3-D button facility (call from end of application) */
void	end_3d(void);

/* Initialize or terminate all 3-D buttons in a dialog box */
/* (call from WM_INITDIALOG and WM_DESTROY) */
void	scan_3d_buttons(HWND dlg, LPARAM pass);

/* Paint a 3-D button in a given new state (call from WM_DRAWITEM) */
void	paint_3d_button(DWORD lParam);

/* For debugging: Display given DC+bitmap in center of screen */
void	show(HDC dc_in);

