/*****************************************************/
/* symedit.c                                         */
/* -- Demo application that tricks an edit control   */
/*    into using to characters from the system font  */
/*    and the symbol font.                           */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>
#include "symdll.h"
#include "symedit.h"

BOOL CALLBACK FDlgProc(HWND, UINT, WPARAM, LPARAM);

HFONT   hfntSym;    /* Symbol font. */

int PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    DLGPROC lpfnDlg;

    if (lpfnDlg = (DLGPROC)MakeProcInstance(
      (FARPROC)FDlgProc, hins))
        {
        DialogBox(hins, MAKEINTRESOURCE(dlgSymEdit),
          NULL, lpfnDlg);
        FreeProcInstance((FARPROC)lpfnDlg);
        return TRUE;
        }

    return FALSE;
    }

BOOL CALLBACK
FDlgProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Dialog proc.                                   */
/*****************************************************/
    {
    static  HFONT   hfntSym;
            BYTE    szBuf[257];
            int     ich;

    switch (wm)
        {
    default:
        break;

    case WM_INITDIALOG:
        for (ich = 0; ich < 256; ich++)
            szBuf[ich] = (BYTE)(ich + 1);
        szBuf[256] = '\0';

		SetDlgItemText(hwnd, didEdit, szBuf);
        if (!(hfntSym = CreateFont(0, 0, 0, 0,
          FW_DONTCARE, 0, 0, 0, SYMBOL_CHARSET,
          OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
          DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
          "Symbol")))
            EndDialog(hwnd, FALSE);
        return TRUE;

    case WM_DESTROY:
        if (hfntSym)
            DeleteObject(hfntSym);
        StopFontMix();
        break;

    case WM_COMMAND:
        if (wParam == IDOK || wParam == IDCANCEL)
            {
            EndDialog(hwnd, wParam);
            return TRUE;
            }

        if (HIWORD(lParam) != BN_CLICKED)
            return FALSE;

        switch (wParam)
            {
        case didSystem:
            StopFontMix();
            wParam = 0;
            break;

        case didSymbol:
            StopFontMix();
            wParam = (WPARAM)hfntSym;
            break;

        case didMixed:
            FStartFontMix(hfntSym);
            wParam = 0;
            break;
            }   /* End second switch wParam. */

        SendDlgItemMessage(hwnd, didEdit, WM_SETFONT,
          wParam, TRUE);
        return TRUE; /* End case WM_COMMAND. */
        }            /* End switch wm. */

    return FALSE;
    }
