/*
 * beep.c
 *  This routine causes the system speaker to emit a beep
 *  of the specified pitch and duration.
 *
 * Writen 2/92 by Fred C. Smith
 *
 * (Heavily modified from code found in one of the books of
 *  Herbert Schildt--Sorry, I forget which one!)
 *
 * Compile (Borland C++):
 *  bcc beep.c timer.obj
 */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include "timer.h"

/* Beep the speaker using the specified frequency. */

void beep (int freq, long duration)
/*  int freq;              in Hertz ??     */
/*  long duration;         in milliseconds */
    {
    unsigned i;
    union
        {
        unsigned short divisor;
        unsigned char c[2];
        } count;
    unsigned long pause, start;
    unsigned char p;

    if (freq > 0 && freq < 19)
        freq = 19;  /* smallest number where result fits an unsigned int */
    if (freq != 0)
    {   /* compute the proper count */
        count.divisor=(unsigned int)(1193280L/freq);
        outportb (67, 182);             /* tell 8253 that count is comming */
        outportb (66, count.c[0]);      /* send low-order byte */
        outportb (66, count.c[1]);      /* send high-order byte */
        p = inportb (97);               /* get existing bit pattern */
        outportb (97, p | 3);           /* turn on bits 0 and 1 */
    }

    /* start counting & continue til enough time has passed */
    pause = duration;
    start = readtimer ();
    while (elapsedtime (start, readtimer ()) < pause)
        ;

    if (freq != 0)
        outportb (97, p);       /* restore orig. bits to turn off speaker */
    }

main (int argc, char ** argv)
{
    initializetimer ();
    if (argc != 3)
        exit(fprintf(stderr, "usage: %s freq duration\n", argv[0]));
    beep (atoi (argv[1]), (long) atoi (argv[2]));
    restoretimer ();
    return 0;
}
