/*****************************************************/
/* captfont.c                                        */
/* -- Demonstrate technique for displaying custom    */
/*    font in window caption.                        */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>
#include "symdll.h"

LRESULT CALLBACK __export
    LWndProc(HWND, UINT, WPARAM, LPARAM);

char    szApp[]    = "CaptFont";

int PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    MSG     msg;
    HWND    hwnd;

    if (!hinsPrev)      /* Register a window class. */
        {
        WNDCLASS  wcs;

        wcs.style = 0;
        wcs.lpfnWndProc = LWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szApp;
        if (!RegisterClass(&wcs))
            return FALSE;
        }

    msg.wParam = 0;
    if ((hwnd = CreateWindow(szApp, szApp,
      WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
      NULL, NULL, hins, NULL)) != NULL)
        {
        ShowWindow(hwnd, wShow);
        while (GetMessage(&msg, NULL, 0, 0))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            }
        }

    return msg.wParam;
    }

LRESULT CALLBACK __export
LWndProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_NCPAINT:
    case WM_NCACTIVATE:
        FStartFontMix(GetStockObject(ANSI_FIXED_FONT));
        break;

    case WM_DESTROY:
        PostQuitMessage(0);
        break;
        }

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }
