// ---------------------------------------------------------
//  build.cpp
// ---------------------------------------------------------

#include <windows.h>
#include <string.h>
#include "zyhapi.h"

int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    //  The paths for the control files and the index.
    char *psControlPath = "d:\\zydev\\control";
    char *psIndexPath   = "d:\\mp\\zy\\index";

    //  Start the Toolkit.
    ToolkitOptions tkOptions;
    memset(&tkOptions, 0, sizeof(tkOptions));
    tkOptions.nResourceLevel = ZY_MEDIUM;
    ZYstart(psControlPath, 
            tkOptions);

    //  Delete any existing index, then create an empty one.
    ZYdeleteIndex(psIndexPath);    
    ZYmakeIndex(psIndexPath);

    //  Open the index in INDEX mode and get its handle. 
    long lZYIndex;
    ZYopenIndex(psIndexPath, 
                ZY_INDEX, 
                &lZYIndex);

    //
    //  Add all the Microsoft Word docs in e:\wpdocs and
    //  all its subdirectories to the index.  Note that the
    //  string parameter is one long string, not separate
    //  ones.
    //
    ZYaddDocs(lZYIndex,         // index handle
              ZYIMMEDIATE,      // script included here
              "5000\r\n"        // required constant
              "*.bak\r\n \r\n"  // exclude file types
              "e:\r\n"          // drive
              "\\wpdocs R\r\n"  // path and recursion flag
              "*.doc\r\n"       // include file types
              "\r\n");          // end of script

    // Close the index and shut down the toolkit.
    ZYcloseIndex(lZYIndex);
    ZYfinish();
    return 0;
}


