/*****************************************************/
/* ncbtndmo.c                                        */
/* -- Program demonstrates use of non-client push    */
/*    button code.                                   */
/* -- To build:                                      */
/*    cc -DSTRICT ncbtndmo.c ncbtn.c                 */
/*****************************************************/
#include <windows.h>
#include "ncbtn.h"

LRESULT CALLBACK __export LwMainWndProc(HWND hwnd,
  UINT wm, WPARAM wParam, LPARAM lParam);

#define cidPush1  1 /* Child push button control id. */
#define cidPush2  2 /* Child push button control id. */

char szMainClass[]  = "NonClientButton";
char szTitle[]      = "Non-client push button demo";
char szBtn1[]       = "Push me";
char szBtn2[]       = "or me";

int PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lpsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    MSG     msg;
    HWND    hwnd;

    if (hinsPrev == NULL)
        {
        WNDCLASS wcs;

        wcs.style = 0;
        wcs.lpfnWndProc = LwMainWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szMainClass;
        if (!RegisterClass(&wcs))
            return FALSE;
        }

    msg.wParam = 0;
    if ((hwnd = CreateWindow(szMainClass, szTitle,
      WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
      NULL, NULL, hins, NULL)) != NULL)
        {
        ShowWindow(hwnd, wShow);
        while (GetMessage(&msg, NULL, 0, 0))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            }
        }

    return msg.wParam;
    }

LRESULT CALLBACK __export
LwMainWndProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_CREATE:
        {
        HDC     hdc;
        SIZE    pt1, pt2;
        int     dxBdr;

        if ((hdc = GetDC(hwnd)) == NULL)
            break;

        dxBdr = GetSystemMetrics(SM_CXBORDER);
        GetTextExtentPoint(hdc, szBtn1, sizeof szBtn1,
          &pt1);
        pt1.cx += 8 * dxBdr;
        HwndCreateCaptionPush(hwnd, szBtn1, cidPush1,
          0, pt1.cx);
        GetTextExtentPoint(hdc, szBtn2, sizeof szBtn2,
          &pt2);
        HwndCreateCaptionPush(hwnd, "or me", cidPush2,
          pt1.cx, pt2.cx + 8 * dxBdr);
        ReleaseDC(hwnd, hdc);
        }
        break;

    case WM_DESTROY:
        PostQuitMessage(0);
        break;

    case WM_COMMAND:
        if (LOWORD(lParam) != 0 &&
          (wParam == cidPush1 || wParam == cidPush2))
            {
            char    szBuf[32];

            wsprintf(szBuf, "Push button %d", wParam);
            MessageBox(hwnd, "Thank you!", szBuf,
              MB_OK);
            return 0;
            }
        break;
        }

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }
