#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <windows.h>
#include <wingate.h>
#include <wgspawn.h>
#include "mb.h"

/****************************************************************************/
/*Title:    MBCLIENT.C - WINGate Message Box Client Example                 */
/*Author:   Thomas W. Olsen                                                 */
/*Version:  1.0                                                             */
/*Compiler: Microsoft Visual C++ Professional Edition v1.0                  */
/*  cl /c /Gs /G2 /W3 /AM /Ox /D "WINVER"="0x0300" /D "STRICT" MBCLIENT.C   */
/*  link /NOI /STACK:5120 MBCLIENT,,,WG OLDNAMES MLIBCE;                    */
/****************************************************************************/

void ErrorExit(char *errMsg)
{
    printf("Error: %s\n", errMsg);
    exit(-1);
}

int main(int argc, char *argv[] )
{
    BOOL        bServerAlive = 0;
    UINT        i, uNumServers = 0;
    LONG        dwTranID;
    SERVERINFO  serverList[MB_MAX_SERVERS];
    WGTRANS     lpRequest;
    char        szBuffer[MB_MAX_TRAN_SIZE];
    short       retStatus;    

    if ( WGInit(0, MB_MAX_TRAN_SIZE * 2))
        ErrorExit("Could Not Initialize");

    /* See if Server Exists */

    uNumServers = WGServerInfo( (LPSERVERINFO) &serverList, MB_MAX_SERVERS );

    for (i = 0; i < uNumServers; i++)
    {
        if ( _fstrcmp( serverList[i].name, MB_SERVER_NAME ) == 0 )
        {
            bServerAlive = TRUE;
            break;
        }
    }

    if (bServerAlive == FALSE)
        ErrorExit("Server Not Found");

    if (WGRegisterClient(MB_CLIENT_NAME)) 
        ErrorExit("Could Not Register Client");

    if ((lpRequest = WGCreateTrans(MB_CLIENT_NAME, MB_MAX_TRAN_SIZE)) == NULL)
        ErrorExit("Could Not Create Transaction");

    /* Put Length of String Inside Protocol Area */
    
    _fstrcpy(szBuffer, "This String Was Sent By a DOS Program!");
    WGSetTransValue(lpRequest, 2, (long) _fstrlen(szBuffer) );
    WGSetTransString(lpRequest, szBuffer);

    /* Execute the Transaction */
    dwTranID = WGExecute(lpRequest, MB_SERVER_NAME, MB_TIMEOUT, WG_STAT_WAIT_RESPONSE, &retStatus);

    if (retStatus != WG_STAT_OK ||
        WGGetResponse(lpRequest, dwTranID, WG_STAT_WAIT_RESPONSE) != WG_STAT_OK)
    {
        WGDestroyTrans(lpRequest);
        ErrorExit("Server Error");   
    }
        
    _fmemset( szBuffer, 0, sizeof(szBuffer));
    WGGetTransString(lpRequest, szBuffer, sizeof(szBuffer)-1);
    printf("%s\n", szBuffer);
    
    WGDestroyTrans(lpRequest);
    WGUnregisterClient(MB_CLIENT_NAME);
    WGTerm();
    return(0);
}


