#include <windows.h>
#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <ctype.h>
#include <sys\stat.h>
#include <wingate.h>
#include "mb.h"

/****************************************************************************/
/*Title:    MBSERVER.C - WINGate Message Box Server Example                 */
/*Author:   Thomas W. Olsen                                                 */
/*Version:  1.0                                                             */
/*Compiler: Microsoft Visual C++ Professional Edition v1.0                  */
/*  cl  /c /G2 /W3 /AM /D "WINVER"="0x0300" /D "STRICT" /GA MBSERVER.C      */
/*  link /NOD /PACKC:61440 /STACK:10240 /ALIGN:16 MBSERVER,,,               */
/*       WINGATE+OLDNAMES+LIBW+MLIBCEW,MBSERVER.DEF;                        */
/*  rc mbserver.exe                                                         */
/*                                                                          */
/****************************************************************************/

int      PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int numCmdShow );
long FAR PASCAL WindowProc(HWND hWnd, unsigned message, WORD wParam, LONG lParam);

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int numCmdShow )
{
    MSG       msg;
    HWND      hWnd;
    WNDCLASS  wc;

    wc.style         = (UINT) NULL;
    wc.lpfnWndProc   = (WNDPROC) WindowProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon( NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor( NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = MB_SERVER_NAME;

    if (!RegisterClass(&wc))
        return(FALSE);

    hWnd = CreateWindow( MB_SERVER_NAME, "WINGate Server Example",
                          WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, NULL, NULL, hInst, NULL );
    if (!hWnd)
        return (FALSE);

    if (WGRegisterServer(MB_SERVER_NAME, MB_MAX_TRAN_SIZE, (long) hWnd, MB_SERVER_MSG))
    {
        MessageBox(0,"Registration Failure", MB_SERVER_NAME, MB_OK);
        return (0);
    }

    ShowWindow(hWnd, SW_MINIMIZE);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, NULL, NULL))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return (msg.wParam);
}


long FAR PASCAL WindowProc(HWND hWnd, unsigned msg, WORD wParam, LONG lParam)
{
    WGTRANS     lpRequest, lpResponse;
    short       rc = 0;
    long        lTranID = 0L;
    char        szBuffer[256];

    switch (msg)
    {
        case WM_QUERYOPEN:              /* Prevents Restore */
            return (0L);

        case WM_CLOSE:
            DestroyWindow(hWnd);
            break;

        case WM_DESTROY:
            WGUnregisterServer(MB_SERVER_NAME);
            PostQuitMessage(0);
            break;

        case MB_SERVER_MSG:
            lpRequest = (WGTRANS) lParam;

            lTranID = WGGetTransID(lpRequest, &rc);

            if (!(lpResponse = WGCreateTrans(MB_SERVER_NAME, MB_MIN_TRAN_SIZE)))
            {
                WGPostResponse((WGTRANS) NULL, lTranID);    /* If Response Can't be Created */
                break;
            }
            
            /* Do Something Here ... */
             _fmemset( szBuffer, 0, sizeof(szBuffer));
            WGGetTransString(lpRequest, szBuffer, sizeof(szBuffer)-1);
            MessageBox(0, szBuffer, MB_SERVER_NAME, MB_OK);
            
            WGSetTransValue(lpResponse, 1, NULL );           
            _fstrcpy(szBuffer, "This String Was Sent By a Windows Program!");
            WGSetTransValue(lpResponse, 2, _fstrlen(szBuffer) );
            WGSetTransString(lpResponse, szBuffer);
                        
            WGPostResponse( lpResponse, lTranID );  /* Post the Response */
            WGDestroyTrans( lpResponse );           /* Destroy the WGTRANS */
            break;

        default:
            return DefWindowProc(hWnd, msg, wParam, lParam);
    }
    return (1L);
}
