#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "testrc.h"
#include "wuiman.h"



BOOL CALLBACK _export DlgProc(HWND, UINT, WPARAM, LPARAM);

HINSTANCE   ThisInstance;


int     FillBox(HWND Listbox, char *Path, int Level)
    {
    // print this path, then print children recursively
    char    Buffer[64];
    Buffer[0] = '\0';
    for(int j = 0; j < Level; ++j)
        strcat(Buffer, "    ");
    char *Current = strrchr(Path, '/');
    strcat(Buffer, Current);
    SendMessage(Listbox, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)Buffer);
    long  NChildren = WUIMAN_Get(Path, "p_Child", NULL, 0);
    if(NChildren < WUIMAN_ERRORS)
        {
        char    Message[128];
        WUIMAN_Error(NChildren, Message);
        MessageBox(NULL, Message, "WUIMAN", MB_OK);
        }
    for(int i = 0; i < NChildren; ++i)
        {
        char    ChildName[64];
        char    ChildNumber[64];
        sprintf(ChildNumber, "p_Child(%d)", i);
        long Status = WUIMAN_Get(Path, ChildNumber, ChildName, 64);
        if(Status < WUIMAN_ERRORS)
            {
            char    Message[128];
            WUIMAN_Error(Status, Message);
            MessageBox(NULL, Message, "WUIMAN", MB_OK);
            }
        char *End = Path + strlen(Path);
        if(End[-1] != '/')
            strcat(Path, "/");
        strcat(Path, ChildName);
        FillBox(Listbox, Path, Level+1);
        *End    = '\0';
        }
    return 0;
    }


#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE Me, HINSTANCE Previous,
		     LPSTR lpszCmdLine, int nCmdShow)
    {
    ThisInstance    = Me;
    long Status = WUIMAN_Init(ThisInstance, "test.wui");
    if(Status < WUIMAN_ERRORS)
        {
        char    Message[128];
        WUIMAN_Error(Status, Message);
        MessageBox(NULL, Message, "WUIMAN", MB_OK);
        }
    DialogBox(Me, "Test", NULL, (DLGPROC)DlgProc);
    return 0;
    }

#ifdef __BORLANDC__
    #pragma argsused
#endif
BOOL CALLBACK _export DlgProc(HWND Dialog, UINT Message,
                             WPARAM Param1, LPARAM Param2)
    {

    if(Message == WM_INITDIALOG)
        {
        char    Version[64];
        strcpy(Version, "WuiMan v");
        long Status = WUIMAN_Get("/", "Version",
                                  Version + strlen(Version),
                           sizeof(Version)-strlen(Version));
        if(Status < WUIMAN_ERRORS)
            {
            char    Message[128];
            WUIMAN_Error(Status, Message);
            MessageBox(NULL, Message, "WUIMAN", MB_OK);
            }
        else
            SetWindowText(Dialog, Version);
        FillBox(GetDlgItem(Dialog, BLMMID_OBJECTSCOMBO), "/", 0);
        return TRUE;
        }
    else if(Message == WM_MENUSELECT)
        {
        char    Buffer[128];
        wsprintf(Buffer, "WM_MENUSELECT ID[%d] Flags[0x%04X]",
            Param1, LOWORD(Param2));
        SetDlgItemText(Dialog, 101, Buffer);
        }
    else if(Message == WM_MENUCHAR)
        {
        char    Buffer[128];
        wsprintf(Buffer, "WM_MENUCHAR CHAR[%d] Flags[0x%04X]",
            Param1, LOWORD(Param2));
        SetDlgItemText(Dialog, 102, Buffer);
        }
    else if(Message == WM_PAINT && IsIconic(Dialog))
        {
#if 0
        PAINTSTRUCT PaintInfo;
        BeginPaint(Dialog, &PaintInfo);
        DrawIcon(PaintInfo.hdc, 0, 0, MyIcon);
        EndPaint(Dialog, &PaintInfo);
#endif
        }
    else if(Message == WM_COMMAND)
        if(Param1 == IDOK || Param1 == IDCANCEL) {
            EndDialog(Dialog, 0);
            return TRUE;
            }
    return FALSE;
    }

