// wuierror.h - WUIMAN error code definitions.
// Copyright (c) 1993 by Ron Burk

#ifndef WUIERROR_H
#define WUIERROR_H

#include <limits.h>

// Some object name in the path did not exist
const   long    WUIMAN_ERR_BAD_PATH         = (LONG_MIN+0);
// Target does not support the specified attribute
const   long    WUIMAN_ERR_BAD_ATTR         = (LONG_MIN+1);
// WUIMAN is not initialized
const   long    WUIMAN_ERR_NOT_INITIALIZED  = (LONG_MIN+2);
// Could not initialize database
const   long    WUIMAN_ERR_DATABASE_INIT    = (LONG_MIN+3);
// Requested attribute is NULL
const   long    WUIMAN_ERR_NULL_ATTR        = (LONG_MIN+4);
// Requested attribute is longer than supplied buffer
const   long    WUIMAN_ERR_ATTR_TOO_LONG    = (LONG_MIN+5);
// Bad attribute argument
const   long    WUIMAN_ERR_BAD_ATTR_ARG     = (LONG_MIN+6);


// So adding new errors may not immediately
// break existing code.
const   long    WUIMAN_ERR_SLOP         = 100;

// use "if(Error < WUIMAN_ERRORS)" to detect
// an error.
const   long    WUIMAN_ERRORS           = (LONG_MIN+6
                                          +WUIMAN_ERR_SLOP);

void    WUIMAN_Error(long Error, char *Output);

#endif
