/*-----------------------------------------------------
 *  LISTING 5
 *
 *  Filename:           testbase.c
 *  Summary:            Test application using
 *                      dynalink DOS driver for
 *                      memory-mapped video display in
 *                      text mode
 *  Author:             T.W. Nelson
 *  Compiler:           BORLAND
 *  Compile options:    large model only (-ml)
 *  Version:            1.00
 *  Date:               11-Feb-1993
 *  Notes:
 *
 *-------------------------------------------------- */

#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include "drv.h"

char *teststr[] = {
    "\"This article describes a program that",
    " sorts a large number of records in less",
    " time than comparison sorting can.  For",
    " many files, the time required will be",
    " proportional to the number of records.",
    " This is not a toy program.....\"",
    0
    };

#define UP   0
#define DOWN 1

//Pointers to driver functions ......
DRVFUNC (*setCursorPos)( int col, int row, int page );
DRVFUNC (*getCursorPos)( int *col, int *row,int page );
DRVFUNC (*setCursorType)( int startln, int endln );
DRVFUNC (*getCursorType)( int *startln,
                          int *endln, int page );
DRVFUNC (*setVideoMode)( int mode );
DRVFUNC (*getVideoMode)( int *mode );
DRVFUNC (*setVideoPage)( int page );
DRVFUNC (*getVideoPage)( int *page );
DRVFUNC (*scrollWindow)(int direction,
                        int nlines,
                        int attr,
                        int uplf_y,
                        int uplf_x,
                        int lwrt_y,
                        int lwrt_x );
DRVFUNC (*hideCursor)(void);
DRVFUNC (*revealCursor)(void);
DRVFUNC (*displayStr)( char *string, int col,
                                     int row );
DRVFUNC (*clearScrn)( int attrib );

#define keywait()   {   \
    while( !bioskey(1) ); \
    bioskey(0);   }

/* ------------------------------------------------- */
int main(void)
{
    char **p;
    int start, end, i = 5;
    unsigned display_h;

    if( DrvLoadModule( "DISPLAY",
            &display_h, 0) != TRUE )    {
        printf( "Display module load failure\n" );
        return 1;
    }

    DrvGetProcAddr( display_h, "clearScrn",
                                &clearScrn );
    DrvGetProcAddr( display_h, "displayStr",
                                &displayStr );
    DrvGetProcAddr( display_h, "scrollWindow",
                                &scrollWindow );
    DrvGetProcAddr( display_h, "hideCursor",
                                &hideCursor );
    DrvGetProcAddr( display_h, "revealCursor",
                                &revealCursor );
    DrvGetProcAddr( display_h, "getCursorType",
                                &getCursorType );
    DrvGetProcAddr( display_h, "setCursorType",
                                &setCursorType );
    clearScrn( 0x70 );

    for( p = teststr; *p; *p++ )
         displayStr( *p, 5, i++ );

    //clear row 22 .......
    scrollWindow( UP, 0, 0x07, 22, 0, 22, 79 );
    //clear col 65......
    scrollWindow( DOWN, 0, 0x07, 0, 65, 24, 65 );
    displayStr( "Press key to hide cursor   ", 0, 20);
    getCursorType( &start, &end, 0 );   //save cursor
    keywait();

    hideCursor();
    displayStr( "Press key to restore cursor", 0, 20);
    keywait();
    revealCursor();
    setCursorType( 1, end );    //set big cursor

    clearScrn( 0x07 );
    displayStr( "Press key to quit          ", 0, 20);
    keywait();
    setCursorType( start, end );   //restore cursor

    return 0;
}

/*------ End of File ------------------------------- */
