/*****************************************************
Name:
   BINDDEMO.C, Listing 3
File Type:
   Program
Description:
   Demo Program for BIND Controls
Function List:
   WinMain
Portability:
   MS Windows
*****************************************************/

/* MS Windows */
#include <windows.h>

/* Standard C */
#include <stdio.h>

/* Types and Prototypes for BIND controls */
#include "bindctls.h"

/* Own */
#include "binddemo.h"

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain( HINSTANCE hInstance,
      HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
      int nCmdShow )
   {

   int iReturn = -1;
   char szBuffer[512], szOn[] = "On", szOff[] = "Off";
   char szFormat[] = "Text is: %s\n\n"
         "Feature A is %s, Feature B is %s\n\n"
         "Option %d is Selected\n\n"
         "Return Value is %d";
   char szText[64] = "Initial Bind Edit Control Text";
   int FeatureA, FeatureB, Option1, Option2;
   BINDCTLDATA CtlData[6];

   lpszCmdLine = lpszCmdLine;
   nCmdShow = nCmdShow;

   CtlData[0].iCtlId = IDC_EDIT_EDIT;
   CtlData[0].lpData = (LPARAM)(LPSTR)szText;

   FeatureA = TRUE;
   CtlData[1].iCtlId = IDC_CBTN_FEATUREA;
   CtlData[1].lpData = (LPARAM)(int FAR *)&FeatureA;

   FeatureB = FALSE;
   CtlData[2].iCtlId = IDC_CBTN_FEATUREB;
   CtlData[2].lpData = (LPARAM)(int FAR *)&FeatureB;

   Option1 = TRUE;
   CtlData[3].iCtlId = IDC_RBTN_OPTION1;
   CtlData[3].lpData = (LPARAM)(int FAR *)&Option1;

   Option2 = FALSE;
   CtlData[4].iCtlId = IDC_RBTN_OPTION2;
   CtlData[4].lpData = (LPARAM)(int FAR *)&Option2;

   CtlData[5].iCtlId = 0;
   CtlData[5].lpData = 0;

   sprintf( szBuffer, szFormat, szText,
         ( FeatureA ? szOn : szOff ),
         ( FeatureB ? szOn : szOff ),
         ( Option1 ? 1 : 2 ), iReturn );
   MessageBox( NULL, szBuffer, "Bind Demo", MB_OK );

   RegisterBindButton( hInstance );
   RegisterBindDialog( hInstance );
   RegisterBindEdit( hInstance );

   iReturn = DialogBoxParam( hInstance,
         MAKEINTRESOURCE( ID_DEMO ), NULL,
         (DLGPROC)WndProcBindDialog,
         (LPARAM)(LPBINDCTLDATA)CtlData );

   sprintf( szBuffer, szFormat, szText,
         ( FeatureA ? szOn : szOff ),
         ( FeatureB ? szOn : szOff ),
         ( Option1 ? 1 : 2 ), iReturn );
   MessageBox( NULL, szBuffer, "Bind Demo", MB_OK );

   return ( 0);

   }   /* function WinMain */

/* End of BINDDEMO.C */
