/*
 * BUG008.CPP.
 *
 * When compiled with optimization turned on
 * (CL /Ox bug008.cpp /LINK /NOE),
 * this program demonstrates a bug in array allocation
 * for the Microsoft C++ 8.0 compiler.
 *
 * When compiled and run with n = 5, this program
 * requests 3875 bytes from global new, when it should
 * need 5 or perhaps a few more.  The constructor is called
 * 834 times, when it should be called just 5 times.
 *
 */

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

int inmain = 0;
int ctor_calls = 0;

void * operator new( size_t size )
{
    if ( inmain )
        printf( "New requesting %d bytes\n", size );
    return malloc( size );
}

void operator delete( void *p )
{
    if ( p )
        free( p );
}

class foo {
    public :
        foo(){ ctor_calls++; };
};

main()
{
   int n = 5;

   inmain = 1;
   printf( "Now in main, size of foo is %d\n", sizeof( foo ) );
   printf( "Constructing an array with %d objects\n", n );
   foo* array = new foo[ n ];
   printf( "Constructor was called %d times\n", ctor_calls );
   return 0;
}
