/*****************************************************/
/* createvm.c                                        */
/* -- Application demonstrates using Shell VxD       */
/*    protect mode API to create a hidden VM.        */
/*****************************************************/
#include <windows.h>
#include <mmsystem.h>
#include <stdlib.h>
#include "shell.h"

typedef DWORD (FAR * LPFN)(void);

int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    char  szPath[128], szArg[128], szBuf[128], *pszCmd;
    char *pch;
    DWORD tim = timeGetTime();
    LPFN  lpfn;
    SEB   seb;
    DWORD hvm;

    /* Get Shell VxD's protect mode entry point. */
    _asm mov  ax, 1684h;
    _asm mov  bx, 0017h;
    _asm int  2fh;
    _asm mov  word ptr [lpfn], di;
    _asm mov  word ptr [lpfn + 2], es;
    if (NULL == lpfn)
        return 0;

    /* Check version number. */
    _asm mov  dx, 0;
    if (0x030a > (*lpfn)())
        return 0;

    /* Initialize Shell Execute Data structure. */
    seb.grfpif = fpifAltEnt | fpifAltPsc | fpifPrtSc |
      fpifCtlEsc | fpifAltTab | fpifAltEsc |
      fpifAltSp | fpifBack | fpifCloseE;
    seb.grfdis =
      0x00000010 | fdisEmText | fdisNoText | fdisNoLow;

    /* Obtain location of command interpreter. */
    if (NULL == (pszCmd = getenv("COMSPEC")))
        pszCmd = "C:\\DOS\\COMMAND.COM";
    seb.wfpExe.ib = (WORD)pszCmd;
    seb.wfpExe.sel = SELECTOROF((LPVOID)pszCmd);

    /* Get working directory. */
    for (pch = szPath + GetModuleFileName(hins,
        szPath, sizeof szPath) - 1;
      pch >= szPath; pch--)
        if (*pch == '\\')
            {
            *pch = 0;
            break;
            }

    /* Create arg list for command.com. */
    wsprintf(szArg + 1,
      "/c %s\\dosbatch.bat one two three four",
      (LPSTR)szPath);
    szArg[0] = (char)(lstrlen(szArg + 1) + 2);
    seb.wfpArgs.ib = (WORD)szArg;
    seb.wfpArgs.sel = SELECTOROF((LPVOID)szArg);

    /* Special case if path is root. */
    if (pch - szPath == 2)
        {
        szPath[2] = '\\';
        szPath[3] = 0;
        }
    seb.wfpWork.ib = (WORD)szPath;
    seb.wfpWork.sel = SELECTOROF((LPVOID)szPath);

    seb.cpagWant = 0xffff;           /* Use default. */
    seb.cpagMin = 0xffff;            /* Use default. */
    seb.wForePriority = 100;         /* 0 to 10,000. */
    seb.wBackPriority = 50;          /* 0 to 10,000. */
    seb.ckbMaxEMS = 0x0400;
    seb.ckbMinEMS = 0x0000;
    seb.ckbMaxXMS = 0x4000;
    seb.ckbMinXMS = 0x0000;
    seb.wUnknown1 = seb.wUnknown2 = 0;
    lstrcpy(seb.szTitle, "Demo VM");

    /* Ask Shell to create the VM. */
    _asm lea  di, word ptr seb;
    _asm mov  dx, 3;
    _asm push es;
    _asm push ss;
    _asm pop  es;
    (*lpfn)();
    _asm pop  es;
    _asm _emit 66h;
    _asm mov WORD PTR hvm, ax; /* Really EAX. */
    if (0 != hvm)
        {
        wsprintf(szBuf,
          "Created VM %lx, elapsed time %ld",
          hvm, timeGetTime() - tim);
        MessageBox(NULL, szBuf, "Hidden VM Demo",
          MB_OK);
        }
    return 0;
    }
