///////////////////////////////////////////////////////
// demowait.c                                        //
// -- Program demonstrates waiting for another to    //
//    terminate using the FWaitHins() routine.       //
// -- Written by Paul R. Bonneau 11/25/94.           //
///////////////////////////////////////////////////////
#include <windows.h>
#include "wait.h"

#ifdef __WATCOMC__
    #pragma off (unreferenced);
#endif

char szThisApp[]  = "Spawn & Wait";
char szSpawnApp[] = "notepad.exe";
char szArgs[]     = "wait.c";

void Report(char *pszFormat, BOOL fError)
    {
    char szBuf[256];

    wsprintf(szBuf, pszFormat, (LPSTR)szSpawnApp);
    MessageBox((HWND)NULL, szBuf, szThisApp,
      fError ? (MB_ICONHAND | MB_OK) : MB_OK);
    }

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
    {
    char szBuf[256];
    BOOL fError;

    wsprintf(szBuf, "%s %s",
      (LPSTR)szSpawnApp, (LPSTR)szArgs);
    if (HINSTANCE_ERROR >
      (hins = (HINSTANCE)WinExec(szBuf, wShow)))
        {
        Report("%s failed to spawn", TRUE);
        return 0;
        }

    // A windowed application should check this return
    // value.
    FWaitHins(hins, &fError);
    Report(fError ?
      "Error encountered" : "%s terminated", fError);
    return 0;
    }
