#include <windows.h>



typedef BOOL (WINAPI *TDLG3D)(HANDLE);

static HINSTANCE    Ctl3d  = NULL;
static HINSTANCE    Caller = NULL;
static TDLG3D   Reg3d;
static TDLG3D   Unreg3d;
static TDLG3D   Auto3d;

static TDLG3D  GetProc(LPCSTR Name)
    {    return (TDLG3D) GetProcAddress(Ctl3d, Name);    }

int     Register3d(HINSTANCE Module)
    {
    /* if unloading library */
    if(Module == NULL)
        {
        if(Ctl3d != NULL)
            {
            Unreg3d(Caller);
            FreeLibrary(Ctl3d);
            Ctl3d   = NULL;
            return TRUE;
            }
        else
            return FALSE;
        }
    /* else if loading library */
    else
        {
        UINT OldFlag = SetErrorMode(SEM_NOOPENFILEERRORBOX);
        Ctl3d        = LoadLibrary("ctl3d.dll");
        SetErrorMode(OldFlag);
        if(Ctl3d <= HINSTANCE_ERROR)
            {
            Ctl3d   = NULL;
            return FALSE;
            }
        else
            {
            Reg3d   = GetProc("Ctl3dRegister");
            Unreg3d = GetProc("Ctl3dUnregister");
            Auto3d  = GetProc("Ctl3dAutoSubclass");
            Caller  = Module;
            Reg3d(Caller);
            Auto3d(Caller);
            return TRUE;
            }
        }
    }



