/* Listing 2, q.h */

/* Defines */
#define CREATE                  0
#define DESTROY                 1

#define IDE_QNAME               0x500
#define IDE_QCNAME              0x501
#define IDE_QCDIR               0x502

#define IDM_CREATE              0x600
#define IDM_DESTROY             0x601
#define IDM_ABOUT               0x606
#define IDM_QUEUEENDSERVICING   0x607
#define IDM_QUEUEBEGINSERVICE   0x608
#define IDM_QUEUEEXIT           0x609
#define IDM_SERVEDLIST          0x700
#define IDM_SERVERSTATUS        0x710
#define IDM_SERVERNAME          0x720
#define IDM_QUEUENAME           0x730                                        

#define BUF_SIZE                4096
#define SERVICE_JOB_TIMER       1
#define TWO_SECONDS             2000
#define SERVICE_JOB_MSG         (WM_USER + 1)    

/* prototypes */
int InitNetWareInfo(char * server, char * queue);
int PServer(void);

/* Macros for handling errors without cluttering
 * up the source code too badly                 */
#define ErrMessage(string, rc) if (rc) \
    {  char errMsg[200]; \
       wsprintf (errMsg, "ccode for "string" =  %04X", rc);\
       MessageBox (hDlg, errMsg, "STATUS", IDOK); \
           break; \
    }
#define CheckErr(rc,error) if(rc) { err = error; goto End; }
#define BreakCheckErr(rc,error) if(rc){ err = error; break; }

/* Undocumented clientRecord format of the NWQueueJobStruct*/
struct pconsoleclientRecord
{
    char flags[4*8]; /* Tab size, number of copies, etc. */
    char userName[13]; /* NetWare logged-in user name    */
    char bannerName[13];/* Banner name, by dflt user name*/
    char fileName[14]; /* DOS style file name            */
    char path[10*8]; /* full path                        */
};
