// ****************************************************************************
// File:    bmpdoc.h
//
// Date:    October 22, 1994
//
// Author:  Greg Johnson
//
// Compiler:    Microsoft Visual C++ version 1.5, Microsoft Foundation Class
//              Library (MFC), version 2.5
//
// Purpose: This file declares the CBmpDoc class, which is derived from the
//          MFC CDocument class, providing the standard MFC framework for
//          the Bitmap Database demo application.
//
// ****************************************************************************

class CBmpDoc : public CDocument
{
    protected:
        CBmpDoc(void);
        DECLARE_DYNCREATE(CBmpDoc)

    public:
        virtual ~CBmpDoc();
        virtual void Serialize(CArchive& ar);   // overridden for document i/o
        #ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
        #endif
        
        BOOL OpenDatabase(void);            // called to initialize the database 
                                            // connection
                                            
        CDatabase* qryDatabase(void)        // returns the current database
            { return(pDb); }                // used by the document
                                                        
    protected:
        CDatabase*      pDb;                // the database
        
        virtual BOOL OnNewDocument();

    protected:
        //{{AFX_MSG(CBmpDoc)
            // NOTE - the ClassWizard will add and remove member functions here.
            //    DO NOT EDIT what you see in these blocks of generated code !
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
