// ****************************************************************************
// File:    dbbitmap.h
//
// Date:    October 22, 1994
//
// Author:  Greg Johnson
//
// Compiler:    Microsoft Visual C++ version 1.5, Microsoft Foundation Class
//              Library (MFC), version 2.5
//
// Purpose: This file declares the fdBitmap class, which is derived from the
//          MFC CBitmap class to provide additional information about a bitmap
//          and a storage/retrieval mechanism for utilizing a database table
//          for persistence of the bitmap.
//
// ****************************************************************************

#ifndef _DbBitmap_
#define _DbBitmap_

class dbBitmap : public CBitmap
{
    public:
        dbBitmap(void);
        virtual ~dbBitmap(void);
        
        int store(CDatabase*);          // stores the bitmap in the database
        
        int fetch(int id,CDatabase*);   // retrieve a bitmap from the database
                                        // by it's unique identifier
        
        CString& qryDescr(void)         // accessor to description
            { return(szDescr); }
            
        int& qryID(void)                // accessor to identifier
            { return(iBmpID); }
        
        BOOL ReadBmpFile(CString&);     // load a bitmap from a file
            
    protected:
        int         iBmpID;             // bitmap identifier
        CString     szDescr;            // user defined description
        

};




#endif  // _DbBitmap_ 




