#define VIDEO_FILENAME  "c:\\windows\\help\\sizewin.avi"

#define STRICT

#include <windows.h>
#include <windowsx.h>
#include <digitalv.h>
#include "video.h"

#ifdef WIN32
	#define CMD_HWND	lParam
	#define CMD_CODE	HIWORD(wParam)

	#define SCR_CODE	LOWORD(wParam)
	#define SCR_POS	HIWORD(wParam)
#else
	#define CMD_HWND	LOWORD(lParam)
	#define CMD_CODE	HIWORD(lParam)

	#define SCR_CODE	wParam
	#define SCR_POS	LOWORD(lParam)
#endif

HINSTANCE	hInst;
MCIDEVICEID mciDeviceID;
HWND hwndPlay, hwndScroll, hwndStretch, hwndLoop, hwndText;
BOOL fPlaying, fStretch, fLoop;
char szWork[32];

LRESULT FAR PASCAL MainWndProc(HWND hwnd, UINT message,
										WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	HBRUSH hbr;
	PAINTSTRUCT ps;
	RECT rcClient;
	
	switch (message)
   {
		case WM_CREATE:
         
			fPlaying = FALSE;
			fStretch = FALSE;
			fLoop		= FALSE;

         mciDeviceID = videoOpen(VIDEO_FILENAME, hwnd,
         								NULL, hwnd);
         
         if (!mciDeviceID)
         {
            MessageBox(hwnd, "Could not open video.",
            		 "Error", MB_ICONEXCLAMATION | MB_OK);
            return -1;
         }      
			
			hwndPlay = CreateWindow("BUTTON", "Play",
							WS_CHILD | WS_VISIBLE,
							10, 300, 75, 30, hwnd,
							NULL, hInst, NULL);

			hwndScroll = CreateWindow("SCROLLBAR", "",
				WS_CHILD | WS_VISIBLE | SBS_HORZ | SBS_TOPALIGN,
							100, 300, 100, 30, hwnd,
							NULL, hInst, NULL);

		   hwndStretch = CreateWindow("BUTTON", "Stretch",
		    	WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
							10, 350, 75, 30, hwnd,
							NULL, hInst, NULL);

		   hwndLoop = CreateWindow("BUTTON", "Loop",
		   	WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
							100, 350, 75, 30,
							hwnd, NULL, hInst, NULL);
		   
		   hwndText = CreateWindow("STATIC", "Frame: 0",
		    				WS_CHILD | WS_VISIBLE,
							10, 400, 75, 30, hwnd,
							NULL, hInst, NULL);
		   
		   SetScrollRange(hwndScroll, SB_CTL, 0,
		   	 		videoGetFrameCount(mciDeviceID), TRUE);
		   
		   break;

		case WM_COMMAND:
			
			if ( CMD_CODE == BN_CLICKED )
			{
				if ( (HWND)CMD_HWND == hwndPlay)
				{
					if (fPlaying)
					{					
						videoStop(mciDeviceID);
						SetWindowText(hwndPlay, "Play");
						fPlaying = FALSE;
					}
					else
					{
						videoPlay(mciDeviceID, hwnd, fLoop);
						SetWindowText(hwndPlay, "Stop");
						fPlaying = TRUE;
					}
				}
				else
				{
					if ( (HWND)CMD_HWND == hwndLoop )
					{
						fLoop = Button_GetCheck(hwndLoop);
					}
					else
					{
						if ( (HWND)CMD_HWND == hwndStretch )
						{
							RECT rcVideo;
							
							videoClose(mciDeviceID);
							fPlaying = FALSE;
							SetWindowText(hwndPlay, "Play");

							fStretch =
								 Button_GetCheck(hwndStretch);

				         SetRect(&rcVideo, 10, 10, 290, 270);
				         
				         mciDeviceID = videoOpen(VIDEO_FILENAME,
	         				hwnd, fStretch ? &rcVideo : NULL,
	         				hwnd);
						   
						   SetScrollRange(hwndScroll, SB_CTL, 0,
						   	videoGetFrameCount(mciDeviceID),
						   	TRUE);

							RedrawWindow(hwnd, NULL, NULL,
							 			RDW_ERASE | RDW_UPDATENOW);
						}
					}
				}
			}

			break;
		
		case WM_HSCROLL:
	
			switch (SCR_CODE)
			{
				case SB_LINELEFT:
					SetScrollPos(hwndScroll, SB_CTL,
						GetScrollPos(hwndScroll, SB_CTL) - 1,
						TRUE);
					break;

				case SB_LINERIGHT:
					SetScrollPos(hwndScroll, SB_CTL,
						GetScrollPos(hwndScroll, SB_CTL) + 1,
						TRUE);
					break;

				case SB_PAGELEFT:
					SetScrollPos(hwndScroll, SB_CTL,
						GetScrollPos(hwndScroll, SB_CTL) - 10,
						TRUE);
					break;

				case SB_PAGERIGHT:
					SetScrollPos(hwndScroll, SB_CTL,
						GetScrollPos(hwndScroll, SB_CTL) + 10,
						TRUE);
					break;
  
				case SB_THUMBTRACK:
					SetScrollPos(hwndScroll, SB_CTL,
						SCR_POS, TRUE);
					break;

				case SB_THUMBPOSITION:
					SetScrollPos(hwndScroll, SB_CTL,
						SCR_POS, TRUE);
					break;

			}

			videoSeek(mciDeviceID,
				GetScrollPos(hwndScroll, SB_CTL));

			wsprintf(szWork, "Frame: %i",
						videoGetCurrentFrame(mciDeviceID));
			SetWindowText(hwndText, szWork);

			SetWindowText(hwndPlay, "Play");
			fPlaying = FALSE;
			
			break;

		case MM_MCISIGNAL:

			SetScrollPos(hwndScroll, SB_CTL, lParam, TRUE);

			wsprintf(szWork, "Frame: %i",
						videoGetCurrentFrame(mciDeviceID));
			SetWindowText(hwndText, szWork);

			break;
		
		case MM_MCINOTIFY:
			
			fPlaying = FALSE;
			SetWindowText(hwndPlay, "Play");
			
			break;

		case WM_PAINT:

			hdc = BeginPaint(hwnd, &ps);
			
			hbr = CreateSolidBrush(GetSysColor(COLOR_WINDOW));
			GetClientRect(hwnd, &rcClient);
			FillRect(hdc, &rcClient, hbr);
			DeleteBrush(hbr);
			
			videoUpdate(mciDeviceID, hdc);

			EndPaint(hwnd, &ps);
			
			return 0;

		case WM_QUIT:
		case WM_DESTROY:					
			
         videoClose(mciDeviceID);			

			PostQuitMessage(0);

			break;
	}

	return DefWindowProc(hwnd, message, wParam, lParam);
}

BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style = CS_HREDRAW | CS_VREDRAW;					
	wc.lpfnWndProc = (WNDPROC) MainWndProc;			
	wc.cbClsExtra = 0;									
	wc.cbWndExtra = 0;									
	wc.hInstance = hInstance;							
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszMenuName = NULL;					
	wc.lpszClassName = "VIDTEST";							

	return (RegisterClass(&wc));
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hwnd;

	hInst = hInstance;

	hwnd = CreateWindow("VIDTEST", "Video Test",
				WS_OVERLAPPEDWINDOW,
				CW_USEDEFAULT, CW_USEDEFAULT,	   	
				CW_USEDEFAULT,	CW_USEDEFAULT, 		
				NULL, NULL,	hInstance, NULL);

	if (!hwnd)
		return (FALSE);

	ShowWindow(hwnd, nCmdShow | SW_MAXIMIZE);
	UpdateWindow(hwnd);		

	return (TRUE);				
}

int PASCAL WinMain(HINSTANCE hInstance,
						 HINSTANCE hPrevInstance,
						 LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if (!hPrevInstance)						
		if (!InitApplication(hInstance))	
			return (FALSE);			

	if (!InitInstance(hInstance, nCmdShow))
		return (FALSE);

	while (GetMessage(&msg,NULL,0,0))				
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}
