Listing 1: bug1295.cpp

//
// The following program produces different results depending on
// whether it is compiled with Borland's 16- or 32-bit compiler.
// When compiled in 32-bit mode, it apparently performs sign
// extension on the characters being compared by strcmpi(), meaning high
// bit ASCII characters as used in IBM PC machines will have problems.
// In this case, a Spanish  character is compared to a string, with
// two different results for two different compilers.
//
// There are two problems here.  The first is that the compiler
// changes behavior between the 16- and 32-bit compiler.  The
// RTL documentation also indicates that this function performs
// an unsigned compare, which doesn't seem to be the case.
//
// To cloud matters further, the Borland C++ documentation indicates
// that strcmpi is part of the ANSI C++ standard, but this doesn't
// seem to have actually made it to the CD.
//

#include <iostream.h>
#include <string.h>

void main()
{
#ifdef __WIN32__
    cout << "In 32-bits: ";
#else
    cout << "In 16-bits: ";
#endif

    char *s1 = "\xa4";   // (N with tilde), as used in Spanish
    char *s2 = "Test";   //A string with all character codes <128

    int result = strcmpi( s1, s2 );
    if ( result == 0 )
        cout << s1 << " == " << s2;
    else if ( result < 0 )
        cout << s1 << " < " << s2;
    else
        cout << s1 << " > " << s2;
    cout << endl;
}
