// testmdoc.cpp : implementation of the CTestmdiDoc class
//

#include "stdafx.h"
#include "testmdi.h"
#include "testmdoc.h"

#include "tv1.h"
#include "tv2.h"
#include "tv3.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestmdiDoc

IMPLEMENT_DYNCREATE(CTestmdiDoc, CDocument)

BEGIN_MESSAGE_MAP(CTestmdiDoc, CDocument)
    //{{AFX_MSG_MAP(CTestmdiDoc)
    ON_COMMAND(IDD_TESTVIEW_FORM1, OnTestviewForm1)
    ON_COMMAND(IDD_TESTVIEW_FORM2, OnTestviewForm2)
    ON_COMMAND(IDD_TESTVIEW_FORM3, OnTestviewForm3)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestmdiDoc construction/destruction

CTestmdiDoc::CTestmdiDoc()
{
    v1 = v2 = v3 = NULL ;
}

CTestmdiDoc::~CTestmdiDoc()
{
}

BOOL CTestmdiDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

    v1 = v2 = v3 = NULL ;

    POSITION fp = GetFirstViewPosition() ;
    v1 = GetNextView(fp) ;

    CMDIMultiViewChildWnd *mvf =
                    (CMDIMultiViewChildWnd *)
                                    (v1->GetParentFrame());

    if (v2 == NULL) {

        CCreateContext context;
        context.m_pCurrentFrame = NULL ;
        context.m_pCurrentDoc = this;
        context.m_pNewViewClass =
                        RUNTIME_CLASS(CTestviewView2) ;
        context.m_pNewDocTemplate = GetDocTemplate();

        v2 = (CView *)(mvf->AddView(&context)) ;

    }

    if (v3 == NULL) {

        CMDIMultiViewChildWnd *nv ;
        CMDIFrameWnd *pf = mvf->GetMDIFrame() ;

        nv = (CMDIMultiViewChildWnd *)
                (RUNTIME_CLASS(
                  CMDIMultiViewChildWnd)->CreateObject()) ;

        CCreateContext context;
        context.m_pCurrentFrame = NULL ;
        context.m_pCurrentDoc = this;
        context.m_pNewViewClass =
                    RUNTIME_CLASS(CTestviewView3) ;
        context.m_pNewDocTemplate = GetDocTemplate();

        nv->LoadFrame(IDR_TESTMDTYPE,
                      WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
                      pf,
                      &context) ;
        
        v3 = (CView *)
               (nv->GetDescendantWindow(AFX_IDW_PANE_FIRST,
                                        TRUE));

        GetDocTemplate()->InitialUpdateFrame( nv,
                                              this,
                                              FALSE);

    }

    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CTestmdiDoc serialization

void CTestmdiDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
    }
    else
    {
        // TODO: add loading code here
    }
}

/////////////////////////////////////////////////////////////////////////////
// CTestmdiDoc diagnostics

#ifdef _DEBUG
void CTestmdiDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CTestmdiDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestmdiDoc commands

void CTestmdiDoc::OnTestviewForm1()
{
    // GetParentFrame is not virtual,
    // so we must cast to CMulitViewWnd
    CMDIMultiViewChildWnd *pf =
                (CMDIMultiViewChildWnd *)
                        (v1->GetParentFrame()) ;

    pf->SetActiveView(v1) ;
    
}

void CTestmdiDoc::OnTestviewForm2()
{
    // GetParentFrame is not virtual,
    // so we must cast to CMulitViewWnd
    CMDIMultiViewChildWnd *pf =
                (CMDIMultiViewChildWnd *)
                        (v2->GetParentFrame()) ;

    pf->SetActiveView(v2) ;
    
}

void CTestmdiDoc::OnTestviewForm3()
{
    // GetParentFrame is not virtual,
    // so we must cast to CMulitViewWnd
    CMDIMultiViewChildWnd *pf =
                (CMDIMultiViewChildWnd *)
                        (v3->GetParentFrame()) ;

    pf->SetActiveView(v3) ;
    
}

