//
// BUG0196.CPP
//
// This program demonstrates a multiplication bug in VC++
// 2.1 and 2.2.  The bug has nothing to do with templates,
// the template class is used only to demonstrate the bug
// with a range of different input numbers.  In this
// particular example, mul<i>(0x20) should always return i,
// but fails to do so for particular values of i, including
// 7, 11, 13, 14, 17, and 19.  Inspection of the assembly
// code reveals that it is a code generation bug.  The bug
// only appears when compiling with the global optimization
// switch set. This will occur when using /Ox, /Og, /O2,
// and various other options.
//

#include <iostream.h>

template<int i>
struct mul {
    inline int operator()( unsigned char &a )
    {
        return ( a >> 5 ) * i;
    }
};

unsigned char a = 0x20;

int main()
{
    cout << mul< 1>()( a ) << endl;
    cout << mul< 2>()( a ) << endl;
    cout << mul< 3>()( a ) << endl;
    cout << mul< 4>()( a ) << endl;
    cout << mul< 5>()( a ) << endl;
    cout << mul< 6>()( a ) << endl;
    cout << mul< 7>()( a ) << endl;
    cout << mul< 8>()( a ) << endl;
    cout << mul< 9>()( a ) << endl;
    cout << mul<10>()( a ) << endl;
    cout << mul<11>()( a ) << endl;
    cout << mul<12>()( a ) << endl;
    cout << mul<13>()( a ) << endl;
    cout << mul<14>()( a ) << endl;
    cout << mul<15>()( a ) << endl;
    cout << mul<16>()( a ) << endl;
    cout << mul<17>()( a ) << endl;
    cout << mul<18>()( a ) << endl;
    cout << mul<19>()( a ) << endl;
    return 1;
}
