// microTimer.cpp: A C++ class for microsecond timer services.
// Works only under Visual C++
// Written by Trevor Harmon, 73771.3307@compuserve.com

#include "microTimer.hpp"


microTimer::microTimer()
{
	StartTime.LowPart = 0;
	StartTime.HighPart = 0;

	QueryPerformanceFrequency(&Frequency);
}


void
microTimer::Start()
{
   QueryPerformanceCounter(&StartTime);
}


DWORD
microTimer::GetElapsedTime()
{
   LARGE_INTEGER Elapsed, Remainder;

   QueryPerformanceCounter(&Elapsed);

   // Determine the number of clock ticks that have elapsed
   // by subtracting the start time from the elapsed time.
   Elapsed = LargeIntegerSubtract(Elapsed, StartTime);
   
   // Because we're dealing with integers, multiply the
	// elapsed time by 1000000 before dividing it. This will
	// prevent problems in getting a fractional number.
   Elapsed = ExtendedIntegerMultiply(Elapsed, 1000000);
   
   // Divide the clock ticks by the frequency to determine
	// the number of microseconds that have elapsed.
   Elapsed = LargeIntegerDivide(Elapsed, Frequency, &Remainder);

   return Elapsed.LowPart;
}
