//
// cstrtok.cpp: strtok-like function for C++
//              (with a test driver)
//

#define TEST

#include "cstrtok.h"

TStringToken::TStringToken (const string& s1, const string& s2) :
TArray<string> (0, 1, 1) {
    size_t Last_Pos = s1.find_first_not_of (s2);
    if (Last_Pos != NPOS)
    {
       size_t Curr_Pos = s1.find_first_of (s2, Last_Pos);

       while (Curr_Pos != NPOS)
       {
          Add (string (s1.substr (Last_Pos, Curr_Pos - Last_Pos)));
          Last_Pos = s1.find_first_not_of (s2, Curr_Pos); Curr_Pos =
          s1.find_first_of (s2, Last_Pos);
       }
       if (Last_Pos < s1.length ())
          Add (string (s1.substr (Last_Pos)));
    }
}

#ifdef TEST

#include <iostream.h>

void
main ()
{
    TStringToken s ("Mary has, , a very   little lamb", " ,");
    TStringToken b ("Now Mary has, , a very   big elephant ", " ,");
    TStringTokenIterator i (s);
    TStringTokenIterator j (b);

    while (i)
    {
        cout << '|' << i.Current () << '|' << endl;
        i++;
    }

    while (j)
    {
        cout << '|' << j.Current () << '|' << endl;
        j++;
    }
}
#endif

