/* include.c */
/* Builds a dependency list */

#include <dir.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>

#define FALSE 0
#define TRUE 1

unsigned long total_lines = 0;
char buffer[132],buffer2[18], buffer3[6];

int get_dependencies (char *filename)
{

/*
 * Searches C source file for #include directives with "
 * (quotes) as delimiters.
 * Don't run INCLUDE on itself.
 */

  char *objfilename, *objext;
  char *inline, *ptr;
  FILE *infile;
  unsigned int lines = 0;
  int dependencies = 0;
  int header_file;

  #define delimiters "\""

  if ((infile = fopen (filename,"rt")) != NULL)
  {
    /* Create the target file name */
    objfilename = &buffer2[0];
    objext = &buffer3[0];
    objfilename = strcpy (objfilename,filename);
    if (strstr(filename,".C") != NULL)
    {
      strcpy(objext,".obj");
      header_file = FALSE;
    }
    else
    {
      strcpy(objext,".h");
      header_file = TRUE;
    }
    objfilename = strcat (strtok (objfilename,"."),objext);
    printf ("%s:",objfilename);

    /* Avoid circular dependencies for header files */
    if (header_file == FALSE)
      printf ("\t%s",filename);

    /* Read the source file */
    while (!feof(infile))
    {
      inline = &buffer[0];
      fgets (inline,131,infile);

      /* If this line has an include directive */
      if (strstr (inline,"#include") != NULL) 
      {
        /* Extract the filename from the directive */
        strtok (inline,delimiters);
        ptr = strtok (NULL,delimiters);

        /* Add the dependency to the list */
        if (ptr != NULL)
        {
          printf (" \\\n\t\t%s",ptr);
          dependencies++;
        }
      }
      if (strlen (inline) > 0)
        lines++;
    }
    fclose (infile);

    /* Use touch to update the timestamp on dependent header files */
    if ((header_file == TRUE) && (dependencies > 0))
      printf (" \n\t\t$(TOUCH)");

    /* Print the number of lines read */
    printf ("\n# (%u Lines)\n",lines);
    total_lines += lines;
  }
  else
    puts ("Unable to open file");
  return dependencies;
}

void main (void)
{
  char buffer[132], *filename;
  struct ffblk ffblk;
  int done;
  int i;
  unsigned total_files = 0;

  filename = &buffer [0];

  printf ("# Dependency list generated by INCLUDE\n\n");

  /* List the highest level of dependency,
     the executeable and objects. */

  total_files = 0;
  printf ("$(PROJECT).exe :\t");
  strcpy (filename,"*.c");
  done = findfirst (filename,&ffblk,0);
  while (!done)
  {
    printf ("%.*s.obj",done = strlen(&ffblk.ff_name[0])-2,ffblk.ff_name);
    done = findnext (&ffblk);
    if (!done)
      printf (" \\\n\t\t");
  }
  printf ("\n\t\t$(LINKCMD)\n\n");

  for (i = 0; i < 2; i++)
  {
    switch (i)
    {
      case 0:
        /* Get the C file dependencies */
        strcpy (filename,"*.c");
        break;
      case 1:
        /* Get the header file dependencies */
        strcpy (filename,"*.h");
        break;
    }
    done = findfirst (filename,&ffblk,0);
    while (!done)
    {
      total_files++;
      get_dependencies (ffblk.ff_name);
      printf ("\n");
      done = findnext (&ffblk);
    }
  }

  printf ("# (%u Files)\n",total_files);
  printf ("# (%lu Total Lines)\n\n",total_lines);
  return;
}
