* objlist.c                                                */
/* Lists object files to be linked (one for every .C file)  */
/* usage: objlist memory_code > ojblist                     */

#include <dir.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>

char buf1 [132], buf2 [132];

void main (int argc,char *argv[])
{
  char *filename, *model;
  struct ffblk ffblk;
  int done;

  filename = &buf1 [0];
  model = &buf2 [0];

  /*
   * Many compilers require an initialization or library module.
   * Refer to the compiler documentation.
   */
  if (argc < 2)
  {
    printf ("Enter memory model (t,s,c,m,l,h): ");
    gets (model);
  }
  else
    strcpy (model,argv[1]);
  printf ("\\turboc\\lib\\c0%1c.obj +\n",*model);

  /* Search the directory for .C files,
     add an .OBJ entry for each one */

  strcpy (filename,"*.c");
  done = findfirst (filename,&ffblk,0);
  while (!done)
  {
    printf ("%.*s.obj",strlen(&ffblk.ff_name[0])-2,ffblk.ff_name);
    done = findnext (&ffblk);
    if (!done)
      printf (" +\n");
  }
  printf ("\n");
}

