// program to test time_fns.asm functions
// Mike Dawdy
// 76275.700@compuserve.com
// http://ourworld.compuserve.com/homepages/Mike_Dawdy

#include <stdio.h>
#include <stdlib.h>

#define LOOPS 15

unsigned      init_time (void);    // function prototypes
void          start_time(void);
unsigned long read_time (void);
void          reset_time(void);

void main(int argc, char *argv[])
{
extern unsigned      pit_latch;    // 8253/4 counter latch register
extern unsigned char pic_irr;      // 8259A interrupt request register

unsigned long process_time[LOOPS],
              arb_number,          // input, arbitrary number
              null_time;           // time for no process

unsigned char irr[LOOPS];

unsigned      latch[LOOPS],        // actual value from counter latch
              isr_time,            // time for interrupt service routine
              j,                   // outer loop control variable
              k;                   // inner loop control variable

if (argc != 2)
   {
   printf("time_tst arbitrary_number\n");
   exit(1);
   }
arb_number = atol(argv[1]);
isr_time = init_time();            // must be called first, once
start_time();                      // time no process at all
null_time = read_time();
printf ("Arbitrary number = %ld, Null time = %ld, ISR time = %u\n",
         arb_number, null_time, isr_time);

start_time();
for (j=0; j<LOOPS; j++)
    {
    for (k=0; k<arb_number; k++)   // process to be timed
        ;
    process_time[j] = read_time(); // subtract null_time to
    latch[j]        = pit_latch;   // get actual time 
    irr[j]          = pic_irr;
    }
reset_time();                      // must be called last, once

printf("Process Time\tPIT Latch\tPIC IRR\n");
for (j=0; j<LOOPS; j++)
   printf("%.8lu\t%.5u\t\t0x%.2x\n", process_time[j], latch[j], irr[j]);
}

