  1: // mainfrm.cpp : implementation of the CMainFrame class (TOOLLIST App)
  2: //
  3: 
  4: #include "stdafx.h"
  5: #include "toollist.h"
  6: 
  7: #include "mainfrm.h"
  8: 
  9: #ifdef _DEBUG
 10: #undef THIS_FILE
 11: static char BASED_CODE THIS_FILE[] = __FILE__;
 12: #endif
 13: 
 14: //////////////////////////////////////////////////////////////////////////
 15: // CMainFrame
 16: 
 17: IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)
 18: 
 19: BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
 20:     //{{AFX_MSG_MAP(CMainFrame)
 21:         // NOTE - the ClassWizard will add and remove mapping macros here.
 22:         //    DO NOT EDIT what you see in these blocks of generated code !
 23:     ON_WM_CREATE()
 24:     //}}AFX_MSG_MAP
 25:     // Global help commands
 26:     ON_COMMAND(ID_HELP_INDEX, CMDIFrameWnd::OnHelpIndex)
 27:     ON_COMMAND(ID_HELP_USING, CMDIFrameWnd::OnHelpUsing)
 28:     ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
 29:     ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
 30:     ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpIndex)
 31: END_MESSAGE_MAP()
 32: 
 33: ///////////////////////////////////////////////////////////////////////////
 34: // arrays of IDs used to initialize control bars
 35: 
 36: // toolbar buttons - IDs are command buttons
 37: static UINT BASED_CODE buttons[] =
 38: {
 39:     // same order as in the bitmap 'toolbar.bmp'
 40:     ID_FILE_NEW,
 41:     ID_FILE_OPEN,
 42:     ID_FILE_SAVE,
 43:         ID_SEPARATOR,
 44:     ID_EDIT_CUT,
 45:     ID_EDIT_COPY,
 46:     ID_EDIT_PASTE,
 47:         ID_SEPARATOR,
 48:     ID_FILE_PRINT,
 49:     ID_APP_ABOUT,
 50:     ID_CONTEXT_HELP, 
 51:         ID_SEPARATOR,       // Separate combobox from other part of toolbar 
 52:         ID_SEPARATOR,       // Add this place holder for combo box  
 53: };
 54: 
 55: const int INDEX_DROPLIST =   //  Location for DropList
 56:                 sizeof(buttons)/sizeof(UINT) - 1 ;
 57: 
 58: static UINT BASED_CODE indicators[] =
 59: {
 60:     ID_SEPARATOR,           // status line indicator
 61:     ID_INDICATOR_CAPS,
 62:     ID_INDICATOR_NUM,
 63:     ID_INDICATOR_SCRL,
 64: };
 65: 
 66: //////////////////////////////////////////////////////////////////////////
 67: // CMainFrame construction/destruction
 68: 
 69: CMainFrame::CMainFrame()
 70: {
 71:     // TODO: add member initialization code here
 72: }
 73: 
 74: CMainFrame::~CMainFrame()
 75: {
 76: }
 77: 
 78: int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
 79: {
 80:     if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
 81:         return -1;
 82: 
 83:     if (!m_wndToolBar.Create(this) ||
 84:         !m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
 85:         !m_wndToolBar.SetButtons(buttons,
 86:           sizeof(buttons)/sizeof(UINT)))
 87:     {
 88:         TRACE("Failed to create toolbar\n");
 89:         return -1;      // fail to create
 90:     }   
 91:     
 92:     
 93:     // Below we create combo box
 94:     CRect rect;
 95:     m_wndToolBar.GetItemRect(INDEX_DROPLIST, &rect);
 96:     int cyFit = rect.Height();
 97:     rect.top = 1;   // 1 pixel down from top of statusbar
 98:     rect.right = rect.left + 150;
 99:     rect.bottom = rect.top + 200;       // drop height
100: 
101:     if (!m_cboxDrop.Create(
102:         WS_CHILD|WS_BORDER|WS_VISIBLE|CBS_DROPDOWNLIST|CBS_SORT|WS_VSCROLL,
103:         rect, &m_wndToolBar, IDC_COMBOLIST))
104:     {
105:         TRACE("Failed to create combobox inside toolbar\n");
106:         return -1;      // fail to create
107:     }
108: 
109:     // load status bar font
110:     LOGFONT logfont;
111:     memset(&logfont, 0, sizeof(logfont));
112: 
113:     // 13 pixel high Sans Serif font
114:     logfont.lfHeight = -13;
115:     logfont.lfWeight = FW_NORMAL;
116:     logfont.lfPitchAndFamily = VARIABLE_PITCH | FF_SWISS;
117:     static char BASED_CODE szFaceName[] = "MS Sans Serif";
118:     lstrcpy(logfont.lfFaceName, szFaceName);
119: 
120:     if (m_fontDrop.CreateFontIndirect(&logfont))
121:     {
122:         m_cboxDrop.SetFont(&m_fontDrop, FALSE);
123:                 // no need to redraw since invisible
124:     }
125:     
126:     SetComboList () ;
127:     
128:     
129:     if (!m_wndStatusBar.Create(this) ||
130:         !m_wndStatusBar.SetIndicators(indicators,
131:           sizeof(indicators)/sizeof(UINT)))
132:     {
133:         TRACE("Failed to create status bar\n");
134:         return -1;      // fail to create
135:     }
136: 
137:     return 0;
138: }
139: 
140: ///////////////////////////////////////////////////////////////////////////
141: // CMainFrame diagnostics
142: 
143: #ifdef _DEBUG
144: void CMainFrame::AssertValid() const
145: {
146:     CMDIFrameWnd::AssertValid();
147: }
148: 
149: void CMainFrame::Dump(CDumpContext& dc) const
150: {
151:     CMDIFrameWnd::Dump(dc);
152: }
153: 
154: #endif //_DEBUG
155: 
156: ///////////////////////////////////////////////////////////////////////////
157: // CMainFrame message handlers
158:                                 
159:                                 
160: const int MAX_ITEMS = 20 ;
161: 
162: ///////////////////////////////////////////////////////////////////////////
163: // @mfunc Fills combo box on the top of main window with tenant names
164: //
165: void CMainFrame::SetComboList () 
166: {   
167:     m_cboxDrop.ResetContent () ;
168:     for ( int i = 0 ; i < MAX_ITEMS; i++ ) 
169:     {   // Form record and add it to the combo box 
170:         char szBuf [ 80 ] ;
171:         wsprintf (szBuf, "%d", i) ;
172:                    
173:         int index = m_cboxDrop.AddString(szBuf);
174:         m_cboxDrop.SetItemData(index, i); // Set Item ID
175:     }   
176: 
177:     m_cboxDrop.SetCurSel( 0 );   
178: }
179:                                           
180: ///////////////////////////////////////////////////////////////////////////
181: // Returns selected item's ID
182: //                                          
183: int CMainFrame::GetSelItemID () 
184: {
185:     return (int)m_cboxDrop.GetItemData(m_cboxDrop.GetCurSel());
186: }                  
187:                                           
