// mdichild.cpp : implementation file
//

#include "stdafx.h"
#include "toollist.h"
#include "mdichild.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMDIChildFrame

IMPLEMENT_DYNCREATE(CMDIChildFrame, CMDIChildWnd)

CMDIChildFrame::CMDIChildFrame()
{
}

CMDIChildFrame::~CMDIChildFrame()
{
}


BEGIN_MESSAGE_MAP(CMDIChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CMDIChildFrame)
	ON_UPDATE_COMMAND_UI(IDC_COMBOLIST, OnUpdateComboList)
	ON_CBN_SELCHANGE(IDC_COMBOLIST, OnComboListChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
                     
                     
                     
//////////////////////////////////////////////////////////////////////////////
//  We override CMDIChildWnd to customize the MDI child's title bar.
//  By default the title bar shows the document name.  But we want
//  it to instead show the text defined as the first string in
//  the document template STRINGTABLE resource.  This string is
//  "Toollist" in the case of the MDI child window
//  view.If we didn't customize the title bar, the MDI child windows would
//  show "Toollist:1" and "Toollist:2" if the document were named "Toollist".
//
BOOL CMDIChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// By turning off the default MFC-defined FWS_ADDTOTITLE style,
	// the framework will use first string in the document template
	// STRINGTABLE resource instead of the document name.   

	cs.style &= ~(LONG)FWS_ADDTOTITLE;  
	
	return CMDIChildWnd::PreCreateWindow(cs);
}
                     
                     

/////////////////////////////////////////////////////////////////////////////
// CMDIChildFrame message handlers




/////////////////////////////////////////////////////////////////////////////
// Called when the user changes selection in the combo list box
//
void CMDIChildFrame::OnComboListChange()
{
	CComboBox* pDrop = (CComboBox*)CWnd::FromHandle(
					(HWND)LOWORD(GetCurrentMessage()->lParam));

	ASSERT(pDrop != NULL);
	ASSERT(pDrop->IsKindOf(RUNTIME_CLASS(CWnd)));

	// Get active view
	CView* pActiveView = GetActiveView () ;
	
	ASSERT (pActiveView != NULL) ;
	                          
	LPARAM lItemID = (LPARAM)pDrop->GetItemData(pDrop->GetCurSel());
	// Send selected Item ID to the active view. 
	// FALSE means set Item ID in active view (later we will use TRUE to retrieve it from view)
	pActiveView -> SendMessage (UWM_ON_COMBO_LIST_UPDATE, FALSE, lItemID ) ;

}



/////////////////////////////////////////////////////////////////////////////
// Called by the framework to update combo list box
//
void CMDIChildFrame::OnUpdateComboList(CCmdUI* pCmdUI)
{
	ASSERT(pCmdUI->m_pOther != NULL);

	// Get active view
	CView* pActiveView = GetActiveView () ;
	
	// Get selected Item ID. 
	// TRUE means to get the ID 
	int iItemID ;
	pActiveView -> SendMessage (UWM_ON_COMBO_LIST_UPDATE, TRUE, (LPARAM)&iItemID ) ;

	// pCmdUI->m_pOther is not the real CWnd, even if it has been attached
	// to a permanent CWnd.  Therefore, compare hWnds, not pointers
	CComboBox* pCombo = (CComboBox*)pCmdUI->m_pOther;
	if (pCombo->m_hWnd == ::GetFocus())
		return;

	for (int i = 0; i < pCombo->GetCount(); i++)
	{
		if ((int)pCombo->GetItemData(i) == iItemID )
		{
			if (pCombo->GetCurSel() != i)
				pCombo->SetCurSel(i);
			return;
		}
	}
}



/////////////////////////////////////////////////////////////////////////////
// Sets caption on MDI Child view windows
//
void CMDIChildFrame::SetCaption (
			char*  pszTitle,  // Caption prefix string
			int    iItemID    // Item ID
				) 
{	
	char szTitle [ 255 ] ;
	lstrcpy (szTitle, pszTitle) ;
	
	char szSuffix [ 10 ] ;
	wsprintf (szSuffix, "%d", iItemID) ;
	
	lstrcat (szTitle, szSuffix) ;
	
	SetWindowText (szTitle) ;
}
