// multrack.h
#ifndef __MULTRACK_H__
#define __MULTRACK_H__

class CMultipleRectTracker : public CObject
{
   struct CRectTrackerTag 
   {
      CRectTracker   *m_pTracker;
      BOOL           m_bSelected;
      CRect          m_rectLast;		// for tracking purposes
      CRect          m_rectSave;    // for escaping tracking
   };

public:
   CMultipleRectTracker();	// default constructor
   ~CMultipleRectTracker();
   int      AddTracker(CRectTracker *);
   void     RemoveTracker(int);
   void     Select(int, BOOL bSelected = TRUE);
   void     UnselectAll();
   void     ClipTo(CWnd *pWnd){m_pWndClipTo = pWnd;}
   int      NumSelected() const;
   int      GetMaxID() const {return m_arrayTrackers.GetSize();}
   int      GetCount() const;
   CRectTracker   *GetTrackerFromID(int) const;
   BOOL     IsSelected(int) const;
   BOOL     IsMultiTracking() const {return m_bMultiTracking;}
   int      GetTrackerIDAtPoint(CPoint) const;
   virtual void   Draw(CDC *pDC);
   virtual void   HandleLButtonDown(CWnd *, UINT, CPoint);
   virtual BOOL   HandleSetCursor(CWnd *, UINT) const;
   virtual void   OnChangingRects(int &x, int &y);

protected:
   CWnd     *m_pWndClipTo;
   BOOL     m_bMultiTracking;
   BOOL     m_bErase, m_bFinalErase;
   CPtrArray m_arrayTrackers;
   BOOL     MultiTrack(CWnd *pWnd, CPoint, CWnd *);
   void     DrawTrackerRect(LPCRECT, CWnd*, CDC*, CWnd*, CRect &);
};
#endif
