//------------------------------------------------------------------
//  DbWin32 console mode demo - compile with "cl dbwin32c.c"
//------------------------------------------------------------------
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include "dbwin.h"

HANDLE   _hDevice;
HANDLE   _hEvent;

//------------------------------------------------------------------
DWORD CallBackThread(LPDWORD lpdwParam);
void  _stdcall Ring3Proc(LPNOTIFYINFO pNotifyInfo);

//------------------------------------------------------------------

int main(int argc, char *argv[])
{
    DWORD     dwID, dwParm = 0L;
    HANDLE    hThread;
    char     *szDevice = "\\\\.\\NOTIFY";

    printf("DbWin32c 1.00  Press any to quit\n");

    _hDevice = CreateFile(szDevice, 0, 0, NULL, 0, 0, NULL);
    if (_hDevice == INVALID_HANDLE_VALUE) {
        printf("Unable to load %s\n", szDevice);
        return 0;
    }
    _hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

    if ((hThread = CreateThread(NULL, 0,
                    (LPTHREAD_START_ROUTINE)CallBackThread,
                    &dwParm, 0, &dwID)) == NULL) {
        printf("Unable to create thread\n");
        CloseHandle(_hEvent);
        CloseHandle(_hDevice);
        return 0;
    }
    
    _getch();                   // Wait for key press

    PulseEvent(_hEvent);        // Signal thread to terminate and
    WaitForSingleObject(hThread, INFINITE);     // wait for this

    CloseHandle(_hEvent);       // Close the event,
    CloseHandle(hThread);       //   thread,
    CloseHandle(_hDevice);      //   and device.
    
    return 0;
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

DWORD CallBackThread(LPDWORD lpdwParam)
{
    void (_stdcall *fnCallBack)(LPNOTIFYINFO) = Ring3Proc;

    if (DeviceIoControl(_hDevice, NOTIFY_REGISTERPROC,
                        &fnCallBack, sizeof(fnCallBack),
                        NULL, 0, NULL, NULL) == 0) {
        printf("Error: Failed to set callback\n");
        return 0;
    }

    // Place thread in an alertable wait state
    while (WaitForSingleObjectEx(_hEvent, INFINITE, TRUE) ==
                                                  STATUS_USER_APC) {
        // Released by _VWIN32_QueueUserApc, callback will be called
    }

    // Deregister the callback procedure.
    fnCallBack = NULL;
    DeviceIoControl(_hDevice, NOTIFY_REGISTERPROC,
            &fnCallBack, sizeof(fnCallBack), NULL, 0, NULL, NULL);

    return 0;
}

//------------------------------------------------------------------

void _stdcall Ring3Proc(LPNOTIFYINFO pNotifyInfo)
{
    // This is the notification callback function. We get called for
    // system events here (currently only for DS_Out_Str).
    
    printf("DS_Out_Str: %s\n", pNotifyInfo->szInfo);

    // Free the buffer
    DeviceIoControl(_hDevice, NOTIFY_DEALLOC_LIST,
            &pNotifyInfo, sizeof(pNotifyInfo), NULL, 0, NULL, NULL);

    return ;
}
