/*
    File: SmartVal.cpp
    Author: V.Ramachandran
    Date: September 18, 1996
*/

#include "stdafx.h"
#include "generic.h"
#include "smartval.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSmartValidationDlg dialog


CSmartValidationDlg::CSmartValidationDlg(CWnd* pParent /*=NULL*/)
    : ZDialog(CSmartValidationDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSmartValidationDlg)
    m_sEdit1 = _T("");
    m_sEdit2 = _T("");
    //}}AFX_DATA_INIT
}


void CSmartValidationDlg::DoDataExchange(CDataExchange* pDX)
{
    ZDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSmartValidationDlg)
    DDX_Control(pDX, IDC_ST_INFO, m_stInfo);
    DDX_Text(pDX, IDC_EDIT1, m_sEdit1);
    DDX_Text(pDX, IDC_EDIT2, m_sEdit2);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSmartValidationDlg, ZDialog)
    //{{AFX_MSG_MAP(CSmartValidationDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/***************************************************************/
// ZDialog virtual override. Call the base class to ensure 
// that both the windows belong to the same parent. If so, 
// check if the window gaining focus is IDCANCEL. If so, 
// don't do validation.
/***************************************************************/

BOOL CSmartValidationDlg::IsValidationReqd (HWND hWndLost, 
                            HWND hWndGain)
{
    BOOL bRet = ZDialog::IsValidationReqd (hWndLost, hWndGain);
    if (bRet) {
#ifndef WIN32
        if (::GetWindowWord (hWndGain, GWW_ID) == IDCANCEL)
#else
        if (::GetWindowLong (hWndGain, GWL_ID) == IDCANCEL)
#endif
            bRet = FALSE;
    }
    return bRet;
}

/***************************************************************/
// ZDialog virtual override. Do the validation here.
// hWndLost is the handle of the window losing focus.
// hWndGain is the handle of the window gaining focus.
// Return TRUE if validation is successful, FALSE Otherwise.
/***************************************************************/

BOOL CSmartValidationDlg::DoValidation (UINT nLostID)
{
    UpdateData ();
    int nVal;
    BOOL bRet = TRUE;

    switch (nLostID) {
        case IDC_EDIT1:
            nVal = atoi (m_sEdit1);
            if ((nVal < 0) || (nVal > 100))
                bRet = FALSE;
            break;
        case IDC_EDIT2:
            if (strlen (m_sEdit2) > 4)
                bRet = FALSE;
            break;
    }
    return bRet;
}

void CSmartValidationDlg::NotifyError (UINT nLostID)
{
    CString sMsg;
    MessageBeep (1);
    sMsg.Format ("Validation failed for field id: %d.", nLostID);
    m_stInfo.SetWindowText (sMsg);
}

void CSmartValidationDlg::OnOK() 
{
    DO_FIELD_VALIDATION(IDC_EDIT1);
    DO_FIELD_VALIDATION(IDC_EDIT2);
    ZDialog::OnOK();
}

