// TechTipView.h : interface of the CTechTipView class
//
/////////////////////////////////////////////////////////////////////////////

class CTechTipCntrItem;

class CTechTipView : public CTreeView
{
protected: // create from serialization only
	CTechTipView();
	DECLARE_DYNCREATE(CTechTipView)

// Attributes
public:
	CTechTipDoc* GetDocument();
	// m_pSelection holds the selection to the current CTechTipCntrItem.
	// For many applications, such a member variable isn't adequate to
	//  represent a selection, such as a multiple selection or a selection
	//  of objects that are not CTechTipCntrItem objects.  This selection
	//  mechanism is provided just to help you get started.

	// TODO: replace this selection mechanism with one appropriate to your app.
	CTechTipCntrItem* m_pSelection;


	HTREEITEM	m_DragSourceItem;
	IStorage*	m_pIStorage;
	HGLOBAL		m_hGlobal;
 	COleDropTarget m_dropTarget;

	
	HTREEITEM addTreeItem(
					HTREEITEM		hParentItem,
					CString			csItemText,
					int				nImage,
					int				nSelImage,
					long			lID
				  ); 

	HTREEITEM addTreeNode( HTREEITEM hTarget, 
                           CString    strName,
                           int        nImage,
                           int        nSelectedImage,
                           LPARAM     lID
                      );

	void serializeTVItem( CArchive&       ar, 
                          CString&        strName,
                          int&            nImage,
                          int&            nSelectedImage,
                          LPARAM&         lID
                          );

	BOOL readTreeBranch( IStorage* lpOpenStorage, 
						 HTREEITEM hTarget, 
						 CString csRoot 
						 );

	IStorage* serializeItem( HTREEITEM  hItem,
							  IStorage*  ppstg, 
							  BOOL       bCreateSubStorage 
						  );

	void serializeTree ( LPSTORAGE*  ppIStorage, 
						  HTREEITEM   hThisItem 
						 );

	BOOL copyTreeBranch ( HTREEITEM hRootItem 
						);


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTechTipView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL IsSelected(const CObject* pDocItem) const;// Container support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTechTipView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTechTipView)
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInsertObject();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in TechTipView.cpp
inline CTechTipDoc* CTechTipView::GetDocument()
   { return (CTechTipDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
