#define STRICT
#ifdef __BORLANDC__
#pragma comment(lib, "hwndproc.lib")
#endif

#include <windows.h>
#include <windowsx.h>
#include "HwndProc.h"
#include "appmain.rh"



// functions
static BOOL OnRefresh( HWND );
static VOID OnSelChange( HWND );


// callbacks
LRESULT CALLBACK APP_DlgProc( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK EnumWndProc( HWND, LPARAM );



INT APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevious,
     LPSTR lpsz, INT iCmd )
{
     return DialogBox( hInstance, "DLG_MAIN", 
         NULL, (DLGPROC)APP_DlgProc );
}



LRESULT CALLBACK APP_DlgProc( HWND hDlg, UINT uiMsg, 
	WPARAM wParam, LPARAM lParam )
{
   switch( uiMsg )
   {
       case WM_COMMAND:
          if( HIWORD(wParam)==LBN_SELCHANGE )
             OnSelChange( (HWND)lParam );
          switch( LOWORD(wParam) )		    
          {
              case IDOK:
                OnRefresh( hDlg );
                return 1;

              case IDCANCEL:
                EndDialog( hDlg, FALSE );
                return 0;
          }
          break;
    }
    return 0;
}



BOOL OnRefresh( HWND hDlg )
{
    HWND hwndList = GetDlgItem(hDlg,IDC_LISTBOX);

    ListBox_ResetContent( hwndList );
    EnumWindows( EnumWndProc, (LPARAM) hwndList );
    return TRUE;
}



BOOL CALLBACK EnumWndProc( HWND hWnd, LPARAM lParam )
{
    CHAR szBuf[200], szClass[100];	
    DWORD dwID, dwItem;

    GetClassName( hWnd, szClass, 100 );
    dwID = GetWindowLong( hWnd, GWL_ID ); 
    wsprintf( szBuf, "Class='%s',  ID=0x%X,  HWND=0x%X", 
    szClass, dwID, hWnd );

    dwItem = ListBox_AddString( (HWND)lParam, (LPSTR) szBuf );
    ListBox_SetItemData( (HWND)lParam, dwItem, (DWORD) hWnd );
    return TRUE;
}



VOID OnSelChange( HWND hwndList )
{
    CHAR szProcName[MAX_PATH];
    HWND hWnd;
    DWORD dwItem;

    dwItem = ListBox_GetCurSel( hwndList );
    hWnd = (HWND) ListBox_GetItemData( hwndList, dwItem );
    ProcessNameFromWindow( hWnd, szProcName, MAX_PATH );
    SetDlgItemText( GetParent(hwndList), IDC_STATUS,
        szProcName );
}

