/****************************************************\
*
* HELPER.C - main module for VxD HELPER
*
* 01/06/96 SSS Original
*
* PURPOSE : Hooks into VPICD_Virtualize_IRQ 
* service to make sure all interrupts 
* are installed as shareable
*
* TOOLS : You will need VtoolsD 2.02 for 
* Windows 95 to build this VxD 
*
\****************************************************/

/* Disable "modifiers on data are ignored"
 warning from DDK include files */
#pragma warning( disable : 4229 ) 

#define DEVICE_MAIN
#include "helper.h"
#include <vpicd.h> 
#undef DEVICE_MAIN

Declare_Virtual_Device(HELPER)

DefineControlHandler(SYS_CRITICAL_INIT, 
 OnSysCriticalInit);

BOOL __cdecl ControlDispatcher(
 DWORD dwControlMessage,
 DWORD EBX,
 DWORD EDX,
 DWORD ESI,
 DWORD EDI,
 DWORD ECX)
{
 START_CONTROL_DISPATCH

 ON_SYS_CRITICAL_INIT(OnSysCriticalInit);

 END_CONTROL_DISPATCH

 return TRUE;
}

/* Thunk required by VToolsD */
DeviceService_THUNK Thunk_VPICD_Virtualize_Irq;

VOID __stdcall Hook_VPICD_Virtualize_IRQ(
 PDSFRAME pDSFrame)
{
 ((PVID)pDSFrame->REDI)->VID_Options |= 
   VPICD_OPT_CAN_SHARE;
 Call_Previous_Hook_Proc(pDSFrame, 
   &Thunk_VPICD_Virtualize_Irq);
}

BOOL OnSysCriticalInit(VMHANDLE hVM, PCHAR CommandTail, 
 DWORD refData)
{
 Hook_Device_Service( (VPICD_DEVICE_ID << 16) | 
     (__VPICD_Virtualize_IRQ),
   Hook_VPICD_Virtualize_IRQ,
   &Thunk_VPICD_Virtualize_Irq); 
 return TRUE;
}
