Attribute VB_Name = "Defs"
Public Const MAX_PATH = 260

' This type identifies a GUID (globally unique identifier) 
' for an OLE interface.
Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    BData1 As Byte
    BData2 As Byte
    BData3 As Byte
    BData4 As Byte
    BData5 As Byte
    BData6 As Byte
    BData7 As Byte
    BData8 As Byte
End Type

' This type is the VB conversion of a union structure and
' identifies the kind of picture.
Type ICONDESC
    cbSizeOfStruct As Long
    picType As Long
    hIcon As Long
    dummy1 As Long
    dummy2 As Long
End Type

Type ENHMETADESC
    cbSizeOfStruct As Long
    picType As Long
    hEnhMeta As Long
    dummy1 As Long
    dummy2 As Long
End Type

Type BITMAPDESC
    cbSizeOfStruct As Long
    picType As Long
    hBitmap As Long
    hPalette As Long
    dummy1 As Long
End Type

Type METAFILEDESC
    cbSizeOfStruct As Long
    picType As Long
    hMetafile As Long
    cx As Long
    cy As Long
End Type

' Some functions
Declare Function GetWindowLong Lib "user32" _
  Alias "GetWindowLongA" (ByVal hwnd As Long, _
  ByVal nIndex As Long) As Long
Declare Function ExtractIcon Lib "shell32.dll" _
  Alias "ExtractIconA" (ByVal hInst As Long, _
  ByVal lpszExeFileName As String, _
  ByVal nIconIndex As Long) As Long
Declare Function GetWindowsDirectory Lib "kernel32" _
  Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, _
  ByVal nSize As Long) As Long


' These allow to access OLE functionalities.
Declare Function OleInitialize Lib "ole32.dll" (_
   lp As Any) As Long
Declare Function OleCreateIconIndirect Lib "olepro32.dll"_
   Alias "OleCreatePictureIndirect" (_
   picDesc As ICONDESC, iid As GUID, _
   ByVal fOwn As Boolean, iPic As IPictureDisp) As Long
Declare Function OleCreateBitmapIndirect Lib "olepro32.dll" _
   Alias "OleCreatePictureIndirect" (_
   picDesc As BITMAPDESC, iid As GUID, _
   ByVal fOwn As Boolean, iPic As IPictureDisp) As Long
Declare Function OleCreateMetafileIndirect Lib "olepro32.dll" _
   Alias "OleCreatePictureIndirect" (_
   picDesc As METAFILEDESC, iid As GUID, _
   ByVal fOwn As Boolean, iPic As IPictureDisp) As Long
Declare Function OleCreateEnhMetaIndirect Lib "olepro32.dll" _
   Alias "OleCreatePictureIndirect" (_
   picDesc As ENHMETADESC, iid As GUID, _
   ByVal fOwn As Boolean, iPic As IPictureDisp) As Long
Declare Sub OleUninitialize Lib "ole32.dll" ()

' Some needed constants
Public Const GWL_HINSTANCE = (-6)
Public Const PICTYPE_ENHMETAFILE = 4
Public Const PICTYPE_ICON = 3
Public Const PICTYPE_METAFILE = 2
Public Const PICTYPE_BITMAP = 1
