// BitArrVw.cpp : implementation of the CBitArrView class
//

#include "stdafx.h"
#include "BitArr.h"

#include "BitArrDo.h"
#include "BitArrVw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitArrView

IMPLEMENT_DYNCREATE(CBitArrView, CFormView)

BEGIN_MESSAGE_MAP(CBitArrView, CFormView)
	//{{AFX_MSG_MAP(CBitArrView)
	ON_BN_CLICKED(IDC_B_SET_SIZE, OnBSetSize)
	ON_BN_CLICKED(IDC_B_SET_AT, OnBSetAt)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_B_ARRAY_1, IDC_B_ARRAY_32, OnBArray)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_B_SET_RANGE, OnBSetRange)
	ON_BN_CLICKED(IDC_B_SET_AT_GROW, OnBSetAtGrow)
	ON_BN_CLICKED(IDC_B_ADD, OnBAdd)
	ON_BN_CLICKED(IDC_B_COPY, OnBCopy)
	ON_BN_CLICKED(IDC_B_REFRESH_SCREEN_NAMES, OnBRefreshScreenNames)
	ON_BN_CLICKED(IDC_B_APPEND, OnBAppend)
	ON_BN_CLICKED(IDC_B_GO_TO, OnBGoTo)
	ON_BN_CLICKED(IDC_B_SET_SERIALIZE_FILE, OnBSetSerializeFile)
	ON_BN_CLICKED(IDC_B_SAVE, OnBSave)
	ON_BN_CLICKED(IDC_B_RESTORE, OnBRestore)
	ON_BN_CLICKED(IDC_B_FREE_EXTRA, OnBFreeExtra)
	ON_BN_CLICKED(IDC_B_INSERT_AT, OnBInsertAt)
	ON_BN_CLICKED(IDC_B_INSERT_AT2, OnBInsertAt2)
	ON_BN_CLICKED(IDC_B_REMOVE_AT, OnBRemoveAt)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitArrView construction/destruction

CBitArrView::CBitArrView()
	: CFormView(CBitArrView::IDD)
{
	//{{AFX_DATA_INIT(CBitArrView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_nArrayStart = 0;
	m_nFactor = 1;
}

CBitArrView::~CBitArrView()
{
}

void CBitArrView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBitArrView)
	DDX_Control(pDX, IDC_C_OTHER_SCREENS, m_xOtherScreens);
	DDX_Control(pDX, IDC_S_ARRAY_SCROLL, m_xArrayScroll);
	//}}AFX_DATA_MAP
}

BOOL CBitArrView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	cs.style |= WS_CLIPCHILDREN;

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBitArrView printing

BOOL CBitArrView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBitArrView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBitArrView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CBitArrView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CBitArrView diagnostics

#ifdef _DEBUG
void CBitArrView::AssertValid() const
{
	CFormView::AssertValid();
}

void CBitArrView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CBitArrDoc* CBitArrView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBitArrDoc)));
	return (CBitArrDoc*)m_pDocument;
}	
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBitArrView message handlers

void CBitArrView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	SetDlgItemText(IDC_E_SERIALIZE_FILE, "C:\\Temp\\BitArr.Tmp");

	SetDlgItemInt(IDC_E_GROW_BY, -1);

	int	nIndex = 0;
	for (int nID = IDC_B_ARRAY_1; nID <= IDC_B_ARRAY_32; nID++)
	{
		m_xArray[nIndex++].SubclassDlgItem(nID, this);
	}
	m_nArrayStart = 0;
	RefreshArrayView();
}

void CBitArrView::SetButtonNumbers()
{
	int	nIndex = 0;
	CString sStr;

	for (int nArrayIndex=m_nArrayStart; nArrayIndex<m_nArrayStart+32; nArrayIndex++)
	{
		sStr.Format("%d", nArrayIndex);
		m_xArray[nIndex++].SetWindowText(sStr);
	}
}

void CBitArrView::UpdateArrayValues()
{
	for (int nID=IDC_BIT_1; nID<=IDC_BIT_32; nID++)
	{
		GetDlgItem(nID)->SetWindowText(NULL);
	}
	
	nID = IDC_BIT_1;
	for (int nArrayIndex=m_nArrayStart; nArrayIndex<m_nArrayStart+32; nArrayIndex++)
	{
		if (m_baArray.GetSize() <= nArrayIndex)
		{
			break;
		}
		GetDlgItem(nID++)->SetWindowText((m_baArray.GetAt(nArrayIndex))?"1":"0");
	}

	int nVal = m_baArray.GetSize();
	SetDlgItemInt(IDC_E_M_NSIZE, nVal);

#ifdef _DEBUG
	nVal = m_baArray.GetMaxSize();
	SetDlgItemInt(IDC_E_M_NMAXSIZE, nVal);

	nVal = m_baArray.GetGrowBy();
	SetDlgItemInt(IDC_E_M_NGROWBY, nVal);
#endif
}

void CBitArrView::OnBSetSize() 
{
	int	nSize	= GetDlgItemInt(IDC_E_SET_SIZE);
	if (nSize < 0)
	{
		ASSERT(FALSE);
		return;
	}
	int	nGrowBy	= GetDlgItemInt(IDC_E_GROW_BY);
	if (nGrowBy > 0)
	{
		m_baArray.SetSize(nSize, nGrowBy);
	}
	else
	{
		m_baArray.SetSize(nSize);
	}
	RefreshArrayView();
}

void CBitArrView::OnBSetAt() 
{
	BOOL bVal = FALSE;

	int	nIndex = GetDlgItemInt(IDC_E_SET_AT);
	int nID = GetCheckedRadioButton(IDC_R_SET_AT_TRUE, IDC_R_SET_AT_FALSE);
	if (nID == IDC_R_SET_AT_TRUE)
	{
		bVal = TRUE;
	}
	else
	{
		bVal = FALSE;
	}

	m_baArray.SetAt(nIndex, bVal);
	RefreshArrayView();
}

void CBitArrView::OnBSetAtGrow() 
{
	BOOL bVal = FALSE;

	int	nIndex = GetDlgItemInt(IDC_E_SET_AT);
	int nID = GetCheckedRadioButton(IDC_R_SET_AT_TRUE, IDC_R_SET_AT_FALSE);
	if (nID == IDC_R_SET_AT_TRUE)
	{
		bVal = TRUE;
	}
	else
	{
		bVal = FALSE;
	}

	m_baArray.SetAtGrow(nIndex, bVal);
	RefreshArrayView();
}

void CBitArrView::OnBAdd() 
{
	BOOL bVal = FALSE;

	int nID = GetCheckedRadioButton(IDC_R_ADD_TRUE, IDC_R_ADD_FALSE);
	if (nID == IDC_R_ADD_TRUE)
	{
		bVal = TRUE;
	}
	else
	{
		bVal = FALSE;
	}

	m_baArray.Add(bVal);
	RefreshArrayView();
}

void CBitArrView::OnBArray(UINT nID) 
{
    int nIndex = nID - IDC_B_ARRAY_1;
	ASSERT(nIndex >= 0 && nIndex < 32);
	
	int nRadioID = 0;
	int nArrayIndex = m_xArray[nIndex].GetArrayIndex();
	SetDlgItemInt(IDC_E_SET_AT, nArrayIndex);

	BOOL bVal = m_baArray.GetAt(nArrayIndex);

	if (bVal)
	{
		nRadioID = IDC_R_SET_AT_TRUE;
	}
	else
	{
		nRadioID = IDC_R_SET_AT_FALSE;
	}
	CheckRadioButton(IDC_R_SET_AT_TRUE, IDC_R_SET_AT_FALSE, nRadioID);
}

void CBitArrView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar != &m_xArrayScroll)
	{
		CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
		return;
	}

	BOOL bSkip = FALSE;

	switch (nSBCode)
	{
	case SB_LINELEFT:
		m_nArrayStart--;
		break;

	case SB_LINERIGHT:
		m_nArrayStart++;
		break;
	
	case SB_PAGELEFT:
		m_nArrayStart -= 31;
		break;

	case SB_PAGERIGHT:
		m_nArrayStart += 31;
		break;

	case SB_THUMBTRACK:
		m_nArrayStart = nPos * m_nFactor;
		break;

	default:
		bSkip = TRUE;
	}

	if (!bSkip)
	{
		if (m_nArrayStart+2 > m_baArray.GetSize())
		{
			m_nArrayStart = m_baArray.GetSize()-2;
		}
		if (m_nArrayStart < 0)
		{
			m_nArrayStart = 0;
		}
		m_xArrayScroll.SetScrollPos(m_nArrayStart/m_nFactor);
		RefreshArrayView();
	}

	CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CBitArrView::OnBSetRange() 
{
	BOOL bVal = FALSE;

	int	nStartIndex = GetDlgItemInt(IDC_E_START_BIT);
	int	nEndIndex = GetDlgItemInt(IDC_E_END_BIT);
	int nID = GetCheckedRadioButton(IDC_R_SET_RANGE_TRUE, IDC_R_SET_RANGE_FALSE);
	if (nID == IDC_R_SET_RANGE_TRUE)
	{
		bVal = TRUE;
	}
	else
	{
		bVal = FALSE;
	}

	m_baArray.SetRange(nStartIndex, nEndIndex, bVal);
	RefreshArrayView();
}


void CBitArrView::OnBCopy() 
{
	CBitArrView* pSrc = GetSeletedView();
	if (!pSrc)
	{
		return;
	}
	m_baArray.Copy(pSrc->m_baArray);
	RefreshArrayView();
}

void CBitArrView::OnBAppend() 
{
	CBitArrView* pSrc = GetSeletedView();
	if (!pSrc)
	{
		return;
	}
	m_baArray.Append(pSrc->m_baArray);
	RefreshArrayView();
}

void CBitArrView::OnBRefreshScreenNames() 
{
	m_xOtherScreens.ResetContent();
	CString sStr;
	CWnd* pClient = GetParentFrame()->GetParent();
	ASSERT(pClient);

	CWnd* pFrame = pClient->GetWindow(GW_CHILD);
	CWnd* pView;
	while (pFrame)
	{
		pView = pFrame->GetWindow(GW_CHILD);
		ASSERT(pView);
		ASSERT(pView->IsKindOf(RUNTIME_CLASS(CBitArrView)) );
		if (pView != this)
		{
			pFrame->GetWindowText(sStr);
			m_xOtherScreens.AddString(sStr);
		}
		pFrame = (CFrameWnd*)pFrame->GetWindow(GW_HWNDNEXT);
	}
}

CBitArrView* CBitArrView::GetSeletedView()
{
	int nCurSel = m_xOtherScreens.GetCurSel();
	if (CB_ERR == nCurSel)
	{
		MessageBeep(0);
		return NULL;
	}
	CString sComboStr, sStr;
	m_xOtherScreens.GetLBText(nCurSel, sComboStr);

	CWnd* pClient = GetParentFrame()->GetParent();
	ASSERT(pClient);

	CWnd* pFrame = pClient->GetWindow(GW_CHILD);
	CWnd* pView;
	while (pFrame)
	{
		pView = pFrame->GetWindow(GW_CHILD);
		ASSERT(pView);
		ASSERT(pView->IsKindOf(RUNTIME_CLASS(CBitArrView)) );
		if (pView != this)
		{
			pFrame->GetWindowText(sStr);
			if (sStr == sComboStr)
			{
				return (CBitArrView*) pView;;
			}
		}
		pFrame = (CFrameWnd*)pFrame->GetWindow(GW_HWNDNEXT);
		pView = NULL;
	}

	OnBRefreshScreenNames();
	return NULL;
}

void CBitArrView::RefreshArrayView()
{
	SetButtonNumbers();
	UpdateArrayValues();
	int nSize = m_baArray.GetSize();
	m_nFactor = 1;
	while (nSize > 32767)
	{
		m_nFactor = m_nFactor * 2;
		nSize = nSize / 2;
	}
	m_xArrayScroll.SetScrollRange(0, nSize);
	m_xArrayScroll.SetScrollPos(m_nArrayStart/m_nFactor);
}

void CBitArrView::OnBGoTo() 
{
	CBitArrView* pView = GetSeletedView();
	if (!pView)
	{
		return;
	}
	pView->GetParentFrame()->ActivateFrame();
}

void CBitArrView::OnBSetSerializeFile() 
{
}

void CBitArrView::OnBSave() 
{
	CFile	BitFile;
	if (!BitFile.Open("C:\\Temp\\BitArr.Tmp", CFile::modeCreate|CFile::modeReadWrite) )
	{
		ASSERT(FALSE);
		return;
	}

	CArchive ar(&BitFile, CArchive::store);
	
	m_baArray.Serialize(ar);
	
	ar.Close();
	BitFile.Close();
}

void CBitArrView::OnBRestore() 
{
	CFile	BitFile;
	if (!BitFile.Open("C:\\Temp\\BitArr.Tmp", CFile::modeRead) )
	{
		ASSERT(FALSE);
		return;
	}

	CArchive ar(&BitFile, CArchive::load);
	
	m_baArray.Serialize(ar);
	
	ar.Close();
	BitFile.Close();
	RefreshArrayView();
}

void CBitArrView::OnBFreeExtra() 
{
	m_baArray.FreeExtra();
	RefreshArrayView();
}

void CBitArrView::OnBInsertAt() 
{
	BOOL bVal = FALSE;

	int	nIndex = GetDlgItemInt(IDC_E_INSERT_AT);
	int nID = GetCheckedRadioButton(IDC_R_INSERT_AT_TRUE, IDC_R_INSERT_AT_FALSE);
	if (nID == IDC_R_INSERT_AT_TRUE)
	{
		bVal = TRUE;
	}
	else
	{
		bVal = FALSE;
	}

	int	nCount = 1;
	if (GetDlgItem(IDC_E_INSERT_AT_COUNT)->GetWindowTextLength())
	{
		nCount = GetDlgItemInt(IDC_E_INSERT_AT_COUNT);
	}
	m_baArray.InsertAt(nIndex, bVal, nCount);
	RefreshArrayView();
}


void CBitArrView::OnBInsertAt2() 
{
	CBitArrView* pSrc = GetSeletedView();
	if (!pSrc)
	{
		return;
	}
	int nIndex = GetDlgItemInt(IDC_E_INSERT_AT2);
	m_baArray.InsertAt(nIndex, &pSrc->m_baArray);
	RefreshArrayView();
}

void CBitArrView::OnBRemoveAt() 
{
	int	nIndex = GetDlgItemInt(IDC_E_INSERT_AT);
	int	nCount = 1;
	if (GetDlgItem(IDC_E_INSERT_AT_COUNT)->GetWindowTextLength())
	{
		nCount = GetDlgItemInt(IDC_E_INSERT_AT_COUNT);
	}
	m_baArray.RemoveAt(nIndex, nCount);
	RefreshArrayView();
}
