//////////////////////////////////////////////////////////////////////////
//
// AutoEdit.cpp: Implementation of CAutoFocusEdit Class
//
// Auto Focus Edit Control
//
// History:
//
// Release 1.0       Original Release                      Jul 1997
//
// Written by Thierry G. Marneffe
//
//////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AutoEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////
//
// CAutoFocusEdit::CAutoFocusEdit()
//
// Param: None
//
// Purpose: Default Constructor
//
// Return Value: None
//
// History:
//
//   Date     Comment                                   Initials
//
//  19/07/97  Created                                     TGM
//
//////////////////////////////////////////////////////////////////////////

CAutoFocusEdit::CAutoFocusEdit()
{

    // Init Member

    m_bMouseInside = FALSE;
}


//////////////////////////////////////////////////////////////////////////
//
// CAutoFocusEdit::~CAutoFocusEdit()
//
// Param: None
//
// Purpose: Default Destructor
//
// Return Value: None
//
// History:
//
//   Date     Comment                                   Initials
//
//  19/07/97  Created                                     TGM
//
//////////////////////////////////////////////////////////////////////////

CAutoFocusEdit::~CAutoFocusEdit()
{
}

BEGIN_MESSAGE_MAP(CAutoFocusEdit, CEdit)
	//{{AFX_MSG_MAP(CAutoFocusEdit)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillfocus)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////////
//
// void CAutoFocusEdit::OnKillfocus()
//
// Param: None
//
// Purpose: Reset Flag for Mouse Inside Control on Focus Loss
//
// Return Value: void 
//
// History:
//
//   Date     Comment                                   Initials
//
//  19/07/97  Created                                     TGM
//
//////////////////////////////////////////////////////////////////////////

void CAutoFocusEdit::OnKillfocus() 
{

    m_bMouseInside = FALSE;
	
}

//////////////////////////////////////////////////////////////////////////
//
// void CAutoFocusEdit::OnMouseMove(UINT nFlags, CPoint point)
//
// Param: 
//     - UINT nFlags:
//     - CPoint point:
//
// Purpose: Set Focus and Select all Edit Text ( if any) on First Mouse 
//          Move inside the Edit Control
//
// Return Value: void 
//
// History:
//
//   Date     Comment                                   Initials
//
//  19/07/97  Created                                     TGM
//
//////////////////////////////////////////////////////////////////////////

void CAutoFocusEdit::OnMouseMove(UINT nFlags, CPoint point) 
{

    // Check if First Time Inside Control

    if ( m_bMouseInside == FALSE)
    {
        // Update Flag

        m_bMouseInside = TRUE;
    
        // Set Focus to Edit Control

        SetFocus();

        // Select All Edit Text

        SetSel( 0, -1, FALSE );
    }
	
	CEdit::OnMouseMove(nFlags, point);
}
