// testgame.c - Win32 Console program to test GAMEPORT.SYS

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
//#include <winioctl.h>
#include "gameport.h"

//-----------------------------------------------------------------
VOID main(IN int argc, IN char *argv[])
{
    HANDLE hDevice;
    BOOL ret;
    BYTE data, buttonMask, positionMask;

    //
    // Get a handle to the game port device driver.
    //
   
    hDevice = CreateFile(GAMEPORT_WIN32_NAME, GENERIC_READ | 
                         GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 
                         FILE_ATTRIBUTE_NORMAL, NULL);
 
    if (hDevice == INVALID_HANDLE_VALUE) {
        printf("Error opening device (%d)\n", GetLastError());
        return;
    } else {
        printf("CreateFile succeeded\n");
    }

    //
    // Read a byte of data from the game port driver.
    //

    if (ReadFile(hDevice, &data, 1, &ret, NULL)) {

        data &= 0xf0;      // mask high four bits
        data ^= 0xf0;      // invert the bit sense

        printf("Joystick A, Button 1 = %s\n", 
               (data & 0x10) ? "PRESSED" : "OFF");
	printf("Joystick A, Button 2 = %s\n", 
               (data & 0x20) ? "PRESSED" : "OFF");
	printf("Joystick B, Button 1 = %s\n", 
               (data & 0x40) ? "PRESSED" : "OFF");
	printf("Joystick B, Button 2 = %s\n", 
               (data & 0x80) ? "PRESSED" : "OFF");
    } else {
        printf("DeviceIoContrl error (%d)\n", GetLastError());
    }

    CloseHandle(hDevice);

} // main
