// betterlv.h

class CBetterLVC : public CListCtrl
{
public:
    BOOL SelectAll(BOOL bSelect = TRUE)
    {
        // To select all items we must pass a LV_ITEM because MFC
        // SetItemState(nItem, nState, nMask) internally calls
        // SetItem method instead of sending a LVM_SETITEMSTATE
        // message
        // Note -1 to indicate ALL
        LV_ITEM item;

        item.mask = LVIF_STATE;
        item.iItem = -1;
        item.stateMask = LVIS_SELECTED;
        // Select or deselect ? That is the question!
        item.state = bSelect ? LVIS_SELECTED : 0;
        return SetItemState(-1, &item);
    }

    void AutoSizeColumn(int nColumn)
    {
        SetColumnWidth(nColumn, LVSCW_AUTOSIZE);
    } 

    CHeaderCtrl* GetHeader()
    {
        static const int nMaxChar =
                            sizeof(WC_HEADER) / sizeof(TCHAR);
        HWND hWnd = ::GetWindow(m_hWnd, GW_CHILD);
        TCHAR szName[nMaxChar]; // room for null terminating char

        // Normally LVC has only 1 child (Header control) but
        // this code works if this isn't true

        // Find only windows registered with WC_HEADER class name
        for(; hWnd; hWnd = ::GetWindow(hWnd, GW_HWNDNEXT)) {
            ::GetClassName(hWnd, szName, nMaxChar);
            if (!lstrcmp(WC_HEADER, szName))
                return (CHeaderCtrl* )CWnd::FromHandle(hWnd);
        }

        return NULL;
    }

    CHeaderCtrl* GetHeaderFast()
    {
        return (CHeaderCtrl* )GetWindow(GW_CHILD);
    }

    int GetColumnCount()
    {
        CHeaderCtrl* pWnd = GetHeader();
        return pWnd ? pWnd->GetItemCount() : -1;
    }
};
