//
// Listing 2 - Display.cpp
//
// This code is companion code to the program shown
// in May98.cpp.  The two routines simply print all
// of the strings in a given container.  Due to problems
// with Microsoft's run time environment, attempting to
// print the contents of the set causes a crash.
//
// For details on how to build and use this program,
// see the internal documentation for May98.cpp
//

#include <vector>
#include <set>
#include <string>
#include <iostream>

using namespace std;

#pragma warning( disable : 4786 )

__declspec( dllexport )
int DisplaySetDll( const set< string > &s )
{
    cout << "\nListing set from DLL: ";
    set<string>::const_iterator ii = s.begin();
	while ( ii != s.end() ) {
		cout << *ii << "  ";
                ii++;
        }
        cout << "\n\n";
	return 1;
}

__declspec( dllexport )
int DisplayVectorDll( const vector < string > &s )
{
    cout << "\nListing vector from DLL: ";
    vector<string>::const_iterator ii = s.begin();
	while ( ii != s.end() ) {
		cout << *ii << "  ";
                ii++;
        }
        cout << "\n\n";
	return 1;
}

//EOF
